<?php

/**
 * log.php
 * 
 * Copyright (c) 1999-2003 The Owl Project Team
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 * 
 * $Id: log.php,v 1.5 2003/11/12 14:26:02 b0zz Exp $
 */

global $default, $whereclause;

//require_once("../config/owl.php");
require_once(_SYSCOMMONROOT . "/lib/disp.lib.php");
require_once(_SYSCOMMONROOT . "/lib/owl.lib.php");
include_once(_SYSCOMMONROOT . "/lib/header.inc");
include_once(_SYSCOMMONROOT . "/lib/userheader.inc");

if (!isset($nextrecord)) $nextrecord = 0;
if (!isset($next)) $next = 0;
if (!isset($prev)) $prev = 0;
if (!isset($hideagent)) $hideagent = 0;
if (isset($fa)) $filteraction = unserialize(stripslashes($fa));
if (!isset($hidedetail)) $hidedetail = 0;

if ($next == 1) $nextrecord = $nextrecord + $default->log_rec_per_page;
if ($prev == 1)
{
   $nextrecord = $nextrecord - $default->log_rec_per_page;
   if ($nextrecord < 0)
   {
      $nextrecord = 0;
   } 
} 

$whereclause = " where 1=1";

if ($filteraction && $filteraction[0] != "0")
{
   $whereclause .= " and (";
   foreach($filteraction as $fa)
   {
      $whereclause .= " action='$fa' or";
   } 
   $whereclause .= " action='$fa')";
} 

if ($filteruser && $filteruser != "0")
{
   $whereclause .= " and userid='$filteruser'";
} 

print("<CENTER>");

if ($usergroupid != "0") die("$owl_lang->err_unauthorized");

if ($action == "clear_log")
{
   $sql = new Owl_DB;
   $sql->query("DELETE from $default->owl_log_table");
} 

print("<H1> $owl_lang->owl_log_viewer</H1>\n");
print("<TABLE WIDTH='$default->table_expand_width' BGCOLOR='$default->main_header_bgcolor' CELLSPACING='0' CELLPADDING='0' BORDER='$default->table_border' HEIGHT='30'>\n");
print("<TR>\n<TD WIDTH=200 VALIGN=TOP>");
print("<TR>\n");
print("<TD ALIGN=LEFT WIDTH=33%>");
print uid_to_name($userid);
print(" : ");
fPrintButton("../index.php?login=logout&sess=$sess", "btn_logout");
print("</TD>\n");
print("<TD ALIGN=CENTER WIDTH=33%> $owl_lang->owl_admin</TD>\n");
print("<TD ALIGN=RIGHT WIDTH=33%>");
fPrintButton("../browse.php?sess=$sess", "btn_browse");
print("</TD>\n");
print("</TR>\n");
print("</TABLE>\n");
print("<HR WIDTH=$default->table_expand_width><BR>\n"); 
// print the column headers
print("<TABLE WIDTH='$default->table_expand_width' BGCOLOR='$default->main_header_bgcolor' CELLSPACING='0' CELLPADDING='0' BORDER='$default->table_border' HEIGHT='30'>\n");
print("<TR BGCOLOR='$default->table_header_bg' height='25'>\n");
print("<TD align=left><font size=4>$owl_lang->owl_log_hd_action</font></TD>\n");
print("<TD align=left><font size=4>$owl_lang->owl_log_hd_file</font></TD>\n");
print("<TD align=left><font size=4>$owl_lang->owl_log_hd_fld_path</font></TD>\n");
print("<TD align=left><font size=4>$owl_lang->owl_log_hd_user</font></TD>\n");
print("<TD align=left><font size=4>$owl_lang->owl_log_hd_dt_tm</font></TD>\n");
print("<TD align=left><font size=4>$owl_lang->owl_log_hd_ip</font></TD>\n");
if ($hideagent == 1)
   print("<TD align=left><font size=4>&nbsp;</font></TD>\n");
else
   print("<TD align=left><font size=4>$owl_lang->owl_log_hd_agent</font></TD>\n");
if ($hidedetail == 1)
   print("<TD align=left><font size=4>&nbsp;</font></TD>\n");
else
   print("<TD align=left><font size=4>$owl_lang->owl_log_hd_dtls</font></TD>\n");

print("</TR>\n");
print("<TR>\n<TD colspan=8 align=center BGCOLOR=$default->body_bgcolor><H3>&nbsp;</H3></TD>\n</TR>\n"); 
// print the LOG Details
$CountLines = 0;
$sql = new Owl_DB;
$getusers = new Owl_DB; 
// Found out how many records we are going to retreive
$sql->query("select * from $default->owl_log_table $whereclause");
$recordcount = $sql->num_rows($sql); 

// Retreive the log records for display
if ($recordcount == 0)
{
   print("<TR BGCOLOR='$default->body_bgcolor'>\n<TD colspan=8 align=center><H2>$owl_lang->owl_log_no_rec</H2></TD>\n</TR>\n");
   print("<TR BGCOLOR='$default->body_bgcolor'>\n<TD colspan=8 align=center><H2>&nbsp;</H2></TD>\n</TR>\n");
} 
else
{
   $sql->query("select * from $default->owl_log_table $whereclause order by logdate DESC LIMIT $nextrecord,$default->log_rec_per_page");
   while ($sql->next_record())
   {
      $CountLines++;
      $PrintLines = $CountLines % 2;
      if ($PrintLines == 0)
         print("<TR BGCOLOR='$default->table_cell_bg_alt'>\n");
      else
         print("<TR BGCOLOR='$default->table_cell_bg'>\n");

      print("<TD align=left><font color=green><B>&lsaquo;" . $log_file_actions[$sql->f("action")] . "></B></font></TD>\n");
      if ($sql->f("type") != "LOGIN")
      {
         print("<TD align=left>" . $sql->f("filename") . "</TD>\n");
         print("<TD align=left>" . get_dirpath($sql->f("parent")) . "</TD>\n");
      } 
      else
      {
         print("<TD align=left>&nbsp;</TD>\n");
         print("<TD align=left>&nbsp;</TD>\n");
      } 
      print("<TD align=left>" . uid_to_name($sql->f("userid")) . "</TD>\n");
      print("<TD align=left>" . date($owl_lang->localized_date_format, strtotime($sql->f("logdate"))) . "</TD>\n");
      print("<TD align=left>" . gethostbyaddr($sql->f('ip')) . "</TD>\n");
      if ($hideagent == 1)
         print("<TD align=left>&nbsp;</TD>\n");
      else
         print("<TD align=left>" . $sql->f("agent") . "</TD>\n");
      if ($hidedetail == 1)
         print("<TD align=left>&nbsp;</TD>\n");
      else
         print("<TD>" . $sql->f("details") . "</TD>\n");
      print ("</TR>\n");
   } 
   print("<TR>\n<TD colspan=8 align=center BGCOLOR=$default->body_bgcolor><H2>&nbsp;</H2></TD>\n</TR>\n");
} 
print("</TABLE>"); 
// print out the filters
$logactions[0][1] = "$owl_lang->log_filter_all";
$logactions[1][1] = $log_file_actions[LOGIN];
$logactions[2][1] = $log_file_actions[LOGIN_FAILED];
$logactions[3][1] = $log_file_actions[LOGOUT];
$logactions[4][1] = $log_file_actions[FILE_DELETED];
$logactions[5][1] = $log_file_actions[FILE_UPLOAD];
$logactions[6][1] = $log_file_actions[FILE_UPDATED];
$logactions[7][1] = $log_file_actions[FILE_DOWNLOADED];
$logactions[8][1] = $log_file_actions[FILE_CHANGED];
$logactions[9][1] = $log_file_actions[FILE_LOCKED];
$logactions[10][1] = $log_file_actions[FILE_UNLOCKED];
$logactions[11][1] = $log_file_actions[FILE_EMAILED];
$logactions[12][1] = $log_file_actions[FILE_MOVED];
$logactions[13][1] = $log_file_actions[FOLDER_CREATED];
$logactions[14][1] = $log_file_actions[FOLDER_DELETED];
$logactions[15][1] = $log_file_actions[FOLDER_MODIFIED];
$logactions[16][1] = $log_file_actions[FOLDER_MOVED];
$logactions[17][1] = $log_file_actions[FORGOT_PASS];
$logactions[18][1] = $log_file_actions[USER_REG];

print("<FORM enctype='multipart/form-data' ACTION='log.php' METHOD=POST>
                        <INPUT TYPE=HIDDEN NAME=sess VALUE='$sess'>
                        <INPUT TYPE=HIDDEN NAME=action VALUE=refresh>
                        <INPUT TYPE=HIDDEN NAME=id VALUE='$id'>
                        <INPUT TYPE=HIDDEN NAME=whereclause VALUE='$whereclause'>");
print("<INPUT TYPE=HIDDEN NAME=expand VALUE='$expand'>\n");
print("<TABLE BORDER=$default->table_border>\n<TR>\n<TD ALIGN='RIGHT' bgcolor='$default->table_header_bg'>$owl_lang->owl_log_filter:</TD>\n<TD align=left>");

print("$owl_lang->owl_log_hd_action: <SELECT size=8 NAME=filteraction[] multiple>");
$i = 0;
foreach($logactions as $fp)
{
   $isSelected = false;
   if ($filteraction[0] != "")
   {
      foreach($filteraction as $fa)
      {
         if ($fa == $i)
            $isSelected = true;
      } 
   } 
   print("<OPTION VALUE='$i' ");
   if ($isSelected)
      print("SELECTED");
   print(">$fp[1]");
   $i++;
} 
print("</SELECT>\n</TD>\n"); 
// Print Users
$getusers->query("select name,username,id from $default->owl_users_table order by name");

print("<td>$owl_lang->owl_log_hd_user:<select name=filteruser>");

print("<option value=0>$owl_lang->log_filter_all</option>");
while ($getusers->next_record())
{
   $uid = $getusers->f("id");
   $name = $getusers->f("name");
   $username = $getusers->f("username");

   if ($name == "")
      print("<option value=" . $uid . ">" . $username . "</option>");
   else
   if ($uid == $filteruser)
      print("<option value=" . $uid . " SELECTED> " . $name . "</option>");
   else
      print("<option value=" . $uid . " >" . $name . "</option>");
} 
print("</select></TD>\n</TR>\n"); 
// print Hide columns
print("<TR>\n<TD BGCOLOR='$default->table_header_bg' align='right'>$owl_lang->owl_log_hide</TD>\n");
if ($hideagent == 1)
   print("<TD align=left>$owl_lang->owl_log_hd_agent:<INPUT TYPE=CHECKBOX NAME=hideagent VALUE=1 checked></TD>\n");
else
   print("<TD align=left>$owl_lang->owl_log_hd_agent:<INPUT TYPE=CHECKBOX NAME=hideagent VALUE=1 ></TD>\n");
if ($hidedetail == 1)
   print("<TD align=left>$owl_lang->owl_log_hd_dtls:<INPUT TYPE=CHECKBOX NAME=hidedetail VALUE=1 checked></TD>\n");
else
   print("<TD align=left>$owl_lang->owl_log_hd_dtls:<INPUT TYPE=CHECKBOX NAME=hidedetail VALUE=1 ></TD>\n");
print("</TR>\n");

print("<TR>\n<TD>\n");
print("<INPUT TYPE=IMAGE NAME='$owl_lang->owl_log_filter' SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_buttons/btn_refresh.gif' BORDER=0 ALT='$owl_lang->alt_refresh_filter' TITLE='$owl_lang->alt_refresh_filter'  onMouseOver=this.src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_buttons/btn_refresh_hover.gif'; onMouseOut=this.src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_buttons/btn_refresh.gif'; VALUE='$owl_lang->owl_log_filter'>\n");
print("<TD>\n</TR>\n</TABLE>\n</FORM>\n"); 
// print Footer with Record Count and PREV TOP NEXT
print("<TABLE WIDTH='$default->table_expand_width' BGCOLOR='$default->main_header_bgcolor' CELLSPACING='0' CELLPADDING='0' BORDER='$default->table_border' HEIGHT='30'>\n");
print("<TR BGCOLOR='$default->table_header_bg'>\n");
print("<TD align=left height=30><font size=4>&nbsp;</font></TD>\n");
$fa = serialize($filteraction);
print("<TD align=right width=5%><A HREF='log.php?sess=$sess&prev=1&nextrecord=$nextrecord&fa=$fa&filteruser=$filteruser&hideagent=$hideagent&hidedetail=$hidedetail'><IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_nav/prev.gif' BORDER=0 ALT='$owl_lang->alt_log_prev' TITLE='$owl_lang->alt_log_prev'></A></TD>\n");
print("<TD align=center width=5%><A HREF='log.php?sess=$sess&next=0&nextrecord=0&fa=$fa&filteruser=$filteruser&hideagent=$hideagent&hidedetail=$hidedetail'><IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_nav/top.gif' BORDER=0 ALT='$owl_lang->alt_log_top' TITLE='$owl_lang->alt_log_top'></A></TD>\n");
$from = $nextrecord + 1;
if ($recordcount == 0)
   $from = $recordcount;
$to = $nextrecord + $default->log_rec_per_page;
if ($to > $recordcount)
   $to = $recordcount;
if ($to < $recordcount)
{
   print("<TD align=left width=5%><A HREF='log.php?sess=$sess&next=1&nextrecord=$nextrecord&fa=$fa&filteruser=$filteruser&hideagent=$hideagent&hidedetail=$hidedetail'><IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_nav/next.gif' BORDER=0 ALT='$owl_lang->alt_log_next' TITLE='$owl_lang->alt_log_next'></A></TD>\n");
} 
else
{
   print("<TD align=left width=5%><IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/transparent.gif' BORDER=0></TD>\n");
} 
print("<TD align=left width=5%><A HREF='log.php?sess=$sess&action=clear_log' onClick='return confirm(\"$owl_lang->reallydelete_logs ?\");'><IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/delete.gif' BORDER=0 ALT='$owl_lang->alt_log_clear' TITLE='$owl_lang->alt_log_clear'></A></TD>\n");

print("<TD align=center height=30 width=20%><font size=4>($from to $to) of $recordcount</font></TD>\n");
print ("</TR>");
print("</TABLE>");

if (owlusergroup($userid) == 0)
{
   print("<BR>");
   print("<BR>");
   fPrintButton("$default->owl_root_url/admin/index.php?sess=$sess", "btn_admin");
   print("<BR>");
   print("<BR>");
} 

if (file_exists(_SYSCOMMONROOT . "/lib/footer.inc")) 
{
   include(_SYSCOMMONROOT . "/lib/footer.inc");
} 
else 
{
   include(_SYSCOMMONROOT . "/lib/footer.inc");
}
?>
