<?php

/**
 * news.php
 * 
 * Copyright (c) 1999-2003 The Owl Project Team
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 */

global $default;

//require_once("../config/owl.php");
require_once(_SYSCOMMONROOT . "/lib/disp.lib.php");
require_once(_SYSCOMMONROOT . "/lib/owl.lib.php");
include_once(_SYSCOMMONROOT . "/lib/header.inc");
include_once(_SYSCOMMONROOT . "/lib/userheader.inc");

print("<CENTER>");

if ($usergroupid != "0" && !fIsNewsAdmin($userid)) die("$owl_lang->err_unauthorized");

$sql = new Owl_DB;
if (!isset($nid))
{
   $nid = 0;
}
if (fIsNewsAdmin($userid))
{
   $sql->query("SELECT g.id, g.name from $default->owl_users_table as u, $default->owl_groups_table as g where u.groupid = g.id and u.id = '$userid';");
   $sql->next_record();
   $iPrimaryGroup = $sql->f("id");
   $groups[0][0] = $sql->f("id");
   $groups[0][1] = $sql->f("name");

   $sql->query("SELECT m.groupid, g.name from $default->owl_users_grpmem_table as m, $default->owl_groups_table as g where m.userid = '$userid' and m.groupid = g.id");
   $i = 1;
   while ($sql->next_record())
   {
      if (!($sql->f("groupid") == $iPrimaryGroup))
      {
         $groups[$i][0] = $sql->f("groupid");
         $groups[$i][1] = $sql->f("name");
         $i++;
      } 
   } 
} 
else
{
   $sql->query("SELECT id,name from $default->owl_groups_table order by name");
   $i = 0;
   while ($sql->next_record())
   {
      $groups[$i][0] = $sql->f("id");
      $groups[$i][1] = $sql->f("name");
      $i++;
   } 
} 

if ($action == "del_news")
{
   $del = new Owl_DB;
   $del->query("delete from $default->owl_news_table where id = '$nid'");
   $nid = 0;
} 

print("<H1>$owl_lang->news_title</H1>");
print("<TABLE WIDTH='$default->table_expand_width' BGCOLOR='$default->main_header_bgcolor' CELLSPACING='0' CELLPADDING='0' BORDER='$default->table_border' HEIGHT='30'>");
print("<TR><TD WIDTH=200 VALIGN=TOP>");
print("<TR>");
print("<TD ALIGN=LEFT WIDTH=33%>");
print uid_to_name($userid);
print(" : ");
fPrintButton("../index.php?login=logout&sess=$sess", "btn_logout");
print("</A></TD>");

print("<TD ALIGN=CENTER WIDTH=33%> $owl_lang->owl_admin</TD>");
print("<TD ALIGN=RIGHT WIDTH=33%>");
fPrintButton("../browse.php?sess=$sess", "btn_browse");
print("</TD>");
print("</TR>\n");
print("</TABLE>\n");
print("<HR WIDTH=$default->table_expand_width>\n");
print("<TABLE WIDTH='$default->table_expand_width' BGCOLOR='$default->main_header_bgcolor' CELLSPACING='0' CELLPADDING='0' BORDER='$default->table_border'>\n");

if ($action == "edit_news")
{
   if ($change == 1)
      print("<TR><TD colspan=6 align=center BGCOLOR=$default->body_bgcolor>$owl_lang->saved</TD></TR>");
   $edit = new Owl_DB;
   $edit->query("SELECT * from $default->owl_news_table where id = '$nid'");
   $edit->next_record();
   print("<FORM enctype='multipart/form-data' ACTION='admin_dbmodify.php' METHOD=POST>\n");
   print("<INPUT TYPE=HIDDEN NAME=nid VALUE=" . $edit->f("id") . ">\n");
   print("<INPUT TYPE=HIDDEN NAME=action VALUE='edit_news'>\n");
   print("<INPUT TYPE=HIDDEN NAME=sess VALUE='$sess'>\n");
   print("<TR BGCOLOR='$default->body_bgcolor'>");
   print("<TD align=left valign=top>&nbsp;</TD>");

   print("<TD align=left valign=top>&nbsp;</TD>");
   print("<TD align=left valign=top>$owl_lang->news_heading<BR /><INPUT TYPE=text NAME=news_title SIZE=50 VALUE='" . $edit->f("news_title") . "'><BR />$owl_lang->news_content<BR /><textarea name=newsdesc rows=5 cols=60>" . $edit->f("news") . "</textarea><BR />$owl_lang->news_hd_expires<BR />");
   fPrintDatePicker($edit->f("news_end_date"));
   print("<BR />$owl_lang->news_hd_audience<BR />");
   print("<SELECT NAME=audience>");
   if ($usergroupid == "0")
   {
      print("<OPTION VALUE='-1'>$owl_lang->log_filter_all\n");
   } 
   foreach($groups as $g)
   {
      print("<OPTION VALUE=$g[0] ");
      if ($g[0] == $edit->f("gid"))
         print("SELECTED");
      print(">$g[1]");
   } 
   print("</SELECT>");
   print("<BR />$owl_lang->news_hd_created:  " . date($owl_lang->localized_date_format, strtotime($edit->f("news_date"))) . "</TD>");
   print("</TD>");
   print("<TD colspan=3 ></TD>");
   print("</TR>");
   print("<TR><TD colspan=6 align=center BGCOLOR=$default->body_bgcolor>&nbsp;</TD></TR>");
   print("<TR><TD BGCOLOR=$default->body_bgcolor>&nbsp;</TD><TD colspan=5 align=left BGCOLOR=$default->body_bgcolor><input type=image name=btn_ed_news  SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_buttons/btn_change.gif' BORDER=0 ALT='$owl_lang->alt_change' TITLE='$owl_lang->alt_change'>&nbsp;&nbsp;<input type=image name=btn_cancel_news SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_buttons/btn_cancel.gif' BORDER=0 ALT='$owl_lang->alt_cancel' TITLE='$owl_lang->alt_cancel'></TD></TR>");
   print("<TR><TD colspan=6 align=center BGCOLOR=$default->body_bgcolor>&nbsp;</TD></TR>");
   print("</FORM>");
} 
else
{
   if ($change == 1)
      print("<TR><TD colspan=6 align=center BGCOLOR=$default->body_bgcolor>$owl_lang->saved</TD></TR>");
   $edit = new Owl_DB;
   $edit->query("SELECT * from $default->owl_news_table where id = '$nid'");
   $edit->next_record();
   print("<FORM enctype='multipart/form-data' ACTION='admin_dbmodify.php' METHOD=POST>\n");
   print("<INPUT TYPE=HIDDEN NAME=nid VALUE=" . $edit->f("id") . ">\n");
   print("<INPUT TYPE=HIDDEN NAME=action VALUE='add_news'>\n");
   print("<INPUT TYPE=HIDDEN NAME=sess VALUE='$sess'>\n");
   print("<TR BGCOLOR='$default->body_bgcolor'>");
   print("<TD align=left valign=top>&nbsp;</TD>");
   print("<TD align=left valign=top>&nbsp;</TD>");
   print("<TD align=left valign=top>$owl_lang->news_heading<BR /><INPUT TYPE=text NAME=news_title SIZE=50 VALUE='" . $edit->f("news_title") . "'><BR />$owl_lang->news_content<BR /><textarea name=newsdesc rows=5 cols=50 wrap=hard>" . $edit->f("news") . "</textarea><BR />$owl_lang->news_hd_expires<BR />");
   fPrintDatePicker();
   print("<BR />$owl_lang->news_hd_audience<BR />");
   print("<SELECT NAME=audience>");
   if ($usergroupid == "0")
   {
      print("<OPTION VALUE='-1'>$owl_lang->log_filter_all\n");
   } 
   foreach($groups as $g)
   {
      print("<OPTION VALUE=$g[0] ");
      if ($g[0] == $edit->f("gid"))
         print("SELECTED");
      print(">$g[1]");
   } 
   print("</SELECT>");
   print("</TD>");
   print("<TD colspan=3></TD>");
   print("</TR>");
   print("<TR><TD colspan=6 align=center BGCOLOR=$default->body_bgcolor>&nbsp;</TD></TR>");
   print("<TR><TD BGCOLOR=$default->body_bgcolor>&nbsp;</TD><TD colspan=5 align=left BGCOLOR=$default->body_bgcolor>");
   print("<INPUT TYPE=IMAGE  NAME=btn_add_news SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_buttons/btn_add_news.gif' BORDER=0 ALT='$owl_lang->alt_add_news' TITLE='$owl_lang->alt_add_news' onMouseOver=this.src='$default->owl_graphics_url/$language/graphics/$default->sButtonStyle/ui_buttons/btn_add_news_hover.gif'; onMouseOut=this.src='$default->owl_graphics_url/$language/graphics/$default->sButtonStyle/ui_buttons/btn_add_news.gif';>\n");
   print("</TD></TR>");
   print("<TR><TD colspan=6 align=center BGCOLOR=$default->body_bgcolor>&nbsp;</TD></TR>");
   print("</FORM>");
} 
print("<TR BGCOLOR='$default->table_header_bg'>");
print("<TD align=left><font size=3>&nbsp;</font></TD>");
print("<TD align=left><font size=3></font></TD>");
print("<TD align=left><font size=3>$owl_lang->news_hd</font></TD>");
print("<TD align=left><font size=3>$owl_lang->news_hd_created</font></TD>");
print("<TD align=left><font size=3>$owl_lang->news_hd_expires</font></TD>");
print("<TD align=left><font size=3>$owl_lang->news_hd_audience</font></TD>");
print("</TR>");

$dbCountRead = new Owl_DB;
$dbGetUser = new Owl_DB;

$sWhereClause = "";
if (fIsNewsAdmin($userid))
{
   $sWhereClause = "where ";
   foreach($groups as $g)
   {
      $sWhereClause .= " gid = '$g[0]' or";
   } 
   $sWhereClause .= " 0 = 1";
} 

$sql->query("SELECT * from $default->owl_news_table $sWhereClause order by id desc");
while ($sql->next_record())
{
   $iNewsGid = $sql->f("gid");
   $iNewsId = $sql->f("id"); 
   // 
   // Get the number of Users that have Read this
   // 
   $dbCountRead->query("SELECT distinct username,name,id,maxsessions,u.groupid from $default->owl_users_table as u left join $default->owl_users_grpmem_table as m on u.id=m.userid where u.groupid='$iNewsGid' or m.groupid='$iNewsGid' order by name;");
   $iCountRead = 0;
   $iCountTotalUser = 0;
   while ($dbCountRead->next_record())
   {
      $dbGetUser->query("SELECT lastnews from users where id ='" . $dbCountRead->f("id") . "' and disabled ='0'");
      $dbGetUser->next_record();
      if ($dbGetUser->f("lastnews") >= $iNewsId)
      {
         $iCountRead++;
      } 
      $iCountTotalUser++;
   } 
   if ($iCountTotalUser == 0)
   {
      $iCountTotalUser = 0;
      $dbCountRead->query("SELECT id,lastnews from $default->owl_users_table where disabled = '0'");
      while ($dbCountRead->next_record())
      {
         if ($dbCountRead->f("lastnews") >= $iNewsId)
         {
            $iCountRead++;
         } 
         $iCountTotalUser++;
      } 
   } 

   $CountLines++;
   $PrintLines = $CountLines % 2;
   if ($PrintLines == 0)
      print("<TR BGCOLOR='$default->table_cell_bg_alt'>");
   else
      print("<TR BGCOLOR='$default->table_cell_bg'>");
   print("<TD align=left valign=top nowrap>");
   print("<BR><A HREF='news.php?&sess=" . $sess . "&action=edit_news&nid=" . $sql->f("id") . "'><IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/icon_action/edit.gif' ALT='$owl_lang->alt_edit_news' TITLE='$owl_lang->alt_edit_news' BORDER=0></A>");
   print("<BR><A HREF='news.php?&sess=" . $sess . "&action=del_news&nid=" . $sql->f("id") . "' onClick='return confirm(\"$owl_lang->reallydelete " . $sql->f("news_title") . " ?\");'><IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/delete.gif' ALT='$owl_lang->alt_del_news' TITLE='$owl_lang->alt_del_news' BORDER=0></A>");
   print("<BR>$owl_lang->news_read:(" . $iCountRead . " / " . $iCountTotalUser . ")");
   print("</TD>");

   print("<TD align=left valign=top><BR />&nbsp;</TD>");
   print("<TD align=left valign=top><BR />");
   print("<h4>" . $sql->f("news_title") . "</h4>\n");
   print(ereg_replace("\n", '<BR>', $sql->f("news")) . "</TD>");
   print("<TD align=left valign=top><BR />" . date($owl_lang->localized_date_format, strtotime($sql->f("news_date"))) . "</TD>");
   print("<TD align=left valign=top><BR />" . date($owl_lang->localized_date_format, strtotime($sql->f("news_end_date"))) . "</TD>");
   print("<TD align=center valign=top><BR />");
   if ($sql->f("gid") == -1)
   {
      print("$owl_lang->log_filter_all");
   } 
   else
   {
      print group_to_name($sql->f("gid"));
   } 
   print("</TD>\n");
   print("</TR>\n");
} 
print("</TABLE>");

if (owlusergroup($userid) == 0)
{
   print("<BR>");
   print("<BR>");
   fPrintButton("$default->owl_root_url/admin/index.php?sess=$sess", "btn_admin");
   print("<BR>");
} 

function fPrintDatePicker ($date = "")
{
   if ($date == "")
   {
      $iCurrentYear = date("Y");
      $iCurrentMonth = date("m");
      $iCurrentDay = date("d");
      $iCurrentHour = date("H");
      $iCurrentMinute = date("i");
   } 
   else
   {
      $iCurrentYear = substr($date, 0, 4);
      $iCurrentMonth = substr($date, 5, 2);
      $iCurrentDay = substr($date, 8, 2);
      $iCurrentHour = substr($date, 11, 2);
      $iCurrentMinute = substr($date, 14, 2);
   } 
   // 
   // Display the Year
   // 
   print("<select name='year'>\n");
   print("<option value='$iCurrentYear' selected>$iCurrentYear</option>\n");
   for ($i = $iCurrentYear;$i <= $iCurrentYear + 5;$i++)
   {
      if ($iCurrentYear != $i)
      {
         print ("<option value='$i'");
      } 
      print (">$i</option>\n");
   } 
   print ("</select>\n");
   print("-"); 
   // 
   // Display the Month
   // 
   print ("<select name='month'>\n");
   print ("<option value='$iCurrentMonth' selected>$iCurrentMonth</option>\n");
   for ($i = 1;$i < 13;$i++)
   {
      if ($i < 10)
      {
         $sString = "0" . $i;
      } 
      else
      {
         $sString = $i;
      } 
      if ($iCurrentMonth != $sString)
      {
         print ("<option value='$sString'");
         print (">$sString</option>\n");
      } 
   } 
   print ("</select>");
   print("-"); 
   // 
   // Display the Day
   // 
   print ("<select name='day'>\n");
   print ("<option value='$iCurrentDay' selected>$iCurrentDay</option>\n");
   for ($i = 1;$i < 32;$i++)
   {
      if ($i < 10)
      {
         $sString = "0" . $i;
      } 
      else
      {
         $sString = $i;
      } 
      if ($iCurrentDay != $sString)
      {
         print ("<option value='$sString'");
         print (">$sString</option>\n");
      } 
   } 
   print ("</select>\n");
   print("&nbsp;");
   print("&nbsp;"); 
   // 
   // Display the Hour
   // 
   print ("<select name='hour'>\n");
   print ("<option value='$iCurrentHour' selected>$iCurrentHour</option>\n");
   for ($i = 0;$i < 25;$i++)
   {
      if ($i < 10)
      {
         $sString = "0" . $i;
      } 
      else
      {
         $sString = $i;
      } 
      if ($iCurrentHour != $sString)
      {
         print ("<option value='$sString'");
         print (">$sString</option>\n");
      } 
   } 
   print ("</select>\n");
   print(":"); 
   // 
   // Display the Hour
   // 
   print ("<select name='minute'>\n");
   print ("<option value='$iCurrentMinute' selected>$iCurrentMinute</option>\n");
   for ($i = 0;$i < 60;$i++)
   {
      if ($i < 10)
      {
         $sString = "0" . $i;
      } 
      else
      {
         $sString = $i;
      } 
      if ($iCurrentMinute != $sString)
      {
         print ("<option value='$sString'");
         print (">$sString</option>\n");
      } 
   } 
   print ("</select>\n");
   print("&nbsp;");
} 

?>
</BODY> 
</HTML> 
