<?php

/**
 * download.php
 * 
 * Copyright (c) 1999-2003 The Owl Project Team
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 * 
 * $Id: download.php,v 1.3 2003/08/28 17:25:10 b0zz Exp $
 */
//require_once("./config/owl.php");
require_once(_SYSCOMMONROOT . "/lib/disp.lib.php");
require_once(_SYSCOMMONROOT . "/lib/owl.lib.php");
require_once(_SYSCOMMONROOT . "/lib/security.lib.php");

if ($sess == "0" && $default->anon_ro == 1)
   printError($owl_lang->err_login);

function zip_folder($id, $userid)
{
   global $default, $sess;

   $tmpdir = $default->owl_tmpdir . "/owltmpfld_$sess.$id";
   if (file_exists($tmpdir)) myDelete($tmpdir);

   mkdir("$tmpdir", 0777);
   $sql = new Owl_DB;
   $sql2 = new Owl_DB;

   $sql->query("select name, id from $default->owl_folders_table where id = '$id'");
   while ($sql->next_record())
   {
      $top = $sql->f("name");
   } 
   $path = "$tmpdir/$top";
   mkdir("$path", 0777);

   folder_loop($sql, $sql2, $id, $path, $userid); 
   // get all files in folder
   // GETTING IE TO WORK IS A PAIN!
   if (file_exists($default->tar_path))
   {
      if (file_exists($default->gzip_path))
      {
         if (strstr($_SERVER["HTTP_USER_AGENT"], "MSIE"))
            header("Content-Type: application/x-gzip");
         else
            header("Content-Type: application/octet-stream");
         if (substr(php_uname(), 0, 7) != "Windows")
         {
            header("Content-Disposition: attachment; filename=\"$top.tgz\"");
            header("Content-Location: \"$top.tgz\"");
            header("Expires: 0");
            passthru("$default->tar_path cf - -C " . escapeshellarg($tmpdir) . " " . escapeshellarg($top) . "| " . $default->gzip_path . " -c -9");
         } 
         else
         {
            header("Content-Location: \"$top.tar.gz\"");
            header("Content-Disposition: attachment; filename=\"$top.tar.gz\"");
            header("Expires: 0");
            system("$default->tar_path cf " . '"' . $tmpdir . "/" . $top . '.tar"' . " -C " . '"' . $tmpdir . '" "' . $top . '"');
            passthru($default->gzip_path . ' -c -9 "' . $tmpdir . "\\" . $top . '.tar"');
         } 
      } 
      else
      {
         if (substr(php_uname(), 0, 7) != "Windows")
         {
            if (strstr($_SERVER["HTTP_USER_AGENT"], "MSIE"))
               header("Content-Type: application/x-gzip");
            else
               header("Content-Type: application/octet-stream");
            header("Content-Disposition: attachment; filename=\"$top.tar\"");
            header("Content-Location: \"$top.tgz\"");
            header("Expires: 0");
            passthru("$default->tar_path cf - -C " . escapeshellarg($tmpdir) . " " . escapeshellarg($top));
         } 
         else
         {
            printError("$owl_lang->err_gzip_not_found $default->gzip_path");
         } 
      } 
   } 
   else
   {
      myDelete($tmpdir);
      printError("$owl_lang->err_tar_not_found $default->tar_path");
   } 
   myDelete($tmpdir);
} 

function folder_loop($sql, $sql2, $id, $tmpdir, $userid)
{
   global $default;

   if (check_auth($id, "folder_view", $userid) == 1)
   {
      $sql = new Owl_DB; 
      // write out all the files
      $sql->query("select * from $default->owl_files_table where parent = '$id' and url <> '1'");
      while ($sql->next_record())
      {
         $fid = $sql->f("id");
         $filename = $tmpdir . "/" . $sql->f("filename");
         if (check_auth($fid, "file_download", $userid) == 1)
         {
            if ($default->owl_use_fs)
            {
               $source = $default->owl_FileDir . "/" . get_dirpath($id) . "/" . $sql->f("filename");
               copy($source, $filename);
            } 
            else
            {
               $sql2->query("select data,compressed from " . $default->owl_files_data_table . " where id='$fid'");
               while ($sql2->next_record())
               {
                  if ($sql2->f("compressed"))
                  {
                     $fp = fopen($filename . ".gz", "w");
                     fwrite($fp, $sql2->f("data"));
                     fclose($fp);
                     system($default->gzip_path . " -d " . escapeshellarg($filename) . ".gz");
                  } 
                  else
                  {
                     $fp = fopen($filename, "w");
                     fwrite($fp, $sql2->f("data"));
                     fclose($fp);
                  } // end if     
               } // end if     
            } // end while
         } // end if
      } // end while 
      // recurse into directories
      $sql->query("select name, id from $default->owl_folders_table where parent = '$id'");
      while ($sql->next_record())
      {
         $saved = $tmpdir;
         $tmpdir .= "/" . $sql->f("name");
         mkdir("$tmpdir", 0777);
         folder_loop($sql, $sql2, $sql->f("id"), $tmpdir, $userid);
         $tmpdir = $saved;
      } 
   } 
} 

if ($action == "folder")
{
   $abort_status = ignore_user_abort(true);
   zip_folder($id, $userid);
   ignore_user_abort($abort_status);
   exit;
} 

if (check_auth($id, "file_download", $userid) == 1)
{
   $filename = flid_to_filename($id);
   $mimeType = "application/octet-stream";

   if ($binary != 1)
   {
      if ($filetype = strrchr($filename, "."))
      {
         $filetype = substr($filetype, 1);
         $sql = new Owl_DB;
         $sql->query("select * from $default->owl_mime_table where filetype = '$filetype'");
         while ($sql->next_record()) $mimeType = $sql->f("mimetype");
      } 
   } 
   // BEGIN wes change
   if ($default->owl_use_fs)
   {
      $path = find_path($parent) . "/" . $filename;
      $fspath = $default->owl_FileDir . "/" . $path;
      if (!file_exists($fspath))
      {
         printError("$owl_lang->err_file_not_exist");
      } 
      $fsize = filesize($fspath);
   } 
   else
   {
      $sql->query("select size from " . $default->owl_files_table . " where id='$id'");
      while ($sql->next_record()) $fsize = $sql->f("size");
   } 
   // END wes change
   // BEGIN BUG: 495556 File download sends incorrect headers
   // header("Content-Disposition: filename=\"$filename\"");
//print("HERE");
//exit;
   header("Content-Disposition: attachment; filename=\"$filename\"");
   header("Content-Location: $filename");
   header("Content-Type: $mimeType");
   header("Content-Length: $fsize");
   header("Expires: 0"); 
   // END BUG: 495556 File download sends incorrect headers
   // BEGIN wes change
   if ($default->owl_use_fs)
   {
      if (substr(php_uname(), 0, 7) != "Windows")
         $fp = fopen("$fspath", "r");
      else
         $fp = fopen("$fspath", "rb");
      fpassthru($fp); 
      // print fread($fp,filesize("$fspath"));
      // fclose($fp);
   } 
   else
   {
      $sql->query("select data,compressed from " . $default->owl_files_data_table . " where id='$id'");
      while ($sql->next_record())
      {
         if ($sql->f("compressed"))
         {
            $tmpfile = $default->owl_tmpdir . "/" . "owltmp.$id";
            if (file_exists($tmpfile)) unlink($tmpfile);

            $fp = fopen($tmpfile, "w");
            fwrite($fp, $sql->f("data"));
            fclose($fp);
            flush(passthru($default->gzip_path . " -dfc $tmpfile"));
            unlink($tmpfile);
         } 
         else
         {
            print $sql->f("data");
            flush();
         } 
      } 
   } 
   // END wes change
   owl_syslog(FILE_DOWNLOADED, $userid, flid_to_filename($id), $parent, "", "FILE");
} 
else
{
   printError($owl_lang->err_nofileaccess);
} 
// MAKE SURE THERE IS NOT BLANK LINE THE END OF THE FILE
// CUZ IT MESSES UP THE DOWNLOAD
?>
