<?php

/**
 * index.php -- Main page
 * 
 * Copyright (c) 1999-2003 The Owl Project Team
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 * 
 * $Id: index.php,v 1.6 2003/11/12 14:25:08 b0zz Exp $
 */

//if (bcheckLibExists("./config/owl.php")) require_once("./config/owl.php");
if (bcheckLibExists(_SYSCOMMONROOT . "/lib/disp.lib.php")) require_once(_SYSCOMMONROOT . "/lib/disp.lib.php");
if (bcheckLibExists(_SYSCOMMONROOT . "/lib/owl.lib.php")) require_once(_SYSCOMMONROOT . "/lib/owl.lib.php"); 
// 
// Function to check if the required libraries exists
// and are readable by the web server.
// and issue a more significant message
// Maybe we need this in other files as well, I'll wait and
// see.
// 
function bcheckLibExists ($filename)
{
   global $default;
   if (file_exists("$filename"))
   {
      if (is_readable("$filename"))
      {
         return true;
      } 
      else
      {
         die("<BR><FONT SIZE=4><CENTER>The webserver does not have read access to:
			<BR>'$default->owl_fs_root/$filename'.
			<BR>Please fix the permissions and try again</CENTER></FONT>");
      } 
   } 
   else
   {
      die("<BR><FONT SIZE=4><CENTER>The required file '$default->owl_fs_root/$filename' does not exists.<BR>
		    OR<BR>The path specified by \$default->owl_fs_root in config/owl.php is wrong.</CENTER></FONT>");
   } 
} 

if (checkrequirements() == 1)
{
   exit;
} 

if (!isset($failure)) $failure = 0;
if (!$login) $login = 1;

if ($loginname && $password)
{
   $verified["bit"] = 0;
   $verified = verify_login($loginname, $password);
   if ($verified["bit"] == 1)
   {
      $session = new Owl_Session;
      $uid = $session->Open_Session(0, $verified["uid"]);
      $id = 1;

      /**
       * If an admin signs on We want to se the admin menu
       * Not the File Browser.
       */
      owl_syslog(LOGIN, $verified["uid"], 0, 0, $owl_lang->log_login_det . $verified["user"], "LOGIN");

      $sql = new Owl_DB;
      $sql->query("SELECT curlogin FROM $default->owl_users_table where id = '" . $verified["uid"] . "'");
      $sql->next_record();
      $curlogin = $sql->f("curlogin");
      $sql->query("update $default->owl_users_table set lastlogin = '" . $curlogin . "' where id = '" . $verified["uid"] . "'");
      $sql->query("update $default->owl_users_table set curlogin = '" . date("Y-m-d H:i:s") . "' where id = '" . $verified["uid"] . "'");

      if ($verified["group"] == 0)
      {
         if (!isset($fileid))
         {
            if($default->admin_login_to_browse_page)
            {
               header("Location: browse.php?sess=" . $uid->sessdata["sessid"] . "&parent=$parent&fileid=$fileid");
            }
            else
            {
               header("Location: admin/index.php?sess=" . $uid->sessdata["sessid"]);
            }
         }
         else
         {
            header("Location: browse.php?sess=" . $uid->sessdata["sessid"] . "&parent=$parent&fileid=$fileid");
         }
      } 
      else
      {
         if (!isset($fileid))
         {
            header("Location: browse.php?sess=" . $uid->sessdata["sessid"]);
         }
         else
         {
            header("Location: browse.php?sess=" . $uid->sessdata["sessid"] . "&parent=$parent&fileid=$fileid");
         }
      } 
      /**
       * END Bozz Change
       */

   } 
   else
   {
      owl_syslog(LOGIN_FAILED, $verified["uid"], 0, 0, $owl_lang->log_login_det . $verified["user"], "LOGIN");
      if ($verified["bit"] == 2)
         header("Location: index.php?login=1&failure=2");
      else if ($verified["bit"] == 3)
         header("Location: index.php?login=1&failure=3");
      else
      {
         header("Location: index.php?login=1&failure=1");
      } 
   } 
} 
// CHECK IF THE ANONYMOUS USER IS DISABLELD
$sql = new Owl_DB;
$anon_disabled = 1;
$sql->query("select * from $default->owl_users_table where id = '$default->anon_user'");
if ($sql->num_rows() == 1)
{
   $sql->next_record();
   $anon_disabled = $sql->f("disabled");
} 

if (($login == 1) || ($failure == 1))
{
   include(_SYSCOMMONROOT . "/lib/header.inc");
   include(_SYSCOMMONROOT . "/lib/userheader.inc");
   print("<CENTER>\n");
   // BUG Number: 457588
   // This is to display the version inforamation
   // BEGIN
   print("<IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/$default->owl_logo'>\n<BR>$owl_lang->engine<BR>$owl_lang->version: $default->version<BR>\n<HR WIDTH=300>");
   // END
   if ($anon_disabled != 1)
      print("<A HREF='browse.php'>$owl_lang->anonymous</A>\n");
   if ($failure == 1) print("<BR>$owl_lang->loginfail<BR>\n");
   if ($failure == 2) print("<BR><B>'$accountname'</B>&nbsp;$owl_lang->logindisabled<BR><BR>\n");
   if ($failure == 3) print("<BR>$owl_lang->toomanysessions<BR>\n");
   if ($failure == 4) print("<BR>$owl_lang->err_login<BR>\n");
   print "<FORM ACTION=index.php METHOD=POST>\n";
   if (isset($fileid))
   {
      print "<INPUT TYPE=HIDDEN NAME=parent value=$parent>\n";
      print "<INPUT TYPE=HIDDEN NAME=fileid value=$fileid>\n";
   } 
   print "<TABLE>\n<TR>\n<TD>$owl_lang->username:</TD><TD><INPUT TYPE=TEXT NAME=loginname><BR></TD>\n</TR>\n";
   print "<TR>\n<TD>$owl_lang->password:</TD><TD><INPUT TYPE=PASSWORD NAME=password><BR></TD>\n</TR>\n</TABLE>\n";
   print "<INPUT TYPE=IMAGE SRC='$default->owl_graphics_url/$language/graphics/$default->sButtonStyle/ui_buttons/btn_login.gif' ALT='$owl_lang->alt_btn_login' TITLE='$owl_lang->alt_btn_login' BORDER=0 Value=$owl_lang->login onMouseOver=this.src='$default->owl_graphics_url/$language/graphics/$default->sButtonStyle/ui_buttons/btn_login_hover.gif'; onMouseOut=this.src='$default->owl_graphics_url/$language/graphics/$default->sButtonStyle/ui_buttons/btn_login.gif';>\n";
   print "<BR><HR WIDTH=300>";
   print "<TABLE>\n";
   if ($default->self_reg == 1)
   {
      print("<TR>\n<TD><font size=2>$owl_lang->like_register&nbsp;&nbsp;</font></TD>\n<TD>");
      fPrintButton("register.php", "btn_clickhere");
      print("</TD>\n</TR>\n<BR>\n");
   } 
   if ($default->forgot_pass == 1)
   {
      print("<TR>\n<TD><font size=2>$owl_lang->forgot_pass&nbsp;&nbsp;</font></TD>\n<TD>");
      fPrintButton("register.php?myaction=forgot", "btn_clickhere", 1); 
      print("</A></TD>\n</TR>\n<BR>\n");
   } 
   print "</TABLE>";
   include(_SYSCOMMONROOT . "/lib/footer.inc");
   exit;
} 

if ($login == "logout")
{
   include(_SYSCOMMONROOT . "/lib/header.inc");
   include(_SYSCOMMONROOT . "/lib/userheader.inc");
   print("<CENTER>\n");
   // BUG Number: 457588
   // This is to display the version inforamation
   // BEGIN
   print("<IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/$default->owl_logo'>\n<BR>$owl_lang->engine<BR>$owl_lang->version: $default->version<BR><HR WIDTH=300>\n");
   // END
   if ($anon_disabled != 1)
      print("<A HREF='browse.php'>$owl_lang->anonymous</A>\n");
   $sql = new Owl_DB;
   $sql->query("delete from $default->owl_sessions_table where sessid = '$sess' and ip <> '0'");
   print("<BR>$owl_lang->successlogout<BR>\n");
   owl_syslog(LOGOUT, $userid, 0, 0, $owl_lang->log_detail, "LOGIN");
   print "<FORM ACTION=index.php METHOD=POST>\n";
   print "<TABLE>\n<TR>\n<TD>$owl_lang->username:</TD>\n<TD><INPUT TYPE=TEXT NAME=loginname><BR></TD>\n</TR>\n";
   print "<TR>\n<TD>$owl_lang->password:</TD>\n<TD><INPUT TYPE=PASSWORD NAME=password><BR></TD>\n</TR>\n</TABLE>\n";
   print "<INPUT TYPE=IMAGE SRC='$default->owl_graphics_url/$language/graphics/$default->sButtonStyle/ui_buttons/btn_login.gif' ALT='$owl_lang->alt_btn_login' TITLE='$owl_lang->alt_btn_login' BORDER=0 Value=$owl_lang->login onMouseOver=this.src='$default->owl_graphics_url/$language/graphics/$default->sButtonStyle/ui_buttons/btn_login_hover.gif'; onMouseOut=this.src='$default->owl_graphics_url/$language/graphics/$default->sButtonStyle/ui_buttons/btn_login.gif';>\n";
   print "<BR><HR WIDTH=300>";
   print "<TABLE>\n";
   if ($default->self_reg == 1)
   {
      print("<TR>\n<TD><font size=2>$owl_lang->like_register&nbsp;&nbsp;</font></TD>\n<TD>");
      fPrintButton("register.php", "btn_clickhere");
      print("</TD>\n</TR>\n<BR>\n");

   } 
   if ($default->forgot_pass == 1)
   {
      print("<TR>\n<TD><font size=2>$owl_lang->forgot_pass&nbsp;&nbsp;</font></TD>\n<TD>");
      fPrintButton("register.php?myaction=forgot", "btn_clickhere", 1); 
      print("</A></TD>\n</TR>\n<BR>\n");
   } 
   print "</TABLE>\n";
   include(_SYSCOMMONROOT . "/lib/footer.inc");
   exit;
} 
include(_SYSCOMMONROOT . "/lib/footer.inc");
?>
