<?php

/**
 * owl.lib.php
 * 
 * Copyright (c) 1999-2003 The Owl Project Team
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 * 
 * $Id: owl.lib.php,v 1.11 2003/11/12 14:26:04 b0zz Exp $
 */
// 
// Controle the level of PHP Messages that are
// Reported
if ($default->debug == true)
{ 
   // error_reporting (E_ERROR | E_WARNING | E_PARSE | E_NOTICE);
   // I think we have a bit of work to get Owl to run with E_NOTICE turned On ;-(
   error_reporting (E_ERROR | E_WARNING | E_PARSE);
} 
else
{ 
   // error_reporting (E_ERROR);
   error_reporting (0);
} 
// 
// Support for reg.globals off WES
if (substr(phpversion(), 0, 5) >= "4.1.0")
{
   import_request_variables('pgc');
}
else
{
   if (!EMPTY($_POST))
   {
      extract($_POST);
   } 
   else
   {
      extract($HTTP_POST_VARS);
   } 
   if (!EMPTY($_GET))
   {
      extract($_GET);
   } 
   else
   {
      extract($HTTP_GET_VARS);
   } 
   if (!EMPTY($_FILE))
   {
      extract($_FILE);
   } 
   else
   {
      extract($HTTP_POST_FILES);
   } 
} 

if (!isset($sess)) 
{
   $sess = 0;
}
if (!isset($loginname)) 
{
   $loginname = 0;
}
if (!isset($login))
{
   $login = 0;
}

class Owl_DB extends DB_Sql
{
   var $classname = "Owl_DB"; 
   // BEGIN wes changes -- moved these settings to config/owl.php
   // Server where the database resides
   var $Host = ""; 
   // Database name
   var $Database = ""; 
   // User to access database
   var $User = ""; 
   // Password for database
   var $Password = "";

   function Owl_DB()
   {
      global $default;
      $this->Host = $default->owl_db_host;
      $this->Database = $default->owl_db_name;
      $this->User = $default->owl_db_user;
      $this->Password = $default->owl_db_pass;
   } 
   // END wes changes
   function haltmsg($msg)
   {
      printf("</td></table><b>Database error:</b> %s<br>\n", $msg);
      printf("<b>SQL Error</b>: %s (%s)<br>\n",
         $this->Errno, $this->Error);
   } 
} 

getprefs();
gethtmlprefs();
// 
// Set the language from default or from the users file.

// NOTE: the messages here cannot be internationalized
// 
if (!isset($default->sButtonStyle)) $default->sButtonStyle = $default->system_ButtonStyle;
if (isset($default->owl_lang))
{
   $langdir = "$default->owl_LangDir/$default->owl_lang";
   if (is_dir("$langdir") != 1)
   {
      die("<BR><FONT SIZE=4><CENTER>Path to the 'locale' directory was Not found: $langdir</CENTER></FONT>");
   } 
   else
   {
      $sql = new Owl_DB;
      $sql->query("select * from $default->owl_sessions_table where sessid = '$sess'");
      $sql->next_record();
      $numrows = $sql->num_rows($sql);
      $getuid = $sql->f("uid");
      if ($numrows == 1)
      {
         $sql->query("select * from $default->owl_users_table where id = $getuid");
         $sql->next_record();
         $language = $sql->f("language"); 
         $default->sButtonStyle = $sql->f("buttonstyle");
         if (!$language)
         {
            $language = $default->owl_lang;
         } 
         if (file_exists("$default->owl_LangDir/$language/language.inc"))
         {
            if (is_readable("$default->owl_LangDir/$language/language.inc"))
            {
               require_once("$default->owl_LangDir/$language/language.inc");
               $default->owl_lang = $language;
            } 
            else
            {
               die("<BR><FONT SIZE=4><CENTER>The webserver does not have read access to:
					     <BR>The Language file '$default->owl_LangDir/$language/language.inc'
				             <BR>Please fix the permissions and try again</CENTER></FONT>");
            } 
         } 
         else
         {
            die("<BR><FONT SIZE=4><CENTER>The Language file '$default->owl_LangDir/$language/language.inc' does not exists.</CENTER></FONT>");
         } 
      } 
      else
      {
         if ($sess == 0)
         {
            $language = $default->owl_lang;
         } 
         if (file_exists("$default->owl_LangDir/$default->owl_lang/language.inc"))
         {
            if (is_readable("$default->owl_LangDir/$default->owl_lang/language.inc"))
            {
               require_once("$default->owl_LangDir/$default->owl_lang/language.inc");
            } 
            else
            {
               die("<BR><FONT SIZE=4><CENTER>The webserver does not have read access to:
				      	<BR>The Language file '$default->owl_LangDir/$default->owl_lang/language.inc'.
					<BR>Please fix the permissions and try again</CENTER></FONT>");
            } 
         } 
         else
         {
            die("<BR><FONT SIZE=4><CENTER>The Language file '$default->owl_LangDir/$default->owl_lang/language.inc' does not exists.</CENTER></FONT>");
         } 
      } 
   } 
} 
else
{
   die("<BR><FONT SIZE=4><CENTER>Unable to find language, please specify in config/owl.php.</CENTER></FONT>");
} 

class Owl_Session
{
   var $sessid;
   var $sessuid;
   var $sessdata;

   function Open_Session($sessid = 0, $sessuid = 0)
   {
      global $default;
      $this->sessid = $sessid;
      $this->sessuid = $sessuid;

      if ($sessid == "0") // if there is no user loged in, then create a session for them
      {
         $current = time();
         $random = $this->sessuid . $current;
         $this->sessid = md5($random);
         $sql = new Owl_DB;
         if (getenv("HTTP_CLIENT_IP"))
         {
            $ip = getenv("HTTP_CLIENT_IP");
         } elseif (getenv("HTTP_X_FORWARDED_FOR"))
         {
            $forwardedip = getenv("HTTP_X_FORWARDED_FOR");
            list($ip, $ip2, $ip3, $ip4) = split (",", $forwardedip);
         } 
         else
         {
            $ip = getenv("REMOTE_ADDR");
         } 
         $result = $sql->query("insert into $default->owl_sessions_table  values ('$this->sessid', '$this->sessuid', '$current', '$ip')");
         if (!$result) 
         {
            die("$owl_lang->err_sess_write");
         }
      } 
      // else we have a session id, try to validate it...
      $sql = new Owl_DB;
      $sql->query("select * from $default->owl_sessions_table where sessid = '$this->sessid'"); 
      // any matching session ids?
      $numrows = $sql->num_rows($sql);
      if (!$numrows) die("$owl_lang->err_sess_notvalid"); 
      // return if we are a.o.k.
      while ($sql->next_record())
      {
         $this->sessdata["sessid"] = $sql->f("sessid");
      } 
      return $this;
   } 
} 
// --------------------------------
function check_for_sess ($uid)
{
   global $default;

   $mysess = 0;
   $sql = new Owl_DB;
   $sql->query("select * from $default->owl_sessions_table where uid = '$uid' and ip = '0' ORDER BY lastused ASC");
   while ($sql->next_record())
   {
      $time = time();
      if (($time - $sql->f("lastused")) <= $default->owl_timeout)
      {
         $mysess = $sql->f("sessid");
         $sql->query("UPDATE $default->owl_sessions_table set lastused = '$time' where sessid = '$mysess'");
         break;
      } 
   } 
   if ($mysess == 0)
   {
      $session = new Owl_Session;
      $userid = $session->Open_Session(0, $uid);
      $mysess = $userid->sessdata["sessid"];
      $sql->query("UPDATE $default->owl_sessions_table set ip = '0' where sessid = '$mysess'");
   } 
   return $mysess;
} 

function notify_file_owner($iFileId, $comment)
{
   global $default, $userid;
   global $owl_lang;

   $sql = new Owl_DB;
   $getuser = new Owl_DB;

   $sql->query("select * from $default->owl_files_table where id = '$iFileId'");

   $sql->next_record();

   $iCreatorId = $sql->f("creatorid");
   $sFileName = $sql->f("filename");
   $iParent = $sql->f("parent");

   $getuser->query("select email,comment_notify,name from $default->owl_users_table where id = '$iCreatorId'");
   $getuser->next_record();

   if ($getuser->f("comment_notify") == 1)
   {
      $mail = new phpmailer();
      if ($default->use_smtp)
      {
         $mail->IsSMTP(); // set mailer to use SMTP
         if ($default->use_smtp_auth)
         {
            $mail->SMTPAuth = "true"; // turn on SMTP authentication
            $mail->Username = "$default->owl_email_from"; // SMTP username
            $mail->Password = "$default->smtp_passwd"; // SMTP password
         } 
      } 
      $mail->Host = "$default->owl_email_server"; // specify main and backup server
      $mail->From = "$default->owl_email_from";
      $mail->FromName = "$default->owl_email_fromname";
      $mail->AddAddress($getuser->f("email"));
      $mail->AddReplyTo("$default->owl_email_replyto", "OWL Intranet");
      $mail->WordWrap = 50; // set word wrap to 50 characters
      $mail->IsHTML(true); // set email format to HTML
      $mail->Subject = "$default->owl_email_subject  $owl_lang->notif_subject_comment";
      $mail->Body = "<html><body>" . "$owl_lang->notif_salutation " . $getuser->f("name") . ",<BR><BR>";
      $mail->Body .= uid_to_name($userid) . " $owl_lang->notif_comment_1 " . get_dirpath($iParent) . "/" . $sFileName . "<BR><BR>";
      $mail->Body .= "$owl_lang->notif_comment_2<BR><BR>";
      $mail->Body .= ereg_replace("\n", '<BR>', $comment) . "<BR><BR><BR>";
      $mail->Body .= "</body></html>";

      $mail->Body .= "</body></html>";
      if (!$mail->Send() && $default->debug == true)
      {
         printError("DEBUG: " . $owl_lang->err_email, $mail->ErrorInfo);
      } 
   } 
} 

function notify_monitored_folders ($parent, $filename)
{
   global $default;
   global $owl_lang;

   $sql = new Owl_DB;
   $getuser = new Owl_DB; 
   // For each user that want to receive notification of an UPDATE of this file
   
   $sql->query("select f.id, fid, name, description, parent, userid, filename from $default->owl_files_table as f, $default->owl_monitored_folder_table as m where f.filename = '$filename' and f.parent = '$parent' and m.fid = '$parent';");

   while ($sql->next_record())
   {
      $CurrentUser = $sql->f("userid");
      $getuser->query("select id, email,language,attachfile from $default->owl_users_table where id = '$CurrentUser'");
      $getuser->next_record();

      if (check_auth($sql->f("id"), "file_download", $getuser->f(id)) == 1)
      {
         // END BUG 548994 More Below
         $path = find_path($sql->f("parent"));
         $filename = $sql->f("filename"); 
         // $newpath = ereg_replace(" ","%20",$path);
         $newpath = $path; 
         // $newfilename = ereg_replace(" ","%20",$sql->f("filename"));
         $newfilename = $sql->f("filename");
         $DefUserLang = $getuser->f("language");
         require("$default->owl_LangDir/$DefUserLang/language.inc");

         $r = preg_split("(\;|\,)", $getuser->f("email"));
         reset ($r);
         while (list ($occ, $email) = each ($r))
         { 
            // $session = new Owl_Session;
            // $uid = $session->Open_Session(0,$getuser->f("id"));
            // $tempsess = $uid->sessdata["sessid"];
            $tempsess = check_for_sess($getuser->f("id"));

            $mail = new phpmailer();
            if ($default->use_smtp)
            {
               $mail->IsSMTP(); // set mailer to use SMTP
               if ($default->use_smtp_auth)
               {
                  $mail->SMTPAuth = "true"; // turn on SMTP authentication
                  $mail->Username = "$default->owl_email_from"; // SMTP username
                  $mail->Password = "$default->smtp_passwd"; // SMTP password
               } 
            } 
            $mail->Host = "$default->owl_email_server"; // specify main and backup server
            $mail->From = "$default->owl_email_from";
            $mail->FromName = "$default->owl_email_fromname";
            $mail->AddAddress($email);
            $mail->AddReplyTo("$default->owl_email_replyto", "OWL Intranet");
            $mail->WordWrap = 50; // set word wrap to 50 characters
            $mail->IsHTML(true); // set email format to HTML
            $mail->Subject = "$default->owl_email_subject $owl_lang->notif_subject_monitor";
            if ($type != "url")
            {
               if ($getuser->f("attachfile") == 1)
               {
                  $desc = ereg_replace("[\\]", "", $sql->f("description"));
                  $mail->Body = "<html><body>" . "$owl_lang->notif_msg<BR><BR>" . "$owl_lang->title: " . $sql->f("name") . "<BR><BR>$owl_lang->description: $desc <BR><BR>";
                  $mail->Body .= $owl_lang->owl_path . $path . "/" . $filename;
                  $mail->altBody = "$owl_lang->notif_msg_alt\n\n" . "$owl_lang->title: " . $sql->f("name") . "\n\n $owl_lang->description: $desc \n\n";
                  $mail->altBody .= $owl_lang->owl_path . $path . "/" . $filename;
                  if (!$default->owl_use_fs)
                  {
                     if (file_exists("$default->owl_FileDir/$filename"))
                     {
                        unlink("$default->owl_FileDir/$filename");
                     } 
                     $file = fopen("$default->owl_FileDir/$filename", 'wb');
                     $getfile = new Owl_DB;
                     $getfile->query("select data,compressed from $default->owl_files_data_table where id='$fid'");
                     while ($getfile->next_record())
                     {
                        if ($getfile->f("compressed"))
                        {
                           $tmpfile = $default->owl_tmpdir . "owltmp.$fid.gz";
                           $uncomptmpfile = $default->owl_tmpdir . "owltmp.$fid";
                           if (file_exists($tmpfile)) unlink($tmpfile);

                           $fp = fopen($tmpfile, "w");
                           fwrite($fp, $getfile->f("data"));
                           fclose($fp);

                           system($default->gzip_path . " -df $tmpfile");

                           $fsize = filesize($uncomptmpfile);
                           $fd = fopen($uncomptmpfile, 'rb');
                           $filedata = fread($fd, $fsize);
                           fclose($fd);

                           fwrite($file, $filedata);
                           unlink($uncomptmpfile);
                        } 
                        else
                        {
                           fwrite($file, $getfile->f("data"));
                        } 
                     } 
                     fclose($file); 
                     // $mail->AddAttachment("$default->owl_FileDir/$newfilename");
                     $mimeType = fGetMimeType($newfilename);
                     $mail->AddAttachment("$default->owl_FileDir/$newfilename", "" , "base64" , "$mimeType");
                  } 
                  else
                  {
                     $mimeType = fGetMimeType($newfilename);
                     $mail->AddAttachment("$default->owl_FileDir/$newpath/$newfilename", "" , "base64" , "$mimeType"); 
                     // $mail->AddAttachment("$default->owl_FileDir/$newpath/$newfilename");
                  } 
               } 
               else
               {
                  $desc = ereg_replace("[\\]", "", $sql->f("description"));
                  $link = $default->owl_notify_link . "browse.php?sess=$tempsess&parent=" . $sql->f("parent") . "&expand=1&fileid=" . $sql->f("fid");
                  $mail->Body = "<html><body>" . "$owl_lang->notif_msg<BR><BR>" . "$owl_lang->title: " . $sql->f("name") . "<BR><BR>URL: <A HREF=" . $link . ">" . $link . "</A><BR><BR>$owl_lang->description: $desc <BR><BR>";
                  $mail->Body .= $owl_lang->owl_path . $path . "/" . $filename;
                  $mail->altBody = "$owl_lang->notif_msg_alt\n\n" . "$owl_lang->title: " . $sql->f("name") . "\n\n $owl_lang->description: $desc \n\n";
                  $mail->altBody .= $owl_lang->owl_path . $path . "/" . $filename;
               } 
            } 
            else
            {
               $desc = ereg_replace("[\\]", "", $sql->f("description"));
               $mail->Body = "<html><body>" . "URL: <A HREF=" . $newfilename . ">" . $newfilename . "</A> <BR><BR>$owl_lang->notif_msg<BR><BR>" . "$owl_lang->title: " . $sql->f("name") . "<BR><BR>$owl_lang->description: $desc <BR><BR>";
               $mail->Body .= $owl_lang->owl_path . $path . "/" . $filename;
               $mail->altBody = "URL: $newfilename \n\n$owl_lang->notif_msg_alt\n\n" . "$owl_lang->title: " . $sql->f("name") . "\n\n $owl_lang->description: $desc \n\n";
               $mail->altBody .= $owl_lang->owl_path . $path . "/" . $filename;
            } 
            $mail->Body .= "</body></html>";
            if (!$mail->Send() && $default->debug == true)
            {
               printError("DEBUG: " . $owl_lang->err_email, $mail->ErrorInfo);
            } 
            if (!$default->owl_use_fs && $sql->f("attachfile") == 1)
            {
               unlink("$default->owl_FileDir/$newfilename");
            } 
         } 
      } 
   } 
} 
// --------------------------------
function notify_monitored ($fid, $type)
{
   global $default;
   global $owl_lang;

   $sql = new Owl_DB;
   $getuser = new Owl_DB; 
   // For each user that want to receive notification of an UPDATE of this file
   
   $sql->query("select * from $default->owl_files_table as f, $default->owl_monitored_file_table as m where f.id = m.fid and m.fid = '$fid';");

   while ($sql->next_record())
   {
      $CurrentUser = $sql->f("userid");
      $getuser->query("select id, email,language,attachfile from $default->owl_users_table where id = '$CurrentUser'");
      $getuser->next_record();

      if (check_auth($fid, "file_download", $getuser->f(id)) == 1)
      {
         // END BUG 548994 More Below
         $path = find_path($sql->f("parent"));
         $filename = $sql->f("filename"); 
         $newpath = $path;
         $newfilename = $sql->f("filename"); 
         $DefUserLang = $getuser->f("language");
         require("$default->owl_LangDir/$DefUserLang/language.inc");

         $r = preg_split("(\;|\,)", $getuser->f("email"));
         reset ($r);
         while (list ($occ, $email) = each ($r))
         { 
            $tempsess = check_for_sess($getuser->f("id"));

            $mail = new phpmailer();
            if ($default->use_smtp)
            {
               $mail->IsSMTP(); // set mailer to use SMTP
               if ($default->use_smtp_auth)
               {
                  $mail->SMTPAuth = "true"; // turn on SMTP authentication
                  $mail->Username = "$default->owl_email_from"; // SMTP username
                  $mail->Password = "$default->smtp_passwd"; // SMTP password
               } 
            } 
            $mail->Host = "$default->owl_email_server"; // specify main and backup server
            $mail->From = "$default->owl_email_from";
            $mail->FromName = "$default->owl_email_fromname";
            $mail->AddAddress($email);
            $mail->AddReplyTo("$default->owl_email_replyto", "OWL Intranet");
            $mail->WordWrap = 50; // set word wrap to 50 characters
            $mail->IsHTML(true); // set email format to HTML
            $mail->Subject = "$default->owl_email_subject $owl_lang->notif_subject_monitor";
            if ($type != "url")
            {
               if ($getuser->f("attachfile") == 1)
               {
                  $desc = ereg_replace("[\\]", "", $sql->f("description"));
                  $mail->Body = "<html><body>" . "$owl_lang->notif_msg<BR><BR>" . "$owl_lang->title: " . $sql->f("name") . "<BR><BR>$owl_lang->description: $desc <BR><BR>";
                  $mail->Body .= $owl_lang->owl_path . $path . "/" . $filename;
                  $mail->altBody = "$owl_lang->notif_msg_alt\n\n" . "$owl_lang->title: " . $sql->f("name") . "\n\n $owl_lang->description: $desc \n\n";
                  $mail->altBody .= $owl_lang->owl_path . $path . "/" . $filename;
                  if (!$default->owl_use_fs)
                  {
                     if (file_exists("$default->owl_FileDir/$filename"))
                     {
                        unlink("$default->owl_FileDir/$filename");
                     } 
                     $file = fopen("$default->owl_FileDir/$filename", 'wb');
                     $getfile = new Owl_DB;
                     $getfile->query("select data,compressed from $default->owl_files_data_table where id='$fid'");
                     while ($getfile->next_record())
                     {
                        if ($getfile->f("compressed"))
                        {
                           $tmpfile = $default->owl_tmpdir . "owltmp.$fid.gz";
                           $uncomptmpfile = $default->owl_tmpdir . "owltmp.$fid";
                           if (file_exists($tmpfile)) unlink($tmpfile);

                           $fp = fopen($tmpfile, "w");
                           fwrite($fp, $getfile->f("data"));
                           fclose($fp);

                           system($default->gzip_path . " -df $tmpfile");

                           $fsize = filesize($uncomptmpfile);
                           $fd = fopen($uncomptmpfile, 'rb');
                           $filedata = fread($fd, $fsize);
                           fclose($fd);

                           fwrite($file, $filedata);
                           unlink($uncomptmpfile);
                        } 
                        else
                        {
                           fwrite($file, $getfile->f("data"));
                        } 
                     } 
                     fclose($file); 
                     $mimeType = fGetMimeType($newfilename);
                     $mail->AddAttachment("$default->owl_FileDir/$newfilename", "" , "base64" , "$mimeType");
                  } 
                  else
                  { 
                     $mimeType = fGetMimeType($newfilename);
                     $mail->AddAttachment("$default->owl_FileDir/$newpath/$newfilename", "" , "base64" , "$mimeType");
                  } 
               } 
               else
               {
                  $desc = ereg_replace("[\\]", "", $sql->f("description"));
                  $link = $default->owl_notify_link . "browse.php?sess=$tempsess&parent=" . $sql->f("parent") . "&expand=1&fileid=" . $sql->f("fid");
                  $mail->Body = "<html><body>" . "$owl_lang->notif_msg<BR><BR>" . "$owl_lang->title: " . $sql->f("name") . "<BR><BR>URL: <A HREF=" . $link . ">" . $link . "</A><BR><BR>$owl_lang->description: $desc <BR><BR>";
                  $mail->Body .= $owl_lang->owl_path . $path . "/" . $filename;
                  $mail->altBody = "$owl_lang->notif_msg_alt\n\n" . "$owl_lang->title: " . $sql->f("name") . "\n\n $owl_lang->description: $desc \n\n";
                  $mail->altBody .= $owl_lang->owl_path . $path . "/" . $filename;
               } 
            } 
            else
            {
               $desc = ereg_replace("[\\]", "", $sql->f("description"));
               $mail->Body = "<html><body>" . "URL: <A HREF=" . $newfilename . ">" . $newfilename . "</A> <BR><BR>$owl_lang->notif_msg<BR><BR>" . "$owl_lang->title: " . $sql->f("name") . "<BR><BR>$owl_lang->description: $desc <BR><BR>";
               $mail->Body .= $owl_lang->owl_path . $path . "/" . $filename;
               $mail->altBody = "URL: $newfilename \n\n$owl_lang->notif_msg_alt\n\n" . "$owl_lang->title: " . $sql->f("name") . "\n\n $owl_lang->description: $desc \n\n";
               $mail->altBody .= $owl_lang->owl_path . $path . "/" . $filename;
            } 
            $mail->Body .= "</body></html>";
            if (!$mail->Send() && $default->debug == true)
            {
               printError("DEBUG: " . $owl_lang->err_email, $mail->ErrorInfo);
            } 
            if (!$default->owl_use_fs && $sql->f("attachfile") == 1)
            {
               unlink("$default->owl_FileDir/$newfilename");
            } 
         } 
      } 
   } 
} 

function notify_users($groupid, $flag, $parent, $filename, $title, $desc, $type)
{
   global $default;
   global $owl_lang;

   $sql = new Owl_DB; 
   $desc = ereg_replace("[\\]", "", $desc);
   $title = ereg_replace("[\\]", "", $title);

   $path = find_path($parent);
   $sql->query("select id from $default->owl_files_table where filename='$filename' AND parent='$parent'");
   $sql->next_record();
   $fileid = $sql->f("id");
   $sql->query("select distinct id, email,language,attachfile from $default->owl_users_table as u left join $default->owl_users_grpmem_table as m on u.id=m.userid where notify = 1 and (u.groupid = $groupid or m.groupid = $groupid)");

   while ($sql->next_record())
   {
      if (check_auth($fileid, "file_download", $sql->f(id)) == 1)
      {
         $newpath = $path; 
         $newfilename = $filename;
         $DefUserLang = $sql->f("language");
         require("$default->owl_LangDir/$DefUserLang/language.inc");

         $r = preg_split("(\;|\,)", $sql->f("email"));
         reset ($r);
         while (list ($occ, $email) = each ($r))
         {
            $mail = new phpmailer(); 
            // Create a temporary session id, the user
            // will need to get to this file before
            // the default session timeout
            // $session = new Owl_Session;
            // $uid = $session->Open_Session(0,$sql->f("id"));
            // $tempsess = $uid->sessdata["sessid"];
            $tempsess = check_for_sess($sql->f("id"));

            if ($flag == 0)
            {
               if ($default->use_smtp)
               {
                  $mail->IsSMTP(); // set mailer to use SMTP
                  if ($default->use_smtp_auth)
                  {
                     $mail->SMTPAuth = "true"; // turn on SMTP authentication
                     $mail->Username = "$default->owl_email_from"; // SMTP username
                     $mail->Password = "$default->smtp_passwd"; // SMTP password
                  } 
               } 
               $mail->Host = "$default->owl_email_server"; // specify main and backup server
               $mail->From = "$default->owl_email_from";
               $mail->FromName = "$default->owl_email_fromname";
               $mail->AddAddress($email);
               $mail->AddReplyTo("$default->owl_email_replyto", "OWL Intranet");
               $mail->WordWrap = 50; // set word wrap to 50 characters
               $mail->IsHTML(true); // set email format to HTML
               $mail->Subject = "$default->owl_email_subject $owl_lang->notif_subject_new";
               if ($type != "url")
               {
                  if ($sql->f("attachfile") == 1)
                  {
                     $mail->Body = "<html><body>" . "$owl_lang->notif_msg<BR><BR>" . "$owl_lang->title: $title" . "<BR><BR>$owl_lang->description: $desc<BR><BR>";
                     $mail->Body .= $owl_lang->owl_path . $path . "/" . $filename;
                     $mail->altBody = "$owl_lang->notif_msg_alt\n\n" . "$owl_lang->title: $title" . "\n\n $owl_lang->description: $desc\n\n";
                     $mail->altBody .= $owl_lang->owl_path . $path . "/" . $filename;

                     if (!$default->owl_use_fs)
                     {
                        if (file_exists("$default->owl_FileDir/$filename"))
                        {
                           unlink("$default->owl_FileDir/$filename");
                        } 
                        $file = fopen("$default->owl_FileDir/$filename", 'wb');
                        $getfile = new Owl_DB;
                        $getfile->query("select data,compressed from $default->owl_files_data_table where id='$fileid'");
                        while ($getfile->next_record())
                        {
                           if ($getfile->f("compressed"))
                           {
                              $tmpfile = $default->owl_tmpdir . "/owltmp.$fileid.gz";
                              $uncomptmpfile = $default->owl_tmpdir . "/owltmp.$fileid";
                              if (file_exists($tmpfile)) unlink($tmpfile);

                              $fp = fopen($tmpfile, "w");
                              fwrite($fp, $getfile->f("data"));
                              fclose($fp);

                              system($default->gzip_path . " -df $tmpfile");

                              $fsize = filesize($uncomptmpfile);
                              $fd = fopen($uncomptmpfile, 'rb');
                              $filedata = fread($fd, $fsize);
                              fclose($fd);

                              fwrite($file, $filedata);
                              unlink($uncomptmpfile);
                           } 
                           else
                           {
                              fwrite($file, $getfile->f("data"));
                           } 
                        } 
                        fclose($file); 
                        $mimeType = fGetMimeType($newfilename);
                        $mail->AddAttachment("$default->owl_FileDir/$newfilename", "" , "base64" , "$mimeType");
                     } 
                     else
                     { 
                        $mimeType = fGetMimeType($newfilename);
                        $mail->AddAttachment("$default->owl_FileDir/$newpath/$newfilename", "" , "base64" , "$mimeType");
                     } 
                  } 
                  else
                  {
                     $link = $default->owl_notify_link . "browse.php?sess=$tempsess&parent=$parent&expand=1&fileid=$fileid";
                     $mail->Body = "<html><body>" . "$owl_lang->notif_msg<BR><BR>" . "$owl_lang->title: " . $title . "<BR><BR>URL: <A HREF=" . $link . ">" . $link . "</A><BR><BR>$owl_lang->description: $desc<BR><BR>";
                     $mail->Body .= $owl_lang->owl_path . $path . "/" . $filename;
                     $mail->altBody = "$owl_lang->notif_msg_alt\n\n" . "$owl_lang->title: $title" . "\n\n $owl_lang->description: $desc\n\n";
                     $mail->altBody .= $owl_lang->owl_path . $path . "/" . $filename;
                  } 
               } 
               else
               {
                  $mail->Body = "<html><body>" . "URL: <A HREF=" . $newfilename . ">" . $newfilename . "</A> <BR><BR>$owl_lang->notif_msg<BR><BR>" . "$owl_lang->title: " . $title . "<BR><BR>$owl_lang->description: $desc <BR><BR>";
                  $mail->Body .= $owl_lang->owl_path . $path . "/" . $filename;
                  $mail->altBody = "URL: $newfilename \n\n$owl_lang->notif_msg_alt\n\n" . "$owl_lang->title: $title" . "\n\n $owl_lang->description: $desc\n\n";
                  $mail->altBody .= $owl_lang->owl_path . $path . "/" . $filename;
               } 
            } 
            else
            {
               $mail = new phpmailer();
               if ($default->use_smtp)
               {
                  $mail->IsSMTP(); // set mailer to use SMTP
                  if ($default->use_smtp_auth)
                  {
                     $mail->SMTPAuth = "true"; // turn on SMTP authentication
                     $mail->Username = "$default->owl_email_from"; // SMTP username
                     $mail->Password = "$default->smtp_passwd"; // SMTP password
                  } 
               } 
               $mail->Host = "$default->owl_email_server"; // specify main and backup server
               $mail->From = "$default->owl_email_from";
               $mail->FromName = "$default->owl_email_fromname";
               $mail->AddAddress($email);
               $mail->AddReplyTo("$default->owl_email_replyto", "OWL Intranet");
               $mail->WordWrap = 50; // set word wrap to 50 characters
               $mail->IsHTML(true); // set email format to HTML
               $mail->Subject = "$default->owl_email_subject $owl_lang->notif_subject_upd";
               if ($type != "url")
               {
                  if ($sql->f("attachfile") == 1)
                  {
                     $mail->Body = "<html><body>" . "$owl_lang->notif_msg<BR><BR>" . "$owl_lang->title: $title" . "<BR><BR>$owl_lang->description: $desc<BR><BR>";
                     $mail->Body .= $owl_lang->owl_path . $path . "/" . $filename;
                     $mail->altBody = "$owl_lang->notif_msg_alt\n\n" . "$owl_lang->title: $title" . "\n\n $owl_lang->description: $desc \n\n";
                     $mail->altBody .= $owl_lang->owl_path . $path . "/" . $filename;
                     if (!$default->owl_use_fs)
                     {
                        if (file_exists("$default->owl_FileDir/$filename"))
                        {
                           unlink("$default->owl_FileDir/$filename");
                        } 
                        $file = fopen("$default->owl_FileDir/$filename", 'wb');
                        $getfile = new Owl_DB;
                        $getfile->query("select data,compressed from $default->owl_files_data_table where id='$fileid'");
                        while ($getfile->next_record())
                        {
                           if ($getfile->f("compressed"))
                           {
                              $tmpfile = $default->owl_tmpdir . "owltmp.$fileid.gz";
                              $uncomptmpfile = $default->owl_tmpdir . "owltmp.$fileid";
                              if (file_exists($tmpfile)) unlink($tmpfile);

                              $fp = fopen($tmpfile, "w");
                              fwrite($fp, $getfile->f("data"));
                              fclose($fp);

                              system($default->gzip_path . " -df $tmpfile");

                              $fsize = filesize($uncomptmpfile);
                              $fd = fopen($uncomptmpfile, 'rb');
                              $filedata = fread($fd, $fsize);
                              fclose($fd);

                              fwrite($file, $filedata);
                              unlink($uncomptmpfile);
                           } 
                           else
                           {
                              fwrite($file, $getfile->f("data"));
                           } 
                        } 
                        fclose($file); 
                        $mimeType = fGetMimeType($newfilename);
                        $mail->AddAttachment("$default->owl_FileDir/$newfilename", "" , "base64" , "$mimeType");
                     } 
                     else
                     { 
                        $mimeType = fGetMimeType($newfilename);
                        $mail->AddAttachment("$default->owl_FileDir/$newpath/$newfilename", "" , "base64" , "$mimeType");
                     } 
                  } 
                  else
                  {
                     $link = $default->owl_notify_link . "browse.php?sess=$tempsess&parent=$parent&expand=1&fileid=$fileid";
                     $mail->Body = "<html><body>" . "$owl_lang->notif_msg<BR><BR>" . "$owl_lang->title: " . $title . "<BR><BR>URL: <A HREF=" . $link . ">" . $link . "</A><BR><BR>$owl_lang->description: $desc <BR><BR>";
                     $mail->Body .= $owl_lang->owl_path . $path . "/" . $filename;
                     $mail->altBody = "$owl_lang->notif_msg_alt\n\n" . "$owl_lang->title: $title" . "\n\n $owl_lang->description: $desc \n\n";
                     $mail->altBody .= $owl_lang->owl_path . $path . "/" . $filename;
                  } 
               } 
               else
               {
                  $mail->Body = "<html><body>" . "URL: <A HREF=" . $newfilename . ">" . $newfilename . "</A> <BR><BR>$owl_lang->notif_msg<BR><BR>" . "$owl_lang->title: " . $title . "<BR><BR>$owl_lang->description:  $desc <BR><BR>";
                  $mail->Body .= $owl_lang->owl_path . $path . "/" . $filename;
                  $mail->altBody = "URL: $newfilename \n\n$owl_lang->notif_msg_alt\n\n" . "$owl_lang->title: $title" . "\n\n $owl_lang->description: $desc \n\n";
                  $mail->altBody .= $owl_lang->owl_path . $path . "/" . $filename;
               } 
            } 
            $mail->Body .= "</body></html>";
            if (!$mail->Send() && $default->debug == true)
            {
               printError("DEBUG: " . $owl_lang->err_email, $mail->ErrorInfo);
            } 
            if (!$default->owl_use_fs && $sql->f("attachfile") == 1)
            {
               if ($type = "")
                  unlink("$default->owl_FileDir/$newfilename");
            } 
         } 
      } 
   } 
} 

function verify_login($username, $password)
{
   global $default;

   $sql = new Owl_DB;
   $sql->query("select * from $default->owl_users_table where username = '$username' and password = '" . md5($password) . "'");
   $numrows = $sql->num_rows($sql); 
   // Bozz Begin added Password Encryption above, but for now
   // I will allow admin to use non crypted password until he
   // upgrades all users
   if ($numrows == "1")
   {
      while ($sql->next_record())
      {
         if ($sql->f("disabled") == 1)
            $verified["bit"] = 2;
         else
            $verified["bit"] = 1;
         $verified["user"] = $sql->f("username");
         $verified["uid"] = $sql->f("id");
         $verified["group"] = $sql->f("groupid");
         $maxsessions = $sql->f("maxsessions") + 1;
      } 
   } 
   else
   { 
      // LOGIN has FAILED, lets see if a valid username has been used
      // 
      $sql->query("select * from $default->owl_users_table where username = '$username'");
      $numrows = $sql->num_rows($sql);
      if ($numrows == "1")
      {
         while ($sql->next_record())
         {
            $verified["uid"] = $sql->f("id");
            $verified["user"] = $sql->f("username");
         } 
      } 
   } 
   // remove stale sessions from the database for the user
   // that is signing on.
   
   $time = time() - $default->owl_timeout;
   if ($verified["group"] == 0)
   {
      $sql = new Owl_DB;
      $sql->query("delete from $default->owl_sessions_table where lastused <= $time ");
   } 
   else
   {
      $sql = new Owl_DB;
      $sql->query("delete from $default->owl_sessions_table where uid = '" . $verified["uid"] . "' and lastused <= $time ");
   } 
   // Check if Maxsessions has been reached
   
   $sql = new Owl_DB;
   $sql->query("select * from $default->owl_sessions_table where ip <> '0' and uid = '" . $verified["uid"] . "'");

   if ($sql->num_rows($sql) >= $maxsessions && $verified["bit"] != 0)
   {
      if ($verified["group"] == 0)
         $verified["bit"] = 1;
      else
         $verified["bit"] = 3;
   } 
   return $verified;
} 

function verify_session($sess)
{
   global $default;
   global $owl_lang;
   global $parent, $fileid;

   $sess = ltrim($sess);
   $verified["bit"] = 0;
   $sql = new Owl_DB;
   $sql->query("select * from $default->owl_sessions_table where sessid = '$sess'");
   $numrows = $sql->num_rows($sql);
   $time = time();
   if ($numrows == "1")
   {
      while ($sql->next_record())
      {
         if (getenv("HTTP_CLIENT_IP"))
         {
            $ip = getenv("HTTP_CLIENT_IP");
         } elseif (getenv("HTTP_X_FORWARDED_FOR"))
         {
            $forwardedip = getenv("HTTP_X_FORWARDED_FOR");
            list($ip, $ip2, $ip3, $ip4) = split (",", $forwardedip);
         } 
         else
         {
            $ip = getenv("REMOTE_ADDR");
         } 
         if ($ip == $sql->f("ip") || 0 == $sql->f("ip"))
         {
            if (($time - $sql->f("lastused")) <= $default->owl_timeout)
            {
               $verified["bit"] = 1;
               $verified["userid"] = $sql->f("uid");
               $sql->query("select * from $default->owl_users_table where id = '" . $verified["userid"] . "'");
               while ($sql->next_record()) $verified["groupid"] = $sql->f("groupid");
            } 
            else
            { 
               if (file_exists(_SYSCOMMONROOT . "/lib/header.inc"))
               {
                  include(_SYSCOMMONROOT . "/lib/header.inc");
                  include(_SYSCOMMONROOT . "/lib/userheader.inc");
               } 
               else
               {
                  include(_SYSCOMMONROOT . "/lib/header.inc");
                  include(_SYSCOMMONROOT . "/lib/userheader.inc");
               } 
               print("<BR><BR><CENTER>" . $owl_lang->sesstimeout);
               if ($parent == "" || $fileid == "")
               {
                  fPrintButton("$default->owl_root_url/index.php", "btn_login");
               }
               else
               {
                  fPrintButton("$default->owl_root_url/index.php?parent=$parent&fileid=$fileid", "btn_login");
               }
               if (file_exists(_SYSCOMMONROOT . "/lib/footer.inc"))
               {
                  include(_SYSCOMMONROOT . "/lib/footer.inc");
               } 
               else
               {
                  include(_SYSCOMMONROOT . "/lib/footer.inc");
               } 
               exit();
            } 
         } 
         else
         { 
            if (file_exists(_SYSCOMMONROOT . "/lib/header.inc"))
            {
               include(_SYSCOMMONROOT . "/lib/header.inc");
               include(_SYSCOMMONROOT . "/lib/userheader.inc");
            } 
            else
            {
               include(_SYSCOMMONROOT . "/lib/header.inc");
               include(_SYSCOMMONROOT . "/lib/userheader.inc");
            } 
            print("<BR><BR><CENTER>" . $owl_lang->sessinuse);
            if ($parent == "" || $fileid == "")
            {
               fPrintButton("$default->owl_root_url/index.php", "btn_login");
            }
            else 
            {
               fPrintButton("$default->owl_root_url/index.php?parent=$parent&fileid=$fileid", "btn_login");
            }
            if (file_exists(_SYSCOMMONROOT . "/lib/footer.inc"))
            {
               include(_SYSCOMMONROOT . "/lib/footer.inc");
            } 
            else
            {
               include(_SYSCOMMONROOT . "/lib/footer.inc");
            } 
            exit;
         } 
      } 
   } 
   return $verified;
} 

function delTree($fid)
{
   global $fCount, $folderList, $default; 
   // delete from database
   $sql = new Owl_DB;
   $del = new Owl_DB;
   $sql->query("DELETE from $default->owl_folders_table where id = '$fid'");
   $sql->query("DELETE from $default->owl_monitored_folder_table where fid = '$fid'");

   $sql->query("SELECT id from $default->owl_files_table where parent = '$fid'"); 
   // Clean up Comments and Monitored Files from each file we are going to
   // delete
   while ($sql->next_record())
   {
      $iFileid = $sql->f("id");
      $del->query("DELETE from $default->owl_monitored_file_table where fid = '$iFileid'");
      $del->query("DELETE from $default->owl_comment_table where fid = '$iFileid'");
      if (!$default->owl_use_fs)
      {
         $del->query("DELETE from $default->owl_files_data_table  where id = '$iFileid'");
      } 
   } 
   $sql->query("DELETE from $default->owl_files_table where parent = '$fid'");

   for ($c = 0; $c < $fCount; $c++)
   {
      if ($folderList[$c][2] == $fid)
      {
         delTree($folderList[$c][0]);
      } 
   } 
} 

function find_path($parent)
{
   global $default;
   $path = fid_to_name($parent);
   $sql = new Owl_DB;
   while ($parent != 1)
   {
      $sql->query("select parent from $default->owl_folders_table where id = '$parent'");
      while ($sql->next_record())
      {
         $path = fid_to_name($sql->f("parent")) . "/" . $path;
         $parent = $sql->f("parent");
      } 
   } 
   return $path;
} 

function fid_to_filename($id)
{
   global $default;
   $sql = new Owl_DB;
   $sql->query("select filename from $default->owl_files_table where id = '$id'");
   while ($sql->next_record()) return $sql->f("filename");
} 

function fid_to_name($parent)
{
   global $default;
   $sql = new Owl_DB;
   $sql->query("select name from $default->owl_folders_table where id = '$parent'");
   while ($sql->next_record())
   {
      return $sql->f("name");
   } 
} 

function flid_to_name($id)
{
   global $default;
   $sql = new Owl_DB;
   $sql->query("select name from $default->owl_files_table where id = '$id'");
   while ($sql->next_record()) return $sql->f("name");
} 

function flid_to_filename($id)
{
   global $default;
   $sql = new Owl_DB;
   $sql->query("select filename from $default->owl_files_table where id = '$id'");
   while ($sql->next_record()) return $sql->f("filename");
} 

function owlusergroup($userid)
{
   global $default;
   $sql = new Owl_DB;
   $sql->query("select groupid from $default->owl_users_table where id = '$userid'");
   while ($sql->next_record()) $groupid = $sql->f("groupid");
   return $groupid;
} 

function owlfilecreator($fileid)
{
   global $default;
   $filecreator = 0;
   $sql = new Owl_DB;
   $sql->query("select creatorid from " . $default->owl_files_table . " where id = '$fileid'");
   while ($sql->next_record()) $filecreator = $sql->f("creatorid");
   return $filecreator;
} 

function owlfoldercreator($folderid)
{
   global $default;
   $foldercreator = 0;
   $sql = new Owl_DB;
   $sql->query("select creatorid from " . $default->owl_folders_table . " where id = '$folderid'");
   while ($sql->next_record()) $foldercreator = $sql->f("creatorid");
   return $foldercreator;
} 
function owlfiletype ($fileid)
{
   global $default;
   $filecreator = 0;
   $sql = new Owl_DB;
   $sql->query("select url from " . $default->owl_files_table . " where id = '$fileid'");
   while ($sql->next_record()) $filetype = $sql->f("url");
   return $filetype;
} 
function owlfilegroup($fileid)
{
   global $default;
   $filegroup = 0;
   $sql = new Owl_DB;
   $sql->query("select groupid from $default->owl_files_table where id = '$fileid'");
   while ($sql->next_record()) $filegroup = $sql->f("groupid");
   return $filegroup;
} 

function owlfoldergroup($folderid)
{
   global $default;
   $foldergroup = 0;
   $sql = new Owl_DB;
   $sql->query("select groupid from $default->owl_folders_table where id = '$folderid'");
   while ($sql->next_record()) $foldergroup = $sql->f("groupid");
   return $foldergroup;
} 

function owlfolderparent($folderid)
{
   global $default;
   $sql = new Owl_DB;
   $sql->query("select parent from $default->owl_folders_table where id = '$folderid'");
   while ($sql->next_record()) $folderparent = $sql->f("parent");
   return $folderparent;
} 

function owlfileparent($fileid)
{
   global $default;
   $sql = new Owl_DB;
   $sql->query("select parent from $default->owl_files_table where id = '$fileid'");
   while ($sql->next_record()) $fileparent = $sql->f("parent");
   return $fileparent;
} 

function fid_to_creator($id)
{
   global $default;
   $sql = new Owl_DB;
   $sql->query("select creatorid from " . $default->owl_files_table . " where id = '$id'");
   $sql2 = new Owl_DB;
   while ($sql->next_record())
   {
      $creatorid = $sql->f("creatorid");
      $sql2->query("select name from $default->owl_users_table where id = '" . $creatorid . "'");
      $sql2->next_record();
      $name = $sql2->f("name");
   } 
   return $name;
} 

function group_to_name($id)
{
   global $default;
   $sql = new Owl_DB;
   $sql->query("select name from $default->owl_groups_table where id = '$id'");
   while ($sql->next_record()) return $sql->f("name");
} 

function uid_to_name($id)
{
   global $default;
   $name = "";
   $sql = new Owl_DB;
   $sql->query("select name from $default->owl_users_table where id = '$id'");
   while ($sql->next_record()) $name = $sql->f("name");
   if ($name == "") $name = "Owl";
   return $name;
} 

function prefaccess($id)
{
   global $default;
   $prefaccess = 1;
   $sql = new Owl_DB;
   $sql->query("select noprefaccess from $default->owl_users_table where id = '$id'");
   while ($sql->next_record()) $prefaccess = !($sql->f("noprefaccess"));
   return $prefaccess;
} 
// only get dir path from db
function get_dirpath($parent)
{
   global $default;
   global $sess, $expand;
   $name = fid_to_name($parent);
   $navbar = "$name";
   $new = $parent;
   while ($new != "1")
   {
      $sql = new Owl_DB;
      $sql->query("select parent from $default->owl_folders_table where id = '$new'");
      while ($sql->next_record()) $newparentid = $sql->f("parent");
      if ($newparentid == "") break;
      $name = fid_to_name($newparentid);
      $navbar = "$name/" . $navbar;
      $new = $newparentid;
   } 
   return $navbar;
} 

function get_dirpathfs($parent)
{
   global $default;
   global $sess, $expand;
   $name = fid_to_name($parent);
   $navbar = "$name";
   $new = $parent;
   while ($new != "1")
   {
      $sql = new Owl_DB;
      $sql->query("select parent from $default->owl_folders_table where id = '$new'");
      while ($sql->next_record()) $newparentid = $sql->f("parent");
      if ($newparentid == "") break;
      $name = fid_to_name($newparentid);
      $navbar = "$name\\" . $navbar;
      $new = $newparentid;
   } 
   return $navbar;
} 

function fIsNewsAdmin($userid)
{
   global $default;

   $sql = new Owl_DB;
   $sql->query("SELECT newsadmin from $default->owl_users_table where id = '$userid'");
   $sql->next_record();
   if ($sql->f("newsadmin") == 1)
   {
      return true;
   } 
   return false;
} 

function gen_filesize($file_size)
{
   global $owl_lang;

   if (ereg("[^0-9]", $file_size)) return $file_size;

   if ($file_size >= 1073741824)
   {
      $file_size = round($file_size / 1073741824 * 100) / 100 . $owl_lang->file_size_gigabyte;
   } elseif ($file_size >= 1048576)
   {
      $file_size = round($file_size / 1048576 * 100) / 100 . $owl_lang->file_size_megabyte;
   } elseif ($file_size >= 1024)
   {
      $file_size = round($file_size / 1024 * 100) / 100 . $owl_lang->file_size_kilobyte;
   } 
   else
   {
      $file_size = $file_size . $owl_lang->file_size_byte;
   } 
   return $file_size;
} 

function uploadCompat($varname)
{
   global $HTTP_POST_FILES;

   if ($_FILES[$varname]) return $_FILES[$varname];
   if ($HTTP_POST_FILES[$varname]) return $HTTP_POST_FILES[$varname];
   $tmp = "$varname_name";
   global $$tmp;
   $retfile['name'] = $$tmp;
   $tmp = "$varname_type";
   global $$tmp;
   $retfile['type'] = $$tmp;
   $tmp = "$varname_size";
   global $$tmp;
   $retfile['size'] = $$tmp;
   $tmp = "$varname_error";
   global $$tmp;
   $retfile['error'] = $$tmp;
   $tmp = "$varname_tmp_name";
   global $$tmp;
   $retfile['tmp_name'] = $$tmp;
   return $retfile;
} 

function fGetMimeType ($filename)
{
   global $default;

   $mimeType = "application/octet-stream";

   if ($filetype = strrchr($filename, "."))
   {
      $filetype = substr($filetype, 1);
      $sql = new Owl_DB;
      $sql->query("select * from $default->owl_mime_table where filetype = '$filetype'");
      while ($sql->next_record()) $mimeType = $sql->f("mimetype");
   } 
   return $mimeType;
} 

if ($sess)
{
   gethtmlprefs();
   $ok = verify_session($sess);
   $temporary_ok = $ok["bit"];
   $userid = $ok["userid"];
   $usergroupid = $ok["groupid"];
   if ($ok["bit"] != "1")
   { 
      if (file_exists(_SYSCOMMONROOT . "/lib/header.inc"))
      {
         include(_SYSCOMMONROOT . "/lib/header.inc");
         include(_SYSCOMMONROOT . "/lib/userheader.inc");
      } 
      else
      {
         include(_SYSCOMMONROOT . "/lib/header.inc");
         include(_SYSCOMMONROOT . "/lib/userheader.inc");
      } 
      print("<BR><BR><CENTER>" . $owl_lang->invalidsess);
      if ($parent == "" || $fileid == "")
      {
         fPrintButton("$default->owl_root_url/index.php", "btn_login");
      }
      else
      {
         fPrintButton("$default->owl_root_url/index.php?parent=$parent&fileid=$fileid", "btn_login");
      }   
      if (file_exists(_SYSCOMMONROOT . "/lib/footer.inc"))
      {
         include(_SYSCOMMONROOT . "/lib/footer.inc");
      }
      else
      {
         include(_SYSCOMMONROOT . "/lib/footer.inc");
      }
      exit;
   } 
   else
   {
      $lastused = time();
      $sql = new Owl_DB;
      $sql->query("update $default->owl_sessions_table set lastused = '$lastused' where uid = '$userid' and sessid = '$sess'");
   } 
} 
function checkrequirements()
{
   global $default;
   global $owl_lang;

   if (substr(phpversion(), 0, 5) < $default->phpversion)
   {
      print("<CENTER><H3>$owl_lang->err_bad_version_1<BR>");
      print("$default->phpversion<BR>");
      print("$owl_lang->err_bad_version_2<BR>");
      print phpversion();
      print("<BR>$owl_lang->err_bad_version_3</H3></CENTER>");
      return 1;
   } 
   if ($default->debug == true)
   {
      if (!file_exists($default->owl_tmpdir))
      {
         print("<CENTER><H3>$owl_lang->err_tmpdir_not_exists<BR>");
         print("$default->owl_tmpdir</H3>");
         return 1;
      } 
      else
      {
         if (!is_writable($default->owl_tmpdir))
         {
            print("<CENTER><H3>$owl_lang->err_tmpdir_not_writable<BR>");
            print("$default->owl_tmpdir</H3>");
            return 1;
         } 
      } 
      if(ini_get('safe_mode') == 1)
      {
            print("<CENTER><H3>OWL REQUIRES SAFE MODE TO BE Off<BR>");
            return 1;
      }
   } 

   return 0;
} 

function myExec($_cmd, &$lines, &$errco)
{
   $cmd = "$_cmd ; echo $?";
   exec($cmd, $lines); 
   // Get rid of the last errco line...
   $errco = (integer) array_pop($lines);
   if (count($lines) == 0)
   {
      return "";
   } 
   else
   {
      return $lines[count($lines) - 1];
   } 
} 

function myDelete($file)
{
   if (file_exists($file))
   { 
      if (is_dir($file))
      {
         $handle = opendir($file);
         while ($filename = readdir($handle))
         {
            if ($filename != "." && $filename != "..")
            {
               myDelete($file . "/" . $filename);
            } 
         } 
         closedir($handle);
         rmdir($file);
      } 
      else
      {
         unlink($file);
      } 
   } 
} 

function printError($message, $submessage = "")
{
   global $default;
   global $sess, $parent, $expand, $order, $sortorder , $sortname, $userid;
   global $language;
   global $owl_lang;

   if (file_exists(_SYSCOMMONROOT . "/lib/header.inc"))
   {
      include_once(_SYSCOMMONROOT . "/lib/header.inc");
      include_once(_SYSCOMMONROOT . "/lib/userheader.inc");
   } 
   else
   {
      include_once(_SYSCOMMONROOT . "/lib/header.inc");
      include_once(_SYSCOMMONROOT . "/lib/userheader.inc");
   } 
   if (isset($parent))
   {
      if (check_auth($parent, "folder_view", $userid) != "1")
      {
         $sql = new Owl_DB;
         $sql->query("select * from $default->owl_folders_table where id = '$parent'");
         $sql->next_record();
         $parent = $sql->f("parent");
      } 
   } 

   echo("<TABLE WIDTH=$default->table_expand_width BGCOLOR=\"#d0d0d0\" CELLSPACING=0 CELLPADDING=0 BORDER=0 HEIGHT=30>");
   echo("<TR><TD ALIGN=LEFT>");
   print("$owl_lang->user: ");
   if (prefaccess($userid))
   {
      print("<A HREF='prefs.php?owluser=$userid&sess=$sess&expand=$expand&parent=$parent&order=$order&sortname=$sortname'>");
   } 
   print uid_to_name($userid);
   print ("</A><FONT SIZE=-1>");
   if ($sess != "0")
   {
      fPrintButton("index.php?login=logout&sess=$sess", "btn_logout");
   }
   else
   {
      fPrintButton("index.php?login=1", "btn_login");
   }

   print("</FONT></TD><TD ALIGN=RIGHT>");
   if (file_exists("browse.php"))
   {
      fPrintButton("browse.php?sess=$sess&parent=$parent&expand=$expand&order=$order&$sortorder=$sortname", "btn_browse");
   } 
   else
   {
      fPrintButton("../browse.php?sess=$sess", "btn_browse");
   } 
   print("</TD></TR></TABLE><BR><BR><CENTER>");
   print("<TABLE><TR>");
   print("<TD><IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_icons/error.gif' BORDER=0>");
   print("<TD>");
   print $message;
   print("<BR>");
   print $submessage;
   print("</TD</TR></TABLE>");
   if (file_exists(_SYSCOMMONROOT . "/lib/footer.inc"))
   {
      include(_SYSCOMMONROOT . "/lib/footer.inc");
   } 
   else
   {
      include(_SYSCOMMONROOT . "/lib/footer.inc");
   } 
   exit();
} 

function getprefs ()
{
   global $default;

   define ("LOGIN", "1");
   define ("LOGIN_FAILED", "2");
   define ("LOGOUT", "3");
   define ("FILE_DELETED", "4");
   define ("FILE_UPLOAD", "5");
   define ("FILE_UPDATED", "6");
   define ("FILE_DOWNLOADED", "7");
   define ("FILE_CHANGED", "8");
   define ("FILE_LOCKED", "9");
   define ("FILE_UNLOCKED", "10");
   define ("FILE_EMAILED", "11");
   define ("FILE_MOVED", "12");
   define ("FOLDER_CREATED", "13");
   define ("FOLDER_DELETED", "14");
   define ("FOLDER_MODIFIED", "15");
   define ("FOLDER_MOVED", "16");
   define ("FORGOT_PASS", "17");
   define ("USER_REG", "18");

   $sql = new Owl_DB;
   $sql->query("select * from $default->owl_prefs_table");
   $sql->next_record();

   $default->owl_email_from = $sql->f("email_from");
   $default->owl_email_fromname = $sql->f("email_fromname");
   $default->owl_email_replyto = $sql->f("email_replyto");
   $default->owl_email_server = $sql->f("email_server");
   $default->owl_email_subject = $sql->f("email_subject");
   $default->use_smtp = $sql->f("use_smtp");
   $default->use_smtp_auth = $sql->f("use_smtp_auth");
   $default->smtp_passwd = $sql->f("smtp_passwd"); 
   // 
   // LookAtHD is not supported with $default->owl_use_fs = false
   // 
   if ($default->owl_use_fs)
   {
      $default->owl_LookAtHD = $sql->f("lookathd");
   } 
   else
   {
      if (substr(php_uname(), 0, 7) == "Windows")
      {
         $default->owl_compressed_database = 0;
      } 
      $default->owl_LookAtHD = "false";
   } 

   $default->owl_lookAtHD_del = $sql->f("lookathddel");
   $default->owl_def_file_security = $sql->f("def_file_security");
   $default->owl_def_file_group_owner = $sql->f("def_file_group_owner");
   $default->owl_def_file_owner = $sql->f("def_file_owner");
   $default->owl_def_file_title = $sql->f("def_file_title");
   $default->owl_def_file_meta = $sql->f("def_file_meta");
   $default->owl_def_fold_security = $sql->f("def_fold_security");
   $default->owl_def_fold_group_owner = $sql->f("def_fold_group_owner");
   $default->owl_def_fold_owner = $sql->f("def_fold_owner");
   $default->max_filesize = $sql->f("max_filesize");
   $default->owl_timeout = $sql->f("timeout");
   if ($sql->f("tmpdir") == "")
   {
      $default->owl_tmpdir = $default->owl_FileDir;
      $default->owl_tmpdir .= "/" . fid_to_name(1);
   } 
   else
   {
      $default->owl_tmpdir = $sql->f("tmpdir");
   } 
   $default->expand = $sql->f("expand");
   $default->owl_version_control = $sql->f("version_control");
   $default->restrict_view = $sql->f("restrict_view");
   $default->dbdump_path = $sql->f("dbdump_path");
   $default->gzip_path = $sql->f("gzip_path");
   $default->tar_path = $sql->f("tar_path");
   $default->unzip_path = $sql->f("unzip_path");
   $default->pod2html_path = $sql->f("pod2html_path");
   $default->pdftotext_path = $sql->f("pdftotext_path");
   $default->file_perm = $sql->f("file_perm");
   $default->folder_perm = $sql->f("folder_perm");

   $default->anon_ro = $sql->f("anon_ro");
   $default->anon_user = $sql->f("anon_user");
   $default->file_admin_group = $sql->f("file_admin_group");

   $default->hide_backup = $sql->f("hide_backup");

   $default->collect_trash = $sql->f("collect_trash");
   if ($sql->f("trash_can_location") == "")
   {
      $default->trash_can_location = $default->owl_FileDir . "/TrashCan";
   } 
   else
   {
      $default->trash_can_location = $sql->f("trash_can_location");
   } 

   $default->allow_popup = $sql->f("allow_popup");
   $default->status_bar_location = $sql->f("status_bar_location");
   $default->hide_bulk = $sql->f("hide_bulk"); 
   // 
   // Logging options
   // 
   $default->logging = $sql->f("logging");
   $default->log_file = $sql->f("log_file");
   $default->log_login = $sql->f("log_login");
   $default->log_rec_per_page = $sql->f("log_rec_per_page"); 
   // 
   // Self Register options
   // 
   $default->self_reg = $sql->f("self_reg");
   $default->self_reg_quota = $sql->f("self_reg_quota");
   $default->self_reg_notify = $sql->f("self_reg_notify");
   $default->self_reg_attachfile = $sql->f("self_reg_attachfile");
   $default->self_reg_disabled = $sql->f("self_reg_disabled");
   $default->self_reg_noprefacces = $sql->f("self_reg_noprefacces");
   $default->self_reg_maxsessions = $sql->f("self_reg_maxsessions");
   $default->self_reg_group = $sql->f("self_reg_group");
   $default->forgot_pass = $sql->f("forgot_pass");
   $default->records_per_page = $sql->f("rec_per_page");
};

function printfileperm($currentval, $namevariable, $printmessage, $type)
{
   global $default;
   global $owl_lang;

   $file_perm[0][0] = 0;
   $file_perm[1][0] = 1;
   $file_perm[2][0] = 2;
   $file_perm[3][0] = 3;
   $file_perm[4][0] = 4;
   $file_perm[5][0] = 5;
   $file_perm[6][0] = 6;
   $file_perm[7][0] = 7;
   $file_perm[8][0] = 8;

   if ($type == "admin")
   {
      $file_perm[0][1] = "$owl_lang->everyoneread_ad";
      $file_perm[1][1] = "$owl_lang->everyonewrite_ad";
      $file_perm[2][1] = "$owl_lang->groupread_ad";
      $file_perm[3][1] = "$owl_lang->groupwrite_ad";
      $file_perm[4][1] = "$owl_lang->onlyyou_ad";
      $file_perm[5][1] = "$owl_lang->groupwrite_ad_nod";
      $file_perm[6][1] = "$owl_lang->everyonewrite_ad_nod";
      $file_perm[7][1] = "$owl_lang->groupwrite_worldread_ad";
      $file_perm[8][1] = "$owl_lang->groupwrite_worldread_ad_nod";
   } 
   else
   {
      $file_perm[0][1] = "$owl_lang->everyoneread";
      $file_perm[1][1] = "$owl_lang->everyonewrite";
      $file_perm[2][1] = "$owl_lang->groupread";
      $file_perm[3][1] = "$owl_lang->groupwrite";
      $file_perm[4][1] = "$owl_lang->onlyyou";
      $file_perm[5][1] = "$owl_lang->groupwrite_nod";
      $file_perm[6][1] = "$owl_lang->everyonewrite_nod";
      $file_perm[7][1] = "$owl_lang->groupwrite_worldread";
      $file_perm[8][1] = "$owl_lang->groupwrite_worldread_nod";
   } 

   print("<TR>\n<TD ALIGN='RIGHT' BGCOLOR='$default->table_header_bg'>$printmessage</TD>\n<TD align=left><SELECT NAME=$namevariable>");
   foreach($file_perm as $fp)
   {
      print("<OPTION VALUE=$fp[0] ");
      if ($fp[0] == $currentval)
      {
         print("SELECTED");
      }
      print(">$fp[1]");
   } 
   print("</SELECT></TD></TR>");
} ;

function owl_syslog($action, $userid, $filename, $logparent, $detail, $type)
{
   global $default;

   if ($default->logging == 1)
   {
      $sql = new Owl_DB;
      $log = 0;

      $logdate = date("Y-m-d G:i:s");
      if ($_SERVER["HTTP_CLIENT_IP"])
      {
         $ip = $_SERVER["HTTP_CLIENT_IP"];
      } elseif ($_SERVER["HTTP_X_FORWARDED_FOR"])
      {
         $forwardedip = $_SERVER["HTTP_X_FORWARDED_FOR"];
         list($ip, $ip2, $ip3, $ip4) = split (",", $forwardedip);
      } 
      else
      {
         $ip = $_SERVER["REMOTE_ADDR"];
      } 
      $agent = $_SERVER["HTTP_USER_AGENT"];
      if ($default->log_file == 1 && $type == "FILE")
      {
         $log = 1;
      } 
      if ($default->log_login == 1 && $type == "LOGIN")
      {
         $log = 1;
      } 
      if ($log == 1)
      {
         $sql->query("INSERT into $default->owl_log_table (userid, filename, action, parent, details, logdate, ip, agent, type) values ('$userid', '$filename', '$action', '$logparent', '$detail', '$logdate', '$ip', '$agent', '$type');");
      } 
   } 
} 


function change_ownership_perms($file, $id, $parent, $fileowner, $groupid, $policy)
{
   global $default;
   if (is_dir($default->owl_FileDir . "/" . find_path($parent) . "/" . $file)) 
   {
      $sql = new Owl_DB;
      $sql->query("UPDATE $default->owl_folders_table SET creatorid='$fileowner', groupid='$groupid', security='$policy' WHERE id='$id'");
      $filespolicy=$policy-50;
      $sql = new Owl_DB;
      $sql->query("UPDATE $default->owl_files_table SET creatorid='$fileowner', groupid='$groupid', security='$filespolicy' where parent='$id'");
   
      $sql = new Owl_DB;
      $sql->query("SELECT name, id from $default->owl_folders_table where parent='$id'");
      while($sql->next_record())
      {
         $newfile = $sql->f("name");
         $newid = $sql->f("id");
         change_ownership_perms($newfile, $newid, $id, $fileowner, $groupid, $policy);
      }
   } 
   else 
   {
   // this is if the file isn't a directory..  should never happen.
   }
}


function printgroupperm($currentval, $namevariable, $printmessage, $type)
{
   global $default;
   global $owl_lang;

   $group_perm[0][0] = 50;
   $group_perm[1][0] = 51;
   $group_perm[2][0] = 52;
   $group_perm[3][0] = 53;
   $group_perm[4][0] = 54;
   $group_perm[5][0] = 55;
   $group_perm[6][0] = 56;
   $group_perm[7][0] = 57;
   $group_perm[8][0] = 58;

   if ($type == "admin")
   {
      $group_perm[0][1] = "$owl_lang->geveryoneread_ad";
      $group_perm[1][1] = "$owl_lang->geveryonewrite_ad";
      $group_perm[2][1] = "$owl_lang->ggroupread_ad";
      $group_perm[3][1] = "$owl_lang->ggroupwrite_ad";
      $group_perm[4][1] = "$owl_lang->gonlyyou_ad";
      $group_perm[5][1] = "$owl_lang->ggroupwrite_ad_nod";
      $group_perm[6][1] = "$owl_lang->geveryonewrite_ad_nod";
      $group_perm[7][1] = "$owl_lang->ggroupwrite_worldread_ad";
      $group_perm[8][1] = "$owl_lang->ggroupwrite_worldread_ad_nod";
   } 
   else
   {
      $group_perm[0][1] = "$owl_lang->geveryoneread";
      $group_perm[1][1] = "$owl_lang->geveryonewrite";
      $group_perm[2][1] = "$owl_lang->ggroupread";
      $group_perm[3][1] = "$owl_lang->ggroupwrite";
      $group_perm[4][1] = "$owl_lang->gonlyyou";
      $group_perm[5][1] = "$owl_lang->ggroupwrite_nod";
      $group_perm[6][1] = "$owl_lang->geveryonewrite_nod";
      $group_perm[7][1] = "$owl_lang->ggroupwrite_worldread";
      $group_perm[8][1] = "$owl_lang->ggroupwrite_worldread_nod";
   } 

   print("<TR>\n<TD ALIGN='RIGHT' BGCOLOR='$default->table_header_bg'>$printmessage</TD>\n<TD align=left><SELECT NAME=$namevariable>");
   foreach($group_perm as $fp)
   {
      print("<OPTION VALUE=$fp[0] ");
      if ($fp[0] == $currentval)
         print("SELECTED");
      print(">$fp[1]");
   } 
   print("</SELECT></TD></TR>");
} ;

function get_title_tag($chaine)
{
   $fp = fopen ($chaine, 'r');
   while (! feof ($fp))
   {
      $contenu .= fgets ($fp, 1024);
      if (stristr($contenu, '</title>'))
      {
         break;
      } 
   } 
   if (eregi("<title>(.*)</title>", $contenu, $out))
   {
      return $out[1];
   } 
   else
   {
      return false;
   } 
} 

function RndInt($Format)
{
   switch ($Format)
   {
      case "letter":
         $Rnd = rand(0, 25);
         if ($Rnd > 25)
         {
            $Rnd = $Rnd - 1;
         } 
         break;
      case "number":
         $Rnd = rand(0, 9);
         if ($Rnd > 9)
         {
            $Rnd = $Rnd - 1;
         } 
         break;
   } 
   return $Rnd;
} 

function GenRandPassword()
{
   /**
    * RANDOM PASSWORD GENERATION ALGORITHM
    * PROGRAMMED BY: BRIAN GRIFFIN
    * January 1, 2003
    * MXrider005@hotmail.com
    * 
    * You can use this freely. Just don't credit it as your own work! And please e-mail me if you do just to let me know. Thanks.
    */
   // DEFINE STRINGS TO USE FOR CHARACTER C // OMBINATIONS IN THE PASSWORD
   $LCase = "abcdefghijklmnopqrstuvwxyz";
   $UCase = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
   $Integer = "0123456789"; 
   // DEFINE CONSTANTS FOR ALGORTTHM
   define("LEN", "1");
   /**
    * THIS FUNCTION GENERATES A RANDOM NUMBER THAT WILL BE USED TO
    * RANDOMLY SELECT CHARACTERS FROM THE STRINGS ABOVE
    */

   /**
    * RUN THE FUNCTION TO GENERATE RANDOM INTEGERS FOR EACH OF THE
    * 6 CHARACTERS IN THE PASSWORD PRODUCED.
    */
   $a = RndInt("letter");
   $b = RndInt("letter");
   $c = RndInt("letter");
   $d = RndInt("letter");
   $e = RndInt("number");
   $f = RndInt("number"); 
   // EXTRACT 6 CHARACTERS RANDOMLY FROM TH // E DEFINITION STRINGS
   $L1 = substr($LCase, $a, LEN);
   $L2 = substr($LCase, $b, LEN);
   $U1 = substr($UCase, $c, LEN);
   $U2 = substr($UCase, $d, LEN);
   $I1 = substr($Integer, $e, LEN);
   $I2 = substr($Integer, $f, LEN); 
   // COMBINE THE CHARACTERS AND DISPLAY TH // E NEW PASSWORD
   $PW = $L1 . $U2 . $I1 . $L2 . $I2 . $U1;
   return $PW;
} 

if (!$sess && !$loginname && !$login)
{
   if (!isset($fileid))
   {
      $sql = new Owl_DB;
      $sql->query("select * from $default->owl_users_table where id = '$default->anon_user'");
      $sql->next_record();
      if ($sql->num_rows() == 1)
      {
         $accountname = $sql->f("name");
         if ($sql->f("disabled") != 1)
            $userid = $default->anon_user;
         else
         {
            if ($_SERVER["PHP_SELF"] != $default->owl_root_url . "/register.php")
               header("Location: " . $default->owl_root_url . "/index.php?login=1");
         } 
      } 
      else
      {
         if ($_SERVER["PHP_SELF"] != $default->owl_root_url . "/register.php")
            header("Location: " . $default->owl_root_url . "/index.php?login=1&failure=4");
      } 
   } 
   else
   {
      header("Location: " . $default->owl_root_url . "/index.php?login=1&fileid=$fileid&parent=$parent");
   } 
} 

if (!$sess && $loginname)
{
   $sql = new Owl_DB;
   $sql->query("select * from $default->owl_users_table where id = '$default->anon_user'");
   $sql->next_record();
   if ($sql->num_rows() == 1)
   {
      if ($sql->f("disabled") != 1)
      {
         $userid = $default->anon_user;
      } 
      else
      {
         header("Location: " . $default->owl_root_url . "/index.php?login=1");
      } 
   } 
   else
   {
      header("Location: " . $default->owl_root_url . "/index.php?login=1");
   } 
} 

if (!$sess && $login)
{
   if ($_SERVER["PHP_SELF"] != $default->owl_root_url . "/index.php")
      header("Location: " . $default->owl_root_url . "/index.php?login=1");
} 
// 
// PDF and Text File Search Index Functions BEGIN
// 
// DoesFileIDContainKeyword:  Pass a file id from the files table and a keyword.
// pretty quickly tells you if that keyword is in that file, actually very quickly.

function DoesFileIDContainKeyword($fileid, $keyword)
{
   global $default;
   $sql = new Owl_DB;
   $sql->query("SELECT * from $default->owl_wordidx where word='$keyword'");
   if ($sql->num_rows() > 0)
   {
      $sql->next_record();
      $keywordid = $sql->f("wordid");
   }
   else
   {
      $keywordid = -1;
   }

   $sql->query("SELECT * from $default->owl_searchidx where wordid='$keywordid' and owlfileid = '$fileid'");

   return $sql->num_rows();
} 

function IndexATextFile($filename, $owlfileid)
{
   global $default;

   $fileidnum = $owlfileid;

   $sql = new Owl_DB;
   $sql->query("SELECT * from $default->owl_wordidx"); //Import all words and indexes
   $nextwordindex = 1;
   $wordindex = array();
   while ($sql->next_record()) // this may get ugly, we could have 100K words and indexes, they gotta go into memory.
   {
      $wordindex[$sql->f("word")] = $sql->f("wordid");
      if ($sql->f("wordid") > $nextwordindex)
      {
         $nextwordindex = $sql->f("wordid"); //get largest word index in table
      } 
   } 
   // Note: again, here we've just read in the big wordidx, we should index as many
   // files as possible while we have this index in memory, here we
   // only index a single filename, but if someone wants to greatly improve performance,
   // index an array of filenames here...
   $fp = fopen($filename, "rb");
   while (!feof($fp))
   {
      $line = fgets($fp, 256);
      $line = strtolower($line);
      $wordtemp = preg_split("/\W/", $line); //split line into words a word is any # of A-Za-z's separated by somethign not a-zA-Z
      if (!isset($wordtemp)) continue;

      foreach($wordtemp as $wd)
      {
         $words[$wd]++; //keep a count of how often each word is seen
         if ($words[$wd] == 1) // if this is the first time we've seen this word in this document...
            {
               if ($wordindex[$wd]) // if this word was already in the wordidx table...
                  {
                     $sql->query("INSERT into $default->owl_searchidx values('$wordindex[$wd]','$fileidnum')"); //add a searchidx table entry for this fileidnum (owlidnum)
               } 
               else // if word not in word index, add to both wordidx and searchidx
                  {
                     $wordindex[$wd] = $nextwordindex; //first remember this word as being in the wordindex
                  $sql->query("INSERT into $default->owl_searchidx values('$wordindex[$wd]', '$fileidnum')"); //add pointer to owlidnum for this wordindexnum
                  $wd = ereg_replace("'", "\\'" , $wd);
                  $sql->query("INSERT into $default->owl_wordidx values('$nextwordindex', '$wd')");
                  $nextwordindex++;
               } 
            } //if first instance of this word...
         } //for each word
      } //while!feof
   } 
   // When a file gets delete/removed, this should be called to update the indexing
   // tables
   function fDeleteFileIndexID($fidtoremove)
   {
      global $default;
      $sql = new Owl_DB;

      $sql->query("delete from $default->owl_searchidx where owlfileid = $fidtoremove");
      // Note, I'm leaving the wordidx table alone, it can only grow so large as
      // there are only so many words in the language, will make indexing future items a bit faster methinks
   } 

   function fIndexAFile($new_name, $newpath, $id)
   {
      global $default; 
      // IF the file was inserted in the database now INDEX it for SEARCH.
      $sSearchExtension = fFindFileExtension($new_name);

      if ($sSearchExtension == 'pdf' || $sSearchExtension == 'c' || $sSearchExtension == 'html' || $sSearchExtension == 'htm' || $sSearchExtension == 'php' || $sSearchExtension == 'pl' || $sSearchExtension == 'txt')
      {
         if ($sSearchExtension == 'pdf')
         {
            $command = $default->pdftotext_path . '  "' . $newpath . '" "' . $default->owl_tmpdir . "/" . $new_name . '.text"';
            system($command);
            IndexATextFile($default->owl_tmpdir . "/" . $new_name . '.text', $id);
            unlink($default->owl_tmpdir . "/" . $new_name . '.text');
         } 
         else
         {
            IndexATextFile($newpath, $id);
         } 
      } 
   } 
   // 
   // PDF and Text File Search Index Functions END
   // 
   function fFindFileExtension ($filename)
   {
      $filesearch = explode('.', $filename);
      $extensioncounter = 0;
      while ($filesearch[$extensioncounter + 1] != null)
      { 
         // pre-append a "." separator in the name for each
         // subsequent part of the the name of the file.
         if ($extensioncounter != 0)
         {
            $firstpart = $firstpart . ".";
         } 
         $firstpart = $firstpart . $filesearch[$extensioncounter];
         $extensioncounter++;
      } 
      if ($extensioncounter == 0)
      {
         $firstpart = $filename;
         $file_extension = '';
      } 
      else
      {
         $file_extension = $filesearch[$extensioncounter];
      } 
      return strtolower($file_extension);
   } 

if (!function_exists("file_get_contents")) 
{
   function file_get_contents($filename, $use_include_path = 0) 
   {
      $data = ""; // just to be safe. Dunno, if this is really needed
      $file = @fopen($filename, "rb", $use_include_path);
      if ($file) 
      {
         while (!feof($file)) $data .= fread($file, 1024);
         fclose($file);
      }
      return $data;
   }
}

?>
