<?php

/**
 * log.php
 * 
 * Copyright (c) 1999-2003 The Owl Project Team
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 * 
 * $Id: log.php,v 1.7 2003/11/12 14:25:08 b0zz Exp $
 */

//require_once("./config/owl.php");
require_once(_SYSCOMMONROOT . "/lib/disp.lib.php");
require_once(_SYSCOMMONROOT . "/lib/owl.lib.php");
require_once(_SYSCOMMONROOT . "/lib/security.lib.php");
include_once(_SYSCOMMONROOT . "/lib/header.inc");
include_once(_SYSCOMMONROOT . "/lib/userheader.inc");

// store file name and extension separately

//$filename = unserialize(stripslashes(stripslashes($filename)));
$filename = ereg_replace("<amp>","&", $filename);

$filesearch = explode('.', $filename);
$extensioncounter = 0;
while ($filesearch[$extensioncounter + 1] != null)
{ 
   // pre-append a "." separator in the name for each
   // subsequent part of the the name of the file.
   if ($extensioncounter != 0)
   {
      $firstpart = $firstpart . ".";
   } 
   $firstpart = $firstpart . $filesearch[$extensioncounter];
   $extensioncounter++;
} 
if ($extensioncounter == 0)
{
   $firstpart = $filename;
   $file_extension = '';
} 
else
{
   $file_extension = $filesearch[$extensioncounter];
} 
// Begin 496814 Column Sorts are not persistant
// + ADDED &order=$order&$sortorder=$sortname to
// all browse.php?  header and HREF LINES
switch ($order)
{
   case "name":
      $sortorder = 'sortname';
      break;
   case "major_revision":
      $sortorder = 'sortver';
      break;
   case "filename" :
      $sortorder = 'sortfilename';
      break;
   case "size" :
      $sortorder = 'sortsize';
      break;
   case "creatorid" :
      $sortorder = 'sortposted';
      break;
   case "smodified" :
      $sortorder = 'sortmod';
      break;
   case "checked_out":
      $sortorder = 'sortcheckedout';
      break;
   default:
      break;
} 
// END 496814 Column Sorts are not persistant
print("<TABLE WIDTH='$default->table_expand_width' BGCOLOR='$default->main_header_bgcolor' CELLSPACING='0' CELLPADDING='0' BORDER='$default->table_border' HEIGHT='$default->table_header_height'>");

?>
<TR><TD ALIGN=LEFT>
<?php
fPrintPrefs();

?> 

<FONT SIZE=-1>
<?php 
fPrintButton("index.php?login=logout&sess=$sess", "btn_logout");
?>
    </FONT></TD><TD ALIGN=RIGHT>
<?php 
fPrintButton("browse.php?sess=$sess&parent=$parent&expand=$expand&order=$order&$sortorder=$sortname", "btn_browse");
?>
        </TD></TR></TABLE>
<?php

print("<CENTER>");

print("<TABLE WIDTH=$default->table_expand_width BORDER=$default->table_border>");
print("<TR><TD align=left>$owl_lang->viewlog ");

$iNewParent = owlfolderparent($parent);
if ($iNewParent != 0)
{
   print("<A HREF='browse.php?sess=$sess&parent=$iNewParent&expand=$expand&order=$order&$sortorder=$sort' TITLE='$owl_lang->title_return_folder " . fid_to_name($iNewParent) . "'><img border='0' src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_nav/folder_up.gif' width ='16' height='16'></A>");
} 
else
{
   print("<img border='0' src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_nav/folder_up.gif' width ='16' height='16'>");
} 
print(gen_navbar($parent) . "/" . flid_to_name($id) . "</TD></TR>");

print("</TABLE><HR WIDTH=$default->table_expand_width><BR>$filename");

print ("<TABLE width=$default->table_expand_width border=$default->table_border cellpadding=3 cellspacing=0>
		<TR><TD BGCOLOR='$default->table_header_bg' width='5%'>$owl_lang->ver</td>
		<TD BGCOLOR='$default->table_header_bg' width='10%'>$owl_lang->user</TD>
		<TD BGCOLOR='$default->table_header_bg' width='60%'>$owl_lang->alt_log_file</TD>
		<TD BGCOLOR='$default->table_header_bg' width='25%'>$owl_lang->modified</TD></TR>");

$sql = new Owl_DB; 

// SPECIFIC SQL LOG QUERY -  NOT USED (problematic)
// This SQL log query is designed for repository assuming there is only 1
// digit in major revision, and noone decides to have a "_x-" in their
// filename.

// Has to be changed if the naming structure changes.
// Also a problem that it didn't catch the "current"
// file because of the "_x-" matching (grr)

// $sql->query("select * from $default->owl_files_table where filename LIKE '$filesearch[0]\__-%$filesearch[1]' order by major_revision desc, minor_revision desc");
// GENERIC SQL LOG QUERY - currently used.
// prone to errors when people name a set of docs
// Blah.doc
// Blah_errors.doc
// Blah_standards.doc
// etc. and search for a log on Blah.doc (it brings up all 3 docs)
// $sql->query("select * from $default->owl_files_table where filename LIKE '$filesearch[0]%$filesearch[1]' order by major_revision desc, minor_revision desc");
// $SQL = "select * from $default->owl_files_table where filename LIKE '$filesearch[0]%$filesearch[1]' order by major_revision desc, minor_revision desc";
if ($default->owl_use_fs)
{
   $sql->query("Select id from $default->owl_folders_table where name='backup' and parent='$parent'");
   if ($sql->num_rows($sql) != 0)
   {
      while ($sql->next_record())
      {
         $backup_parent = $sql->f("id");
      } 
   } 
   else
   {
      $backup_parent = $parent;
   } 
   //print("<BR><BR>select * from $default->owl_files_table where filename LIKE '" . $firstpart . "\\_%" . $file_extension . "' OR filename = '$filename' AND (parent = $backup_parent OR parent = $parent) order by major_revision desc, minor_revision desc");
   $sql->query("select * from $default->owl_files_table where filename LIKE '" . $firstpart . "\\_%" . $file_extension . "' OR filename = '$filename' AND (parent = $backup_parent OR parent = $parent) order by major_revision desc, minor_revision desc");
} 
else
{
   // name based query -- assuming that the given name for the file doesn't change...
   // at some point, we should really look into creating a "revision_id" field so that all revisions can be linked.
   // in the meanwhile, the code for changing the Title of the file has been altered to go back and
   $name = flid_to_name($id);
   $sql->query("select * from $default->owl_files_table where name='$name' AND parent='$parent' order by major_revision desc, minor_revision desc");
} 

while ($sql->next_record())
{
   $choped = split("\.", $sql->f("filename"));
   $pos = count($choped);
   $ext = strtolower($choped[$pos-1]);

   print("<TR><TD valign=top>" . $sql->f("major_revision") . "." . $sql->f("minor_revision") . "</TD>
               <TD valign=top>" . uid_to_name($sql->f("creatorid")) . "</TD>
               <TD valign=top align=left width=70%><font size=2 style='font-weight:bold'>");

   if ($sql->f("parent") == $parent)
   {
       $is_backup_folder = false;
   }
   else
   {
       $is_backup_folder = true;
   }
   printFileIcons($sql->f("id"), $sql->f("filename"), $sql->f("checked_out"), $sql->f("url"), $default->owl_version_control, $ext, $sql->f("parent"), $is_backup_folder);
   print("&nbsp&nbsp[ " . $sql->f("filename") . " ]</font><br>" . ereg_replace("\n", "<BR>", $sql->f("description")) . "</></TD>
               <TD valign=top>" . date($owl_lang->localized_date_format, strtotime($sql->f("smodified"))) . "</TD></TR>");
} 
print("</TABLE>");
include(_SYSCOMMONROOT . "/lib/footer.inc");

?>
