<?php

/**
 * modify.php
 * 
 * Copyright (c) 1999-2003 The Owl Project Team
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 * 
 * $Id: modify.php,v 1.9 2003/11/12 14:25:08 b0zz Exp $
 */

//require_once("./config/owl.php");
require_once(_SYSCOMMONROOT . "/lib/disp.lib.php");
require_once(_SYSCOMMONROOT . "/lib/owl.lib.php");
require_once(_SYSCOMMONROOT . "/lib/security.lib.php");
require_once(_SYSCOMMONROOT . "/phpid3v2/class.id3.php");

include_once(_SYSCOMMONROOT . "/lib/header.inc");
include_once(_SYSCOMMONROOT . "/lib/userheader.inc");

if ($sess == "0" && $default->anon_ro == 1)
{
   printError($owl_lang->err_login);
}

switch ($order)
{
   case "name":
      $sortorder = 'sortname';
      break;
   case "major_revision":
      $sortorder = 'sortver';
      break;
   case "filename" :
      $sortorder = 'sortfilename';
      break;
   case "size" :
      $sortorder = 'sortsize';
      break;
   case "creatorid" :
      $sortorder = 'sortposted';
      break;
   case "smodified" :
      $sortorder = 'sortmod';
      break;
   case "checked_out":
      $sortorder = 'sortcheckedout';
      break;
   default:
      break;
} 
// END 496814 Column Sorts are not persistant
function printModifyHeader()
{
   global $owl_lang, $default, $userid, $sess, $parent, $expand, $order, $sortname, $language;
  
   // Ensure that the Id of the parent is valid 
   if ($parent == 0)
   {
      $parent = 1;
   }

   print("<TABLE WIDTH='$default->table_expand_width' BGCOLOR='$default->main_header_bgcolor' CELLSPACING='0' CELLPADDING='0' BORDER='$default->table_border' HEIGHT='$default->table_header_height'>\n");
   print("<TR>\n<TD ALIGN=LEFT>");
   fPrintPrefs();
   print("<FONT SIZE=-1>");

   fPrintButton("index.php?login=logout&sess=$sess", "btn_logout");
   print("</FONT></TD><TD ALIGN=RIGHT>");
   fPrintButton("browse.php?sess=$sess&parent=$parent&expand=$expand&order=$order&$sortorder=$sortname", "btn_browse");
   print("</TD></TR></TABLE>");
   print("<CENTER>");
} 

if ($action == "file_comment")
{
   if (check_auth($id, "file_download", $userid) == 1)
   {
      printModifyHeader();
      $sql = new Owl_DB; 
      // $sql->query("SELECT * from $default->owl_comment_table where fid = '$id' order by comment_date desc ");
      $sql->query("SELECT * from $default->owl_comment_table where fid = '$id' order by id");

      print("<BR>");
      print("<TABLE WIDTH=$default->table_expand_width BORDER=$default->table_border>");
      print("<TR><TD align=left>$owl_lang->adding_comments ");
      $iNewParent = owlfolderparent($parent);
      if ($iNewParent != 0)
      {
         print("<A HREF='browse.php?sess=$sess&parent=$iNewParent&expand=$expand&order=$order&$sortorder=$sort' TITLE='$owl_lang->title_return_folder " . fid_to_name($iNewParent) . "'><img border='0' src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_nav/folder_up.gif' width ='16' height='16'></A>");
      } 
      else
      {
         print("<img border='0' src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_nav/folder_up.gif' width ='16' height='16'>");
      } 
      print(gen_navbar($parent, $id) . "</TD></TR>");

      print("</TABLE><HR WIDTH=$default->table_expand_width><BR>");
      print("<FORM enctype='multipart/form-data' ACTION='dbmodify.php' METHOD=POST>
                        <INPUT TYPE=HIDDEN NAME=order VALUE='$order'>\n
                        <INPUT TYPE=HIDDEN NAME=sortname VALUE='$sortname'>\n
                        <INPUT TYPE=HIDDEN NAME=sess VALUE='$sess'>\n
                        <INPUT TYPE=HIDDEN NAME=parent VALUE=$parent>\n
                        <INPUT TYPE=HIDDEN NAME=action VALUE=file_comment>\n
                        <INPUT TYPE=HIDDEN NAME=id VALUE='$id'>\n");
      print(" <INPUT TYPE=IMAGE  SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_buttons/btn_post_comment.gif' BORDER=0 ALT='$owl_lang->alt_add_comments' TITLE='$owl_lang->alt_add_comments' onMouseOver=this.src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_buttons/btn_post_comment_hover.gif'; onMouseOut=this.src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_buttons/btn_post_comment.gif'; VALUE='$owl_lang->sendfile'>\n");
      print("<INPUT TYPE=HIDDEN NAME=expand VALUE='$expand'>");
      print("<TABLE BORDER=$default->table_border>");
      print("<td align=left><textarea name=newcomment rows=5 cols=80 wrap=hard></textarea></tr>");
      print("</TABLE>\n");
      print("</FORM>\n");

      print("<TABLE BORDER=$default->table_border WIDTH=$default->table_expand_width>");
      $iCountlines = 0;
      while ($sql->next_record())
      {
         $sComment = ereg_replace("\n", '<BR>', $sql->f("comment"));

         print("<TR>\n<TD ALIGN='LEFT' valign='top' BGCOLOR='$default->main_header_bgcolor' rowspan='2'><B><FONT COLOR=green> " . date($owl_lang->localized_date_format, strtotime($sql->f("comment_date"))) . "</FONT></B>");
         $iFileOwner = owlfilecreator($sql->f("fid"));
         if ($usergroupid == "0" || $usergroupid == $default->file_admin_group || $iFileOwner == $userid)
         {
            print("<BR><A HREF='dbmodify.php?&sess=" . $sess . "&parent=" . $parent . "&action=del_comment&cid=" . $sql->f("id") . "&order=$order&sortname=$sortname&expand=$expand&id=$id' onClick='return confirm(\"$owl_lang->reallydelete ?\");'><IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/delete.gif' ALT='$owl_lang->alt_del_comments $file' TITLE='$owl_lang->alt_del_comments $file' BORDER=0></A>");
         } 

         print("</TD>\n<TD width='70%' BGCOLOR='$default->main_header_bgcolor' align='left'>$owl_lang->comments_added<B><FONT COLOR=green>" . uid_to_name($sql->f("userid")) . "</FONT></B></TD\n</TR>\n");
         $iCountLines++;
         $iPrintLines = $iCountLines % 2;
         if ($iPrintLines == 0)
         {
            print("\t\t\t\t<TR BGCOLOR='$default->table_cell_bg_alt'>");
         } 
         else
         {
            print("\t\t\t\t<TR BGCOLOR='$default->table_cell_bg'>");
         } 

         print("<TD align=left>" . $sComment . "</TD></TR>");
      } 
      print("</TABLE>\n");

      include(_SYSCOMMONROOT . "/lib/footer.inc");
   } 
   else
   {
      printError($owl_lang->err_adding_comments);
   } 
} 

if ($action == "file_update")
{
   if (check_auth($id, "file_modify", $userid) == 1)
   {
      printModifyHeader();
      $sql = new Owl_DB;
      $sql->query("SELECT description from $default->owl_files_table where id = '$id'");
      $sql->next_record();
      $sDescription = $sql->f("description");

      print("<BR>");
      print("<TABLE WIDTH=$default->table_expand_width BORDER=$default->table_border>");
      print("<TR><TD align=left>$owl_lang->updating ");
      $iNewParent = owlfolderparent($parent);
      if ($iNewParent != 0)
      {
         print("<A HREF='browse.php?sess=$sess&parent=$iNewParent&expand=$expand&order=$order&$sortorder=$sort' TITLE='$owl_lang->title_return_folder " . fid_to_name($iNewParent) . "'><img border='0' src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_nav/folder_up.gif' width ='16' height='16'></A>");
      } 
      else
      {
         print("<img border='0' src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_nav/folder_up.gif' width ='16' height='16'>");
      } 
      print(gen_navbar($parent, $id) . "</TD></TR>");

      print("</TABLE><HR WIDTH=$default->table_expand_width><BR>");
      print("<FORM enctype='multipart/form-data' ACTION='dbmodify.php' METHOD=POST>
                        <INPUT TYPE=HIDDEN NAME=order VALUE='$order'>
                        <INPUT TYPE=HIDDEN NAME=sortname VALUE='$sortname'>
			<INPUT TYPE=HIDDEN NAME=sess VALUE='$sess'>
			<INPUT TYPE=HIDDEN NAME=parent VALUE=$parent>
			<INPUT TYPE=HIDDEN NAME=MAX_FILE_SIZE VALUE='$default->max_filesize'>
			<INPUT TYPE=HIDDEN NAME=action VALUE=file_update>
			<INPUT TYPE=HIDDEN NAME=id VALUE='$id'>");
      print("<INPUT TYPE=HIDDEN NAME=expand VALUE='$expand'>");
      print("<TABLE BORDER=$default->table_border><TR><TD ALIGN='RIGHT' bgcolor='$default->table_header_bg'>$owl_lang->sendthisfile</TD><TD align=left><input name='userfile' type='file'></TD></TR>"); 
      if ($default->owl_version_control == 1)
      {
         print("<TR align=left><TD ALIGN='RIGHT' bgcolor='$default->table_header_bg' valign=top>$owl_lang->vertype</td>
                        <td><SELECT NAME=versionchange>
                                <OPTION VALUE=major_revision>$owl_lang->vermajor
                    <OPTION selected VALUE=minor_revision>$owl_lang->verminor</select></td></tr>");
         print("<tr><TD align='right' bgcolor='$default->table_header_bg' valign='top'>$owl_lang->verdescription
                        </td>
                        <td align=left><textarea name=newdesc rows=5 cols=30 wrap=hard>$sDescription</textarea></tr>");
      } 
      print("</TABLE>
			       <INPUT TYPE=IMAGE  SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_buttons/btn_send.gif' BORDER=0 ALT='$owl_lang->alt_sendfile' TITLE='$owl_lang->alt_sendfile' onMouseOver=this.src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_buttons/btn_send_hover.gif'; onMouseOut=this.src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_buttons/btn_send.gif'; VALUE='$owl_lang->sendfile'>\n</FORM>\n");
      include(_SYSCOMMONROOT . "/lib/footer.inc");
   } 
   else
   {
      printError($owl_lang->err_noupload);
   } 
} 

if ($action == "file_upload")
{
   if (check_auth($parent, "folder_modify", $userid) == 1)
   {
      printModifyHeader(); 

      /**
       * BEGIN Bozz Change
       * Retrieve Group information if the user is in the
       * Administrator group
       */

      if (owlusergroup($userid) == 0)
      {
         $sql = new Owl_DB;
         $sql->query("SELECT id,name from $default->owl_groups_table");
         $i = 0;
         while ($sql->next_record())
         {
            $groups[$i][0] = $sql->f("id");
            $groups[$i][1] = $sql->f("name");
            $i++;
         } 
      } 
      else
      {
         $sql = new Owl_DB;
         $sql->query("SELECT userid,groupid from $default->owl_users_grpmem_table where userid = $userid ");
         if ($sql->num_rows($sql) == 0)
            $sql->query("SELECT u.groupid as groupid, g.name as name  from $default->owl_users_table as u join $default->owl_groups_table as g where u.id = $userid and u.groupid = g.id");
         $i = 0;
         while ($sql->next_record())
         {
            $groups[$i][0] = $sql->f("groupid");
            $groups[$i][1] = group_to_name($sql->f("groupid"));
            $i++;
         } 
      } 
      /**
       * END Bozz Change
       */

      print("<TABLE WIDTH=$default->table_expand_width BORDER=$default->table_border>");
      print("<TR><TD align=left>$owl_lang->addingfile ");
      $iNewParent = owlfolderparent($parent);
      if ($iNewParent != 0)
      {
         print("<A HREF='browse.php?sess=$sess&parent=$iNewParent&expand=$expand&order=$order&$sortorder=$sort' TITLE='$owl_lang->title_return_folder " . fid_to_name($iNewParent) . "'><img border='0' src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_nav/folder_up.gif' width ='16' height='16'></A>");
      } 
      else
      {
         print("<img border='0' src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_nav/folder_up.gif' width ='16' height='16'>");
      } 
      print(gen_navbar($parent) . "</TD></TR>");

      print("</TABLE><HR WIDTH=$default->table_expand_width><BR>");
      print("<FORM enctype= 'multipart/form-data' ACTION='dbmodify.php' METHOD=POST>
			<INPUT TYPE=HIDDEN NAME=sess VALUE='$sess'><INPUT TYPE=HIDDEN NAME=parent VALUE=$parent>
                        <INPUT TYPE=HIDDEN NAME=order VALUE='$order'>
                        <INPUT TYPE=HIDDEN NAME=sortname VALUE='$sortname'>
			<INPUT TYPE=HIDDEN NAME=MAX_FILE_SIZE VALUE='$default->max_filesize'>
			<INPUT TYPE=HIDDEN NAME=action VALUE=file_upload>
			<INPUT TYPE=HIDDEN NAME=expand VALUE=$expand>
			<INPUT TYPE=HIDDEN NAME=type VALUE=$type>
			<TABLE BORDER=$default->table_border>\n<TR>");

      if ($type == "url")
      {
         print("\n<TD ALIGN='RIGHT' bgcolor='$default->table_header_bg'>$owl_lang->sendthisurl:</TD>\n<TD align=left><input name='userfile' type='text' value='http://' size='80'></TD>\n</TR>\n");
      } elseif ($type == "")
      {
         print("<TD ALIGN='RIGHT' bgcolor='$default->table_header_bg'>$owl_lang->sendthisfile:</TD>\n<TD align=left><input name='userfile' type='file'></TD>\n</TR>\n");
      } 

      print("<TR>\n<TD ALIGN='RIGHT' bgcolor='$default->table_header_bg'>$owl_lang->title:</TD>\n<TD align=left><INPUT TYPE=TEXT NAME=title size=60></TD>\n</TR>\n
			<TR>\n<TD ALIGN='RIGHT' bgcolor='$default->table_header_bg'>$owl_lang->keywords:</TD>\n<TD align=left><INPUT TYPE=TEXT NAME=metadata></TD>\n</TR>\n");
      if ($default->owl_version_control == 1)
      {
         print("<TR>\n<TD ALIGN='RIGHT' bgcolor='$default->table_header_bg'>$owl_lang->vermajor:</TD>\n<TD ALIGN=LEFT><INPUT TYPE=TEXT NAME=major_revision VALUE=0></TD>\n</TR>\n");

         print("<TR>\n<TD ALIGN='RIGHT' bgcolor='$default->table_header_bg'>$owl_lang->verminor:</TD>\n<TD ALIGN=LEFT><INPUT TYPE=TEXT NAME=minor_revision VALUE=1></TD>\n</TR>\n");
      } 

      print("<TR><TD ALIGN='RIGHT' BGCOLOR='$default->table_header_bg'>$owl_lang->ownergroup:</TD><TD align=left><SELECT NAME=groupid>");
      if (isset($groupid))
      {
         print("<OPTION VALUE=" . $sql->f("groupid") . ">" . group_to_name($sql->f("groupid")));
      } 
      foreach($groups as $g)
      {
         print("<OPTION VALUE=$g[0]>$g[1]");
      } 
      print("</SELECT></TD></TR>");
      printfileperm($default->file_perm, "security", $owl_lang->permissions, "admin");

      print("<TR><TD ALIGN='RIGHT' VALIGN='TOP' bgcolor='$default->table_header_bg'>"); 
      if ($type == "note")
      {
         print("$owl_lang->description:</TD><TD align=left><TEXTAREA NAME=description ROWS=5 COLS=50 WRAP=hard></TEXTAREA></TD></TR>");
         print("<TR><TD ALIGN='RIGHT' VALIGN='TOP' bgcolor='$default->table_header_bg'>$owl_lang->note_content:</TD><TD align=left><TEXTAREA NAME=note_content ROWS=20 COLS=50 WRAP=hard></TEXTAREA></TD></TR>");
      } 
      else
      {
         print("$owl_lang->description:</TD><TD align=left><TEXTAREA NAME=description ROWS=10 COLS=50 WRAP=hard></TEXTAREA></TD></TR>");
      } 
      print("</TABLE>");
      print("<INPUT TYPE=IMAGE  SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_buttons/btn_send.gif' BORDER=0 ALT='$owl_lang->alt_sendfile' TITLE='$owl_lang->alt_sendfile' onMouseOver=this.src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_buttons/btn_send_hover.gif'; onMouseOut=this.src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_buttons/btn_send.gif'; VALUE='$owl_lang->sendfile'>\n</FORM>\n");
      include(_SYSCOMMONROOT . "/lib/footer.inc");
   } 
   else
   {
      printError($owl_lang->err_noupload);
   } 
} 

if ($action == "file_modify")
{
   if (check_auth($id, "file_modify", $userid) == 1)
   {
      printModifyHeader();

      /**
       * BEGIN Bozz Change
       * Retrieve Group information if the user is in the
       * Administrator group
       */

      $mygroup = owlusergroup($userid);
      if ($mygroup == 0 || $mygroup == $default->file_admin_group)
      {
         $sql = new Owl_DB;
         $sql->query("SELECT id,name from $default->owl_groups_table");
         $i = 0;
         while ($sql->next_record())
         {
            $groups[$i][0] = $sql->f("id");
            $groups[$i][1] = $sql->f("name");
            $i++;
         } 
         $sql->query("SELECT id,name from $default->owl_users_table");
         $i = 0;
         while ($sql->next_record())
         {
            $users[$i][0] = $sql->f("id");
            $users[$i][1] = $sql->f("name");
            $i++;
         } 
      } 
      else
      {
         if (uid_to_name($userid) == fid_to_creator($id))
         {
            $sql = new Owl_DB;
            $sql->query("SELECT userid,groupid from $default->owl_users_grpmem_table where userid = $userid ");
            if ($sql->num_rows($sql) == 0)
               $sql->query("SELECT u.groupid as groupid, g.name as name  from $default->owl_users_table as u join $default->owl_groups_table as g where u.id = $userid and u.groupid = g.id");
            $i = 0;
            while ($sql->next_record())
            {
               $groups[$i][0] = $sql->f("groupid");
               $groups[$i][1] = group_to_name($sql->f("groupid"));
               $i++;
            } 
            $mygroup = owlusergroup($userid);
            $sql->query("SELECT id,name from $default->owl_users_table where groupid='$mygroup'");
            $i = 0;
            while ($sql->next_record())
            {
               $users[$i][0] = $sql->f("id");
               $users[$i][1] = $sql->f("name");
               $i++;
            } 
         } 
      } 

      /**
       * END Bozz Change
       */

      print("<TABLE WIDTH=$default->table_expand_width BORDER=$default->table_border>");
      print("<TR><TD align=left>$owl_lang->modifying ");
      $iNewParent = owlfolderparent($parent);
      if ($iNewParent != 0)
      {
         print("<A HREF='browse.php?sess=$sess&parent=$iNewParent&expand=$expand&order=$order&$sortorder=$sort' TITLE='$owl_lang->title_return_folder " . fid_to_name($iNewParent) . "'><img border='0' src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_nav/folder_up.gif' width ='16' height='16'></A>");
      } 
      else
      {
         print("<img border='0' src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_nav/folder_up.gif' width ='16' height='16'>");
      } 
      print(gen_navbar($parent) . "/" . flid_to_name($id) . "</TD></TR>");

      print("</TABLE><HR WIDTH=$default->table_expand_width><BR>");
      $sql = new Owl_DB;
      $sql->query("SELECT * from $default->owl_files_table where id = '$id'");
      while ($sql->next_record())
      {
         print("<TABLE WIDTH=66% BORDER=$default->table_border><FORM ACTION='dbmodify.php'><TR>\n<TD ALIGN='RIGHT' BGCOLOR='$default->table_header_bg'>
				$owl_lang->title:</TD><TD align=left><INPUT TYPE=TEXT SIZE=60 NAME=title VALUE=\"" . $sql->f("name") . "\"></TD></TR>");

         $link = $default->owl_notify_link . "browse.php?sess=0&parent=" . $parent . "&expand=1&fileid=" . $id;
         print("<TR>\n<TD ALIGN='RIGHT' BGCOLOR='$default->table_header_bg'>$owl_lang->notify_link:</TD><TD align=left>$link</TD></TR>");

         if ($sql->f("url") == 1)
         {
            print("<TR><TD ALIGN='RIGHT' BGCOLOR='$default->table_header_bg'>$owl_lang->modify_url:</TD>");
            print("<TD align=left><A HREF='" . $sql->f("filename") . "'target=new TITLE='$owl_lang->title_browse_site'>" . $sql->f("filename") . "</A>&nbsp;</TD></TR>");
            print("<TR><TD ALIGN='RIGHT' BGCOLOR='$default->table_header_bg'>$owl_lang->file:</TD><TD align=left><INPUT TYPE=TEXT SIZE=60 NAME=new_filename VALUE=\"" . $sql->f("filename") . "\"></TD></TR>");
            print("<INPUT TYPE=HIDDEN NAME=filename VALUE=\"" . $sql->f("filename") . "\">");
            print("<INPUT TYPE=HIDDEN NAME=type VALUE=\"url\">");
         } 
         else
         {
            print("<TR><TD ALIGN='RIGHT' BGCOLOR='$default->table_header_bg'>$owl_lang->file:</TD>");
            print("<TD align=left><INPUT TYPE=TEXT NAME=new_filename VALUE='" .  $sql->f("filename") . "'> &nbsp;(" . gen_filesize($sql->f("size")) . ")");
            // End change by Ian            
            print("<INPUT TYPE=HIDDEN NAME=filename VALUE=\"" . $sql->f("filename") . "\">");
         } 
         // if a MP3 tag was found Display the information
         $filepath = $default->owl_FileDir . "/" . get_dirpath($sql->f("parent")) . "/" . $sql->f("filename");
         if ($sql->f("url") == 0 && file_exists($filepath))
         {
            $id3 = new id3($filepath);

            if ($id3->id3v11 | $id3->id3v1)
            {
               $id3->study();
               print("<TR><TD ALIGN='RIGHT' VALIGN='TOP' BGCOLOR='$default->table_header_bg'><BR>$owl_lang->disp_mp3<BR><BR></TD>");
               print("<TD align=left>");
               print("<B>$id3->artists - $id3->name <BR>");
               print("$id3->album <BR>");
               print("$id3->bitrate kbps&nbsp;&nbsp;$id3->frequency Hz&nbsp;$id3->mode <BR>");
               print("$id3->length<BR>");
               print("$id3->genre<BR>");
               print("$id3->comment</B>");
               print("</TD></TR>");
            } 
         } 

         $security = $sql->f("security");
         $current_groupid = owlfilegroup($id);
         $current_owner = owlfilecreator($id);

         if (owlusergroup($userid) == 0 || uid_to_name($userid) == fid_to_creator($id) || $mygroup == $default->file_admin_group)
         {
            print("<TR><TD ALIGN='RIGHT' BGCOLOR='$default->table_header_bg'>$owl_lang->ownership:</TD><TD align=left><SELECT NAME=file_owner>");
            foreach($users as $g)
            {
               print("<OPTION VALUE=$g[0] ");
               if ($g[0] == owlfilecreator($id))
                  print("SELECTED");
               print(">$g[1]");
            } 
            print("</SELECT></TD></TR>");

            print("<TR><TD ALIGN='RIGHT' BGCOLOR='$default->table_header_bg'>$owl_lang->ownergroup:</TD><TD align=left><SELECT NAME=groupid>");
            foreach($groups as $g)
            {
               print("<OPTION VALUE=$g[0] ");
               if ($g[0] == $current_groupid)
                  print("SELECTED");
               print(">$g[1]");
            } 
            print("</SELECT></TD></TR>");
            printfileperm($security, "security", "$owl_lang->permissions:", "admin");
         } 
         else
         {
            print("<TR><TD ALIGN='RIGHT' BGCOLOR='$default->table_header_bg'>$owl_lang->ownership:</TD><TD align=left>" . fid_to_creator($id) . "&nbsp;(" . group_to_name(owlfilegroup($id)) . ")</TD></TR>");
            print("<INPUT TYPE=HIDDEN NAME=file_owner VALUE='$current_owner'>");
            print("<INPUT TYPE=HIDDEN NAME=security VALUE='$security'>");
            print("<INPUT TYPE=HIDDEN NAME=groupid VALUE='$current_groupid'>");
         } 
         // Bozz change End
         print("\n<TR>\n<TD ALIGN='RIGHT' BGCOLOR='$default->table_header_bg'>$owl_lang->keywords:</TD><TD align=left><INPUT TYPE=TEXT NAME=metadata VALUE='" . $sql->f("metadata") . "'></TD>\n</TR>\n");
         print("<TR>\n<TD ALIGN='RIGHT' BGCOLOR='$default->table_header_bg' VALIGN=TOP>");

         if ($sql->f("url") == 2)
         {
            if ($default->owl_use_fs)
            {
               $filename = $default->owl_FileDir . "/" . find_path($parent) . "/" . $sql->f("filename");
               $handle = fopen ($filename, "r");
               $contents = fread ($handle, filesize ($filename));
               fclose ($handle);
            } 
            else
            {
               $getdata = new Owl_DB;
               $getdata->query("SELECT data from $default->owl_files_data_table where id='$id'");
               $getdata->next_record();
               $contents = $getdata->f("data");
            } 

            print("$owl_lang->description:</TD><TD align=left><TEXTAREA NAME=description ROWS=5 COLS=50 WRAP=hard>" . $sql->f("description") . "</TEXTAREA></TD></TR>");
            print("<TR><TD ALIGN='RIGHT' VALIGN='TOP' bgcolor='$default->table_header_bg'>$owl_lang->note_content:</TD><TD align=left><TEXTAREA NAME=note_content ROWS=20 COLS=50 WRAP=hard>$contents</TEXTAREA></TD></TR>");
         } 
         else
         {
            print("$owl_lang->description:</TD>\n<TD align=left><TEXTAREA NAME=description ROWS=10 COLS=50 WRAP=hard >" . $sql->f("description") . "</TEXTAREA></TD>\n</TR>\n");
         } 
         print("</TABLE>");

         print("<INPUT TYPE=HIDDEN NAME=action VALUE=file_modify>
                        	<INPUT TYPE=HIDDEN NAME=order VALUE='$order'>
                        	<INPUT TYPE=HIDDEN NAME=sortname VALUE='$sortname'>
			       <INPUT TYPE=HIDDEN NAME=id VALUE=$id>
			       <INPUT TYPE=HIDDEN NAME=sess VALUE='$sess'>
			       <INPUT TYPE=HIDDEN NAME=parent VALUE=$parent>
			       <INPUT TYPE=HIDDEN NAME=expand VALUE=$expand><BR>
			       <INPUT TYPE=IMAGE  SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_buttons/btn_change.gif' BORDER=0  ALT='$owl_lang->alt_change' TITLE='$owl_lang->alt_change' onMouseOver=this.src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_buttons/btn_change_hover.gif'; onMouseOut=this.src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_buttons/btn_change.gif'; VALUE='$owl_lang->change'>
			       </FORM>");
         include(_SYSCOMMONROOT . "/lib/footer.inc");
      } 
   } 
   else
   {
      printError($owl_lang->err_nofilemod);
   } 
} 

if ($action == "folder_create")
{
   if (check_auth($parent, "folder_modify", $userid) == 1)
   {
      printModifyHeader(); 
      // $expand=1;
      /**
       * BEGIN Bozz Change
       * Retrieve Group information if the user is in the
       * Administrator group
       */

      $sql = new Owl_DB;
      if (owlusergroup($userid) == 0)
      {
         $sql->query("SELECT id,name from $default->owl_groups_table");
      } 
      else
      {
         $sql->query("SELECT * from $default->owl_users_grpmem_table, $default->owl_groups_table where id = groupid and userid = $userid");
         if ($sql->num_rows($sql) == 0)
         {
            $sql->query("SELECT u.groupid as id, g.name as name  from $default->owl_users_table as u join $default->owl_groups_table as g where u.id = $userid and u.groupid = g.id");
         }
      } 
      $i = 0;
      while ($sql->next_record())
      {
         $groups[$i][0] = $sql->f("id");
         $groups[$i][1] = $sql->f("name");
         $i++;
      } 

      /**
       * END Bozz Change
       */

      print("<TABLE WIDTH=$default->table_expand_width BORDER=$default->table_border>");
      print("<TR>\n<TD align=left>$owl_lang->addingfolder ");
      $iNewParent = owlfolderparent($parent);
      if ($iNewParent != 0)
      {
         print("<A HREF='browse.php?sess=$sess&parent=$iNewParent&expand=$expand&order=$order&$sortorder=$sort' TITLE='$owl_lang->title_return_folder " . fid_to_name($iNewParent) . "'><img border='0' src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_nav/folder_up.gif' width ='16' height='16'></A>");
      } 
      else
      {
         print("<img border='0' src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_nav/folder_up.gif' width ='16' height='16'>");
      } 
      print(gen_navbar($parent) . "</TD></TR>");

      print("</TABLE><HR WIDTH=$default->table_expand_width><BR>
		       <TABLE WIDTH=50% BORDER=$default->table_border><TR><TD ALIGN='RIGHT' BGCOLOR='$default->table_header_bg'>$owl_lang->name:</TD><TD align=left><FORM ACTION='dbmodify.php'>
		       <INPUT TYPE=HIDDEN NAME=parent VALUE=$parent><INPUT TYPE=HIDDEN NAME=expand VALUE=$expand>
		       <INPUT TYPE=HIDDEN NAME=action VALUE=folder_create><INPUT TYPE=TEXT NAME=name></TD></TR>
		       <INPUT TYPE=HIDDEN NAME=sess VALUE='$sess'>
                        <INPUT TYPE=HIDDEN NAME=order VALUE='$order'>
                        <INPUT TYPE=HIDDEN NAME=sortname VALUE='$sortname'>
		       <INPUT TYPE=HIDDEN NAME=expand VALUE='$expand'>");

      /**
       * BEGIN Bozz Change
       * Display Retrieved Group information if the user is in the
       * Administrator group
       */
      print("<TR><TD ALIGN='RIGHT' BGCOLOR='$default->table_header_bg'>$owl_lang->ownergroup:</TD><TD align=left><SELECT NAME=groupid>");
      foreach($groups as $g)
      {
         print("<OPTION VALUE=$g[0]>$g[1]");
      } 
      print("</SELECT></TD></TR>");
      if (owlusergroup($userid) == 0)
         printgroupperm($default->folder_perm, "policy", $owl_lang->policy, "admin");
      else
         printgroupperm($default->folder_perm, "policy", $owl_lang->policy, "user");
      /**
       * END Bozz Change
       */

      print("<TR><TD ALIGN='RIGHT' VALIGN='TOP' bgcolor='$default->table_header_bg'>"); 
      print("$owl_lang->description:</TD><TD align=left><TEXTAREA NAME=description ROWS=10 COLS=50 WRAP=hard></TEXTAREA></TD></TR>");
      print("</TABLE><INPUT TYPE=IMAGE  SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_buttons/btn_create.gif' BORDER=0 ALT='$owl_lang->alt_btn_add_folder' TITLE='$owl_lang->alt_btn_add_folder' onMouseOver=this.src='$default->owl_graphics_url/$language/graphics/$default->sButtonStyle/ui_buttons/btn_create_hover.gif'; onMouseOut=this.src='$default->owl_graphics_url/$language/graphics/$default->sButtonStyle/ui_buttons/btn_create.gif'; VALUE='$owl_lang->create'>\n</FORM>");
      include(_SYSCOMMONROOT . "/lib/footer.inc");
   } 
   else
   {
      printError($owl_lang->err_nosubfolder);
   } 
} 

if ($action == "folder_modify")
{
   if (check_auth($id, "folder_property", $userid) == 1)
   {
      printModifyHeader(); 
      /**
       * BEGIN Bozz Change
       * Retrieve Group information if the user is in the
       * Administrator group
       */

      if ($usergroupid == "0" || $usergroupid == $default->file_admin_group)
      {
         $sql = new Owl_DB;
         $sql->query("SELECT id,name from $default->owl_groups_table");
         $i = 0;
         while ($sql->next_record())
         {
            $groups[$i][0] = $sql->f("id");
            $groups[$i][1] = $sql->f("name");
            $i++;
         } 

         $sql->query("SELECT id,name from $default->owl_users_table");
         $i = 0;
         while ($sql->next_record())
         {
            $users[$i][0] = $sql->f("id");
            $users[$i][1] = $sql->f("name");
            $i++;
         } 
      } 
      else 
      {
         if ($userid == owlfoldercreator($id))
         {
            $sql = new Owl_DB;
            $sql->query("SELECT * from $default->owl_users_grpmem_table, $default->owl_groups_table where id = groupid and userid = $userid");
            if ($sql->num_rows($sql) == 0)
            {
               $sql->query("SELECT u.groupid as id, g.name as name  from $default->owl_users_table as u join $default->owl_groups_table as g where u.id = $userid and u.groupid = g.id");
            }
            $i = 0;
            while ($sql->next_record())
            {
               $groups[$i][0] = $sql->f("id");
               $groups[$i][1] = $sql->f("name");
               $i++;
            }

            $mygroup = owlusergroup($userid);
            $sql->query("SELECT id,name from $default->owl_users_table where groupid='$mygroup'");
            $i = 0;
            while ($sql->next_record())
            {
               $users[$i][0] = $sql->f("id");
               $users[$i][1] = $sql->f("name");
               $i++;
            }

         }
      }
      /**
       * END Bozz Change
       */

      print("<TABLE WIDTH=$default->table_expand_width BORDER=$default->table_border>");
      print("<TR><TD align=left>$owl_lang->modifying ");
      $iNewParent = owlfolderparent($parent);
      if ($iNewParent != 0)
      {
         print("<A HREF='browse.php?sess=$sess&parent=$iNewParent&expand=$expand&order=$order&$sortorder=$sort' TITLE='$owl_lang->title_return_folder " . fid_to_name($iNewParent) . "'><img border='0' src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_nav/folder_up.gif' width ='16' height='16'></A>");
      } 
      else
      {
         print("<img border='0' src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_nav/folder_up.gif' width ='16' height='16'>");
      } 
      print(gen_navbar($id). "</TD></TR>");

      print("</TABLE><HR WIDTH=$default->table_expand_width><BR><TABLE WIDTH=50% BORDER=$default->table_border>");
      $sql = new Owl_DB;
      $sql->query("SELECT * from $default->owl_folders_table where id = '$id'");
      while ($sql->next_record())
      {
         $security = $sql->f("security");

         print("<FORM ACTION='dbmodify.php'><INPUT TYPE=HIDDEN NAME=action VALUE=folder_modify>");
         print("<TR><TD ALIGN='RIGHT' BGCOLOR='$default->table_header_bg'>$owl_lang->name:</TD><TD align=left><INPUT TYPE=TEXT NAME=name VALUE='" . $sql->f("name") . "'></TD></TR>");
         if ($usergroupid == "0" || $usergroupid == $default->file_admin_group || $userid == owlfoldercreator($id))
         {
            print("<TR><TD ALIGN='RIGHT' BGCOLOR='$default->table_header_bg'>$owl_lang->ownership:</TD><TD align=left><SELECT NAME=folder_owner>");
            foreach($users as $g)
            {
               print("<OPTION VALUE=$g[0] ");
               if ($g[0] == owlfoldercreator($id))
                  print("SELECTED");
               print(">$g[1]");
            } 
            print("</SELECT></TD></TR>");
         } 

         print("<INPUT TYPE=HIDDEN NAME=id VALUE=$id>
                        	<INPUT TYPE=HIDDEN NAME=order VALUE='$order'>
                        	<INPUT TYPE=HIDDEN NAME=sortname VALUE='$sortname'>
	                       	<INPUT TYPE=HIDDEN NAME=parent VALUE=$parent>
        	               	<INPUT TYPE=HIDDEN NAME=expand VALUE=$expand>");

         /**
          * BEGIN Bozz Change
          * Display Retrieved Group information if the user is in the
          * Administrator group
          */
         if ($usergroupid == "0" || $usergroupid == $default->file_admin_group)
         {
            print("<TR><TD ALIGN='RIGHT' BGCOLOR='$default->table_header_bg'>$owl_lang->ownergroup:</TD><TD align=left><SELECT NAME=groupid>");
            foreach($groups as $g)
            {
               print("<OPTION VALUE=$g[0] ");
               if ($g[0] == $sql->f("groupid"))
               {
                  print("SELECTED");
               } 
               print(">$g[1]");
            } 
            print("</SELECT></TD></TR>");
            printgroupperm($security, "policy", $owl_lang->policy, "admin");
         } 
         else
         { 
            if ($userid == owlfoldercreator($id))
            {
               print("<TR><TD ALIGN='RIGHT' BGCOLOR='$default->table_header_bg'>$owl_lang->ownergroup:</TD><TD align=left><SELECT NAME=groupid>");
               foreach($groups as $g)
               {
                  print("<OPTION VALUE=$g[0] ");
                  if ($g[0] == $sql->f("groupid"))
                  {
                     print("SELECTED");
                  }
                  print(">$g[1]");
            }
            print("</SELECT></TD></TR>");

            }
            printgroupperm($security, "policy", $owl_lang->policy, "user");
         } 
         /**
          * END Bozz Change
          */
         // ianm adding the prop. permissions checkbox
         if ($usergroupid=="0" || $usergroupid=="$default->file_admin_group")
         {
            print("<TR>\n");
            print("<TD ALIGN='RIGHT' VALIGN='TOP' bgcolor='$default->table_header_bg' nowrap>$owl_lang->prop_permissions</td>\n");
            print("<td><input type='checkbox' name='propagate'></td></tr>\n");
            print("<TR>\n");
            print("<TD ALIGN='RIGHT' VALIGN='TOP' bgcolor='$default->table_header_bg' nowrap>$owl_lang->prop_perms_files</td>\n");
            print("<TD>\n");
   
            $file_perm[0][0] = -1; // added for the "do nothing" clause
            $file_perm[1][0] = 0;
            $file_perm[2][0] = 1;
            $file_perm[3][0] = 2;
            $file_perm[4][0] = 3;
            $file_perm[5][0] = 4;
            $file_perm[6][0] = 5;
            $file_perm[7][0] = 6;
            $file_perm[8][0] = 7;
            $file_perm[9][0] = 8;
   
            $file_perm[0][1] = "$owl_lang->donothing";
            $file_perm[1][1] = "$owl_lang->everyoneread_ad";
            $file_perm[2][1] = "$owl_lang->everyonewrite_ad";
            $file_perm[3][1] = "$owl_lang->groupread_ad";
            $file_perm[4][1] = "$owl_lang->groupwrite_ad";
            $file_perm[5][1] = "$owl_lang->onlyyou_ad";
            $file_perm[6][1] = "$owl_lang->groupwrite_ad_nod";
            $file_perm[7][1] = "$owl_lang->everyonewrite_ad_nod";
            $file_perm[8][1] = "$owl_lang->groupwrite_worldread_ad";
            $file_perm[9][1] = "$owl_lang->groupwrite_worldread_ad_nod";
   
            print("<SELECT NAME=prop_file_sec>");
            foreach($file_perm as $fp)
            {
               print("<OPTION VALUE=$fp[0] ");
               print(">$fp[1]");
            }
            print("</SELECT></TD>\n");
         }
         print("<TR><TD ALIGN='RIGHT' VALIGN='TOP' bgcolor='$default->table_header_bg'>"); 
         print("$owl_lang->description:</TD><TD align=left><TEXTAREA NAME=description ROWS=10 COLS=50>" . $sql->f("description") . "</TEXTAREA></TD></TR>");
         print("</TABLE>
			       <INPUT TYPE=IMAGE  SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_buttons/btn_change.gif' BORDER=0 ALT='$owl_lang->alt_change' TITLE='$owl_lang->alt_change' onMouseOver=this.src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_buttons/btn_change_hover.gif'; onMouseOut=this.src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_buttons/btn_change.gif'; VALUE='$owl_lang->change'>
			       <INPUT TYPE=HIDDEN NAME=sess VALUE='$sess'></FORM></TABLE>");
         include(_SYSCOMMONROOT . "/lib/footer.inc");
      } 
   } 
   else
   {
      printError($owl_lang->err_nofoldermod);
   } 
} 

if ($action == "bulk_email")
{
   printModifyHeader();
   $disp = unserialize(stripslashes($id));
   $sql = new Owl_DB;
   $sql->query("SELECT * from $default->owl_users_table where id = '$userid'");
   $sql->next_record();
   $default_reply_to = $sql->f("email");

   print("<TABLE WIDTH=$default->table_expand_width BORDER=$default->table_border>\n");
   foreach($disp as $fid)
   {
      if (check_auth($fid, "file_modify", $userid) == 1)
      {
         print("<TR><TD align=left>$owl_lang->emailing ");
         $iNewParent = owlfolderparent($parent);
         if ($iNewParent != 0)
         {
            print("<A HREF='browse.php?sess=$sess&parent=$iNewParent&expand=$expand&order=$order&$sortorder=$sort' TITLE='$owl_lang->title_return_folder " . fid_to_name($iNewParent) . "'><img border='0' src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_nav/folder_up.gif' width ='16' height='16'></A>");
         } 
         else
         {
            print("<img border='0' src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_nav/folder_up.gif' width ='16' height='16'>");
         } 
         print(gen_navbar($parent, $fid) . "</TD>\n</TR>\n");
      } 
   } 
   print("</TABLE><HR WIDTH=$default->table_expand_width><BR>\n");
   print("<FORM enctype='multipart/form-data' ACTION='dbmodify.php' METHOD=POST>\n
                        <INPUT TYPE=HIDDEN NAME=order VALUE='$order'>\n
                        <INPUT TYPE=HIDDEN NAME=sortname VALUE='$sortname'>\n
                        <INPUT TYPE=HIDDEN NAME=sess VALUE='$sess'>\n
                        <INPUT TYPE=HIDDEN NAME=parent VALUE=$parent>\n
                        <INPUT TYPE=HIDDEN NAME=MAX_FILE_SIZE VALUE='$default->max_filesize'>\n
                        <INPUT TYPE=HIDDEN NAME=action VALUE=bulk_email>\n
                        <INPUT TYPE=HIDDEN NAME=id VALUE='$id'>\n");

   print("<INPUT TYPE=HIDDEN NAME=expand VALUE='$expand'>\n");
   print("<TABLE BORDER=$default->table_border>\n");
   print("<TR>\n<TD ALIGN='RIGHT' bgcolor='$default->table_header_bg'>$owl_lang->attach_file</TD>\n");
   print("<TD align=left><input type='checkbox' name=fileattached value=1 checked></TD>\n</TR>\n");
   print("<TR>\n<TD ALIGN='RIGHT' bgcolor='$default->table_header_bg'>$owl_lang->email_to</TD>\n<TD align=left><INPUT TYPE=TEXT NAME=mailto SIZE=30></TD>\n</TR>\n
                               <TR>\n<TD ALIGN='RIGHT' bgcolor='$default->table_header_bg'>$owl_lang->email_cc</TD>\n<TD align=left><INPUT TYPE=TEXT NAME=ccto SIZE=30></TD>\n</TR>\n 
                               <TR>\n<TD ALIGN='RIGHT' bgcolor='$default->table_header_bg'>$owl_lang->email_reply_to</TD>\n<TD align=left><INPUT TYPE=TEXT NAME=replyto SIZE=30 VALUE='$default_reply_to'></TD>\n</TR>\n
                               <TR>\n<TD ALIGN='RIGHT' bgcolor='$default->table_header_bg'>$owl_lang->email_subject</TD>\n<TD align=left><INPUT TYPE=TEXT NAME=subject size=80 VALUE='$default->owl_email_subject'></TD>\n</TR>\n");
   print("<tr>\n<TD align='right' bgcolor='$default->table_header_bg' valign='top'>$owl_lang->email_body</td>\n
                               <td align=left><textarea name=mailbody rows=20 cols=80 wrap=hard></textarea></td></tr>\n");
   print("</TABLE>
			       <INPUT TYPE=IMAGE  SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_buttons/btn_send_email.gif' BORDER=0 ALT='$owl_lang->alt_send_email' TITLE='$owl_lang->alt_send_email' onMouseOver=this.src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_buttons/btn_send_email_hover.gif'; onMouseOut=this.src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_buttons/btn_send_email.gif'; VALUE='$owl_lang->sendfile'>\n</FORM>\n");

   include(_SYSCOMMONROOT . "/lib/footer.inc");
} 

if ($action == "file_email")
{
   if (check_auth($id, "file_download", $userid) == 1)
   {
      printModifyHeader();
      print("<BR>");

      $sql = new Owl_DB;
      $sql->query("SELECT * from $default->owl_users_table where id = '$userid'");
      $sql->next_record();
      $default_reply_to = $sql->f("email");

      print("<TABLE WIDTH=$default->table_expand_width BORDER=$default->table_border>\n");
      print("<TR>\n<TD align=left>$owl_lang->emailing ");
      $iNewParent = owlfolderparent($parent);
      if ($iNewParent != 0)
      {
         print("<A HREF='browse.php?sess=$sess&parent=$iNewParent&expand=$expand&order=$order&$sortorder=$sort' TITLE='$owl_lang->title_return_folder " . fid_to_name($iNewParent) . "'><img border='0' src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_nav/folder_up.gif' width ='16' height='16'></A>");
      } 
      else
      {
         print("<img border='0' src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_nav/folder_up.gif' width ='16' height='16'>");
      } 
      print(gen_navbar($parent, $id) . "</TD>\n</TR>\n");

      print("</TABLE>\n<HR WIDTH=$default->table_expand_width><BR>");
      print("<FORM enctype='multipart/form-data' ACTION='dbmodify.php' METHOD=POST>
                        <INPUT TYPE=HIDDEN NAME=order VALUE='$order'>
                        <INPUT TYPE=HIDDEN NAME=sortname VALUE='$sortname'>
                        <INPUT TYPE=HIDDEN NAME=sess VALUE='$sess'>
                        <INPUT TYPE=HIDDEN NAME=parent VALUE=$parent>
                        <INPUT TYPE=HIDDEN NAME=MAX_FILE_SIZE VALUE='$default->max_filesize'>
                        <INPUT TYPE=HIDDEN NAME=action VALUE=file_email>
                        <INPUT TYPE=HIDDEN NAME=type VALUE='$type'>
                        <INPUT TYPE=HIDDEN NAME=id VALUE='$id'>
                        <INPUT TYPE=HIDDEN NAME=expand VALUE='$expand'>\n");
      print("<TABLE BORDER=$default->table_border>\n");
      print("<TR>\n<TD ALIGN='RIGHT' bgcolor='$default->table_header_bg'>$owl_lang->attach_file</TD>\n");
      print("<TD align='left'><input type='checkbox' name=fileattached value=1 checked></TD>\n</TR>\n");
      print("<TR>\n<TD ALIGN='RIGHT' bgcolor='$default->table_header_bg'>$owl_lang->email_to</TD>\n<TD align=left>\n");

      print("<INPUT TYPE=TEXT NAME=mailto SIZE=30>&nbsp;&nbsp;");

      $sql = new Owl_DB;
      $sQuery = "select distinct username,name ,email from users as u left join membergroup as m on u.id=m.userid where email <> '' and (u.groupid = $usergroupid or m.groupid = $usergroupid ";
      $sql->query("select groupid from $default->owl_users_grpmem_table where userid = '$userid'");
      $i = 1;
      while ($sql->next_record())
      {
         if ($sql->f("groupid") != $usergroupid)
         {
            $sQuery .= " or u.groupid = " . $sql->f("groupid") . " or m.groupid = " . $sql->f("groupid");
         } 
      } 

      $sQuery .= ")  order by name";
      $sql->query("$sQuery");

      print("<select name=pick_mailto>\n");
      print("<option value='' >" . $owl_lang->pick_select . "</option>\n");

      while ($sql->next_record())
      {
         $sUsername = $sql->f("username");
         $sName = $sql->f("name");
         $sEmail = $sql->f("email");
         if ($sName == "")
            print("<option value=" . $sEmail . " >" . $sUsername . " - (" . $sEmail . ")</option>\n");
         else
            print("<option value=" . $sEmail . " >" . $sName . " - (" . $sEmail . ")</option>\n");
      } 
      print("</select>\n</TD>\n</TR>\n");

      print("<TR>\n<TD ALIGN='RIGHT' bgcolor='$default->table_header_bg'>$owl_lang->email_cc</TD>\n
			             <TD align=left><INPUT TYPE=TEXT NAME=ccto SIZE=30></TD>\n</TR>
			       <TR>\n<TD ALIGN='RIGHT' bgcolor='$default->table_header_bg'>$owl_lang->email_reply_to</TD>\n<TD align=left><INPUT TYPE=TEXT NAME=replyto SIZE=30 VALUE='$default_reply_to'></TD>\n</TR>
			       <TR>\n<TD ALIGN='RIGHT' bgcolor='$default->table_header_bg'>$owl_lang->email_subject</TD>\n<TD align=left><INPUT TYPE=TEXT NAME=subject SIZE=80 VALUE='$default->owl_email_subject'></TD>\n</TR>\n");
      print("<tr><TD align='right' bgcolor='$default->table_header_bg' valign='top'>$owl_lang->email_body</td>
                               <td align=left><textarea name=mailbody rows=20 cols=80 wrap=hard></textarea></tr>");
      print("</TABLE>
			       <INPUT TYPE=IMAGE  SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_buttons/btn_send_email.gif' BORDER=0 ALT='$owl_lang->alt_send_email' TITLE='$owl_lang->alt_send_email' onMouseOver=this.src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_buttons/btn_send_email_hover.gif'; onMouseOut=this.src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_buttons/btn_send_email.gif'; VALUE='$owl_lang->sendfile'>\n</FORM>\n");
      include(_SYSCOMMONROOT . "/lib/footer.inc");
   } 
   else
   {
      printError($owl_lang->err_noemail);
   } 
} 

?>
