<?php

/**
 * prefs.php
 * 
 * Copyright (c) 1999-2003 The Owl Project Team
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 * 
 * $Id: prefs.php,v 1.4 2003/11/12 14:25:09 b0zz Exp $
 */

require_once("./config/owl.php");
require_once(_SYSCOMMONROOT . "/lib/disp.lib.php");
require_once(_SYSCOMMONROOT . "/lib/owl.lib.php");
require_once(_SYSCOMMONROOT . "/lib/security.lib.php");
include_once(_SYSCOMMONROOT . "/lib/header.inc");
include_once(_SYSCOMMONROOT . "/lib/userheader.inc");

if ($sess == "0" && $default->anon_ro == 1)
   printError($owl_lang->err_login);

switch ($order)
{
   case "name":
      $sortorder = 'sortname';
      break;
   case "major_revision":
      $sortorder = 'sortver';
      break;
   case "filename" :
      $sortorder = 'sortfilename';
      break;
   case "size" :
      $sortorder = 'sortsize';
      break;
   case "creatorid" :
      $sortorder = 'sortposted';
      break;
   case "smodified" :
      $sortorder = 'sortmod';
      break;
   case "checked_out":
      $sortorder = 'sortcheckedout';
      break;
   default:
      $sort = "ASC";
      break;
} 
print("<TABLE WIDTH='$default->table_expand_width' BGCOLOR='$default->main_header_bgcolor' CELLSPACING='0' CELLPADDING='0' BORDER='$default->table_border' HEIGHT='$default->table_header_height'>\n");

?>

<TR><TD ALIGN=LEFT><?php print "$owl_lang->user: ";
print uid_to_name($userid);
?> <FONT SIZE=-1>
<?php 
fPrintButton("index.php?login=logout&sess=$sess", "btn_logout");
?>
    </FONT></TD><TD ALIGN=RIGHT>
<?php 
fPrintButton("browse.php?sess=$sess&parent=$parent&expand=$expand&order=$order&$sortorder=$sortname", "btn_browse");
?>
        </A></TD></TR></TABLE>
        <?php print $owl_lang->preference;
?><br><hr width=50%>

<?php
if (!$action) $action = "users";

function printuser($id)
{
   global $order, $sortname, $sort;
   global $sess, $change, $default, $expand, $parent;
   global $owl_lang;

   if (isset($change)) print("$owl_lang->saved<BR>");
   $sql = new Owl_DB;
   $sql->query("select id,name from $default->owl_groups_table");
   $i = 0;
   while ($sql->next_record())
   {
      $groups[$i][0] = $sql->f("id");
      $groups[$i][1] = $sql->f("name");
      $i++;
   } 
   $sql->query("select * from $default->owl_users_table where id = '$id'");
   while ($sql->next_record())
   {
      print("<FORM ACTION='./dbmodify.php' METHOD=POST>");
      print("<INPUT TYPE=HIDDEN NAME=id VALUE=" . $sql->f("id") . ">");
      print("<INPUT TYPE=HIDDEN NAME=order VALUE='$order'>");
      print("<INPUT TYPE=HIDDEN NAME=sortname VALUE='$sortname'>");
      print("<INPUT TYPE=HIDDEN NAME=sess VALUE=$sess>");
      print("<INPUT TYPE=HIDDEN name=action VALUE=user>");
      print("<INPUT TYPE=HIDDEN name=expand VALUE=$expand>");
      print("<INPUT TYPE=HIDDEN name=parent VALUE=$parent>");
      print("<TABLE>"); 
      // 
      // Show the Title
      // 
      if (prefaccess($sql->f("id")))
      {
         print("<TR><TD BGCOLOR='$default->table_header_bg' align='right'>$owl_lang->title</TD><TD align=left><INPUT TYPE=text NAME=name VALUE='" . $sql->f("name") . "'></TD></TR>");
      } 
      else
      {
         print("<TR><TD BGCOLOR='$default->table_header_bg' align='right'>$owl_lang->title</TD><TD align=left>" . $sql->f("name") . "</TD></TR>");
      } 
      // 
      // Display the Primary group
      // and groups the user is a member
      // of
      // 
      print("<TR><TD BGCOLOR='$default->table_header_bg' align='right'>$owl_lang->group</TD><TD align=left>" . group_to_name($sql->f("groupid")) . "</TD></TR>");

      $sqlmemgroup = new Owl_DB;
      $sqlmemgroup->query("select * from $default->owl_users_grpmem_table where userid = '" . $sql->f("id") . "'");
      if ($sqlmemgroup->num_rows() > 0)
      {
         $sqlmemgroup->next_record();
         print("<TR><TD BGCOLOR='$default->table_header_bg' align='right'>$owl_lang->groupmember</TD><TD align=left>" . group_to_name($sqlmemgroup->f("groupid")) . "</TD></TR>");
         while ($sqlmemgroup->next_record())
         {
            print("<TR><TD BGCOLOR='$default->table_header_bg' align='right'>&nbsp;</TD><TD align=left>" . group_to_name($sqlmemgroup->f("groupid")) . "</TD></TR>");
         } 
      } 
      else
      {
         print("<TR><TD BGCOLOR='$default->table_header_bg' align='right'>$owl_lang->groupmember</TD><TD align=left>$owl_lang->not_member</TD></TR>");
      } 
      // 
      // Display the Language dropdown
      // 
      if (prefaccess($sql->f("id")))
      {
         print("<TR><TD BGCOLOR='$default->table_header_bg' align='right'>$owl_lang->userlang</TD><TD align=left><SELECT NAME=newlanguage>");
         $dir = dir($default->owl_LangDir);
         $dir->rewind();

         while ($file = $dir->read())
         {
            if ($file != "." and $file != ".." and $file != "CVS")
            {
               print("<OPTION VALUE=$file");
               if ($file == $sql->f("language"))
               {
                  print (" SELECTED");
               }
               print(">$file");
            }
         } 
         $dir->close();
         print("</SELECT></TD></TR>");
      } 
      else
      {
         print("<TR><TD BGCOLOR='$default->table_header_bg' align='right'>$owl_lang->userlang</TD><TD align=left>" . $sql->f("language") . "</TD></TR>");
      } 
      // 
      // Display the Password
      // change input text
      // 
      if (prefaccess($sql->f("id")))
      {
         print("<TR><TD BGCOLOR='$default->table_header_bg' align='right'>$owl_lang->oldpassword</TD><TD align=left><INPUT TYPE=PASSWORD NAME=oldpassword VALUE=></TD></TR>");
         print("<TR><TD BGCOLOR='$default->table_header_bg' align='right'>$owl_lang->newpassword</TD><TD align=left><INPUT TYPE=PASSWORD NAME=newpassword VALUE=></TD></TR>");
         print("<TR><TD BGCOLOR='$default->table_header_bg' align='right'>$owl_lang->confpassword</TD><TD align=left><INPUT TYPE=PASSWORD NAME=confpassword VALUE=></TD></TR>");
      } 
      // 
      // Display the Email
      // 
      if (prefaccess($sql->f("id")))
      {
         print("<TR><TD BGCOLOR='$default->table_header_bg' align='right'>$owl_lang->email</TD><TD align=left><INPUT TYPE=TEXT SIZE=40 NAME=email VALUE='" . $sql->f("email") . "'></TD></TR>");
      } 
      else
      {
         print("<TR><TD BGCOLOR='$default->table_header_bg' align='right'>$owl_lang->email</TD><TD align=left>" . $sql->f("email") . "</TD></TR>");
      } 

      if (prefaccess($sql->f("id")))
      {
         if ($sql->f("notify") == 1)
            print("<TR><TD BGCOLOR='$default->table_header_bg' align='right'>$owl_lang->notification</TD><TD align=left><INPUT TYPE=CHECKBOX NAME=notify VALUE=1 checked></TD></TR>");
         else
            print("<TR><TD BGCOLOR='$default->table_header_bg' align='right'>$owl_lang->notification</TD><TD align=left><INPUT TYPE=CHECKBOX NAME=notify VALUE=1></TD></TR>");
         if ($sql->f("attachfile") == 1)
            print("<TR><TD BGCOLOR='$default->table_header_bg' align='right'>$owl_lang->attach_file</TD><TD align=left><INPUT TYPE=CHECKBOX NAME=attachfile VALUE=1 checked></TD></TR>");
         else
            print("<TR><TD BGCOLOR='$default->table_header_bg' align='right'>$owl_lang->attach_file</TD><TD align=left><INPUT TYPE=CHECKBOX NAME=attachfile VALUE=1></TD></TR>");
         if ($sql->f("comment_notify") == 1)
            print("<TR><TD BGCOLOR='$default->table_header_bg' align='right'>$owl_lang->comment_notif</TD><TD align=left><INPUT TYPE=CHECKBOX NAME=comment_notify VALUE=1 checked></TD></TR>");
         else
            print("<TR><TD BGCOLOR='$default->table_header_bg' align='right'>$owl_lang->comment_notif</TD><TD align=left><INPUT TYPE=CHECKBOX NAME=comment_notify VALUE=1></TD></TR>");
         if ($sql->f("newsadmin") == 1)
            print("<TR><TD BGCOLOR='$default->table_header_bg' align='right'>$owl_lang->newsadmin</TD><TD align=left>$owl_lang->status_yes</TD></TR>");
         else
            print("<TR><TD BGCOLOR='$default->table_header_bg' align='right'>$owl_lang->newsadmin</TD><TD align=left>$owl_lang->status_no</TD></TR>");
      } 
      else
      {
         if ($sql->f("notify") == 1)
            print("<TR><TD BGCOLOR='$default->table_header_bg' align='right'>$owl_lang->notification</TD><TD align=left>$owl_lang->status_yes</TD></TR>");
         else
            print("<TR><TD BGCOLOR='$default->table_header_bg' align='right'>$owl_lang->notification</TD><TD align=left>$owl_lang->status_no</TD></TR>");
         if ($sql->f("attachfile") == 1)
            print("<TR><TD BGCOLOR='$default->table_header_bg' align='right'>$owl_lang->attach_file</TD><TD align=left>$owl_lang->status_yes</TD></TR>");
         else
            print("<TR><TD BGCOLOR='$default->table_header_bg' align='right'>$owl_lang->attach_file</TD><TD align=left>$owl_lang->status_no</TD></TR>");
         if ($sql->f("comment_notify") == 1)
            print("<TR><TD BGCOLOR='$default->table_header_bg' align='right'>$owl_lang->comment_notif</TD><TD align=left>$owl_lang->status_yes</TD></TR>");
         else
            print("<TR><TD BGCOLOR='$default->table_header_bg' align='right'>$owl_lang->comment_notif</TD><TD align=left>$owl_lang->status_no</TD></TR>");
         if ($sql->f("newsadmin") == 1)
            print("<TR><TD BGCOLOR='$default->table_header_bg' align='right'>$owl_lang->newsadmin</TD><TD align=left>$owl_lang->status_yes</TD></TR>");
         else
            print("<TR><TD BGCOLOR='$default->table_header_bg' align='right'>$owl_lang->newsadmin</TD><TD align=left>$owl_lang->status_no</TD></TR>");
      } 

      print("</TABLE><BR>");
      if (prefaccess($sql->f("id")))
      {
         print("<INPUT TYPE=IMAGE  SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_buttons/btn_change.gif' BORDER=0  ALT='$owl_lang->alt_change' TITLE='$owl_lang->alt_change' onMouseOver=this.src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_buttons/btn_change_hover.gif'; onMouseOut=this.src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_buttons/btn_change.gif'; VALUE='$owl_lang->change'>");
      }
      print("</FORM>");
   } 
} 

if ($action)
{
   if (isset($owluser)) printuser($owluser);
} 
else
{
   exit("$owl_lang->err_general");
} 

include(_SYSCOMMONROOT . "/lib/footer.inc");

?>
