<?php 

/*
 * search.php
 *
 * Copyright (c) 1999-2003 The Owl Project Team
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 *
 * $Id: search.php,v 1.8 2003/11/12 14:25:10 b0zz Exp $
 */

//require_once("./config/owl.php");
require_once(_SYSCOMMONROOT . "/lib/disp.lib.php");
require_once(_SYSCOMMONROOT . "/lib/owl.lib.php");
require_once(_SYSCOMMONROOT . "/lib/security.lib.php");
include_once(_SYSCOMMONROOT . "/lib/header.inc");
include_once(_SYSCOMMONROOT . "/lib/userheader.inc");

$dStartTime = time();
// Display the Footer Tools (Seach, Newsadmin and Admin)
$bDisplayFooterTools = true;

print("<TABLE WIDTH='$default->table_expand_width' BGCOLOR='$default->main_header_bgcolor' CELLSPACING='0' CELLPADDING='0' BORDER='$default->table_border' HEIGHT='$default->table_header_height'>");
print("<TR><TD WIDTH=200 VALIGN=TOP>");
print("<TR>");
print("<TD ALIGN=LEFT WIDTH=33%>");
print uid_to_name($userid);
print(" : ");
fPrintButton("index.php?login=logout&sess=$sess", "btn_logout");
print("</A></TD>");
print("<TD ALIGN=CENTER WIDTH=33%>&nbsp</TD>");
print("<TD ALIGN=RIGHT WIDTH=33%>");
fPrintButton("browse.php?sess=$sess&parent=$parent&expand=$expand", "btn_browse");
print("</TD>");
print("</TR>");
print("</TABLE>");

print "<center>";
print "<br>";
if ($expand == 1) 
{ // long view
   print("\t\t<TABLE WIDTH=\"".$default->table_expand_width."\" border=\"0\">\n");
} 
else 
{
   print("\t\t<TABLE WIDTH=$default->table_collapse_width>\n");
}

print("\t\t\t<tr><td align=\"left\"><b style=\"color:#0000aa;\">".$owl_lang->search.":</b> ");

$iNewParent = owlfolderparent($parent);
if ($iNewParent != 0 ) 
{
   print("<A HREF='browse.php?sess=$sess&parent=$iNewParent&expand=$expand&order=$order&$sortorder=$sort' TITLE='$owl_lang->title_return_folder ". fid_to_name($iNewParent) ."'><img border='0' src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_nav/folder_up.gif' width ='16' height='16'></A>");
} 
else 
{
   print("<img border='0' src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_nav/folder_up.gif' width ='16' height='16'>");   
}


print(gen_navbar($parent)."</TD>\n</TR>\n");
print("</table>");

// END patch Scott Tigr

$groupid = owlusergroup($userid);

// first we have to find out what we can search
// we need a list of all folder that can be searched
// so we need to see which folders the user can read
// 692380 search exclude old documents

$sql = new Owl_DB;

//if ($currentfolder == 1)
//{
   //$sql->query("SELECT id,creatorid,groupid,security FROM $default->owl_folders_table where name <> 'backup'");
//}
//else
//{
   $sql->query("SELECT id,creatorid,groupid,security FROM $default->owl_folders_table where name <> 'backup'");
//}

//
// get all the folders that the user can read

print("$owl_lang->search_for_folders");

$iCount=0;
$iResults=0;
while($sql->next_record()) 
{

   $id = $sql->f("id");
   if(check_auth($id, "folder_view", $userid) == 1) 
   {
      $iCount++;
      $PrintDot = $iCount % 50;
      if ($PrintDot == 0)
      {
         print(".");
      }
      $folders[$id] = $id;
   }
}

print("<BR>");
//
// get all the files in those folders that the user can read
//if($_REQUEST[keywords] != "")
  //{
  //}

print("$owl_lang->search_for_files");
$iCount=0;
foreach($folders as $item) 
{
   // BEGIN NEW STUFF
   #Clean up the keywords a bit (remove all commas and duplicate spaces)
   $sqlquery = "";
   $glue = "";
   $keywords = $query;
   $keywords = str_replace(', ', ' ', $keywords);
   $keywords = str_replace(',', ' ', $keywords);
   $keywords = str_replace('  ', ' ', $keywords);

   #Replace asterisks with % signs for MySQL wildcards
   $keywords = str_replace("*", "%", $keywords);

   #Tack the search terms onto the query
   if ($withindocs == "1")
   {
      $sqlquery .= " AND (";
      if($boolean == "phrase")
      {
         #Match the entire term
         $sql = new Owl_DB;
         $sql->query("SELECT wordid from $default->owl_wordidx where word='$keywords'");
         if ($sql->num_rows() > 0)
         {
            $sql->next_record();
            $keywordid = $sql->f("wordid");
         }
         else
         {
            $keywordid = -1;
         }
         $sqlquery .= "name LIKE '%$keywords%' OR metadata LIKE '%$keywords%' OR description LIKE '%$keywords%' OR filename LIKE '%$keywords%' OR wordid = '$keywordid'";
      }
      else
      {
         #Match any or all words
         $tok = strtok($keywords, " ");
         while($tok)
         {
            $sql = new Owl_DB;
            $sql->query("SELECT wordid from $default->owl_wordidx where word='$tok'");
            if ($sql->num_rows() > 0)
            {
               $sql->next_record();
               $keywordid = $sql->f("wordid");
            }
            else
            {
               $keywordid = -1;
            }
   
            $sqlquery .= "$glue (name LIKE '%$tok%' OR metadata LIKE '%$tok%' OR description LIKE '%$tok%' OR filename LIKE '%$tok%' OR wordid = '$keywordid')";
            $glue = ($boolean == "all") ? " AND" : " OR";
            $tok = strtok(" ");
         }
      }
      $sqlquery .= ")";
   }       

   if ($withindocs == "1")
   {
   $sql->query("SELECT * FROM $default->owl_files_table left outer join $default->owl_searchidx on owlfileid=id where parent = '$item' $sqlquery");
   }
   else
   {
   $sql->query("SELECT * FROM $default->owl_files_table where parent = '$item'");
   }

   while($sql->next_record()) 
   {
      $id = $sql->f("id");
      if ($oldid == $id)
      { 
         continue;
      }
      if(check_auth($id, "file_download", $userid) == 1) 
      {
         $files[$id][id] = $id;
         $files[$id][n] = $sql->f("name");
         $files[$id][m] = explode(" ", $sql->f("metadata"));
         $files[$id][d] = explode(" ", $sql->f("description"));
         $files[$id][f] = $sql->f("filename");
         $files[$id][c] = $sql->f("checked_out");
         $files[$id][u] = $sql->f("url");
         $files[$id][p] = $sql->f("parent");
         $files[$id][x] = $sql->f("description");
         $files[$id][s] = $sql->f("size");
         $files[$id][date] = $sql->f("smodified");

	 $iCount++;
	 $PrintDot = $iCount % 50;
	 if ($PrintDot == 0)
	 {
	    print(".");
	 }
         $files[$id][score] = 0;
         $oldid = $id;
      }
   }
}
print("<BR>");

print("$owl_lang->search_score");
//
// right now we have the array $files with all possible files that the user has read access to

if (strlen(trim($query))>0) 
{
   //
   // break up our query string
   $query = explode(" ", $query);
   //
   // the is the meat of the matching
   if(sizeof($files) > 0) 
   {
      foreach($query as $keyword) 
      {
         if($keyword <> "*")
         {
            foreach(array_keys($files) as $key) 
            {
               // BEGIN enhancement Sunil Savkar
               // if the $parent string contains a keyword to be searched, then the score is
               // adjusted.  This takes into account the hierarchy.
               if(eregi("$keyword", find_path($files[$key][p]))) 
               {    
                  $iResults = 1;
                  $files[$key][score] = $files[$key][score] + 4;
               }
               if(eregi("$keyword", $files[$key][n])) 
               {
                  $iResults = 1;
                  $files[$key][score] = $files[$key][score] + 4;
               }
               if(eregi("$keyword", $files[$key][f]))
               {
                  $iResults = 1;
                  $files[$key][score] = $files[$key][score] + 3;
               }
               foreach($files[$key][m] as $metaitem) 
               {
                  // add 2 to the score if we find it in metadata (key search items)
                  if(eregi("$keyword", $metaitem)) 
                  {
                  $iResults = 1;
                     $files[$key][score] = $files[$key][score] + 2;
                  }
               }
               foreach($files[$key][d] as $descitem) 
               {
                  // only add 1 for regular description matches
                  if(eregi("$keyword", $descitem)) 
                  {
                  $iResults = 1;
                     $files[$key][score] = $files[$key][score] + 1;
                  }
               }
               if ($withindocs == "1")
               {
               if(DoesFileIDContainKeyword($files[$key][id], $keyword) > 0) 
               {
                  $iResults = 1;
                  $files[$key][score] = $files[$key][score] + 5;
               }
               }
               $iCount++;
               $PrintDot = $iCount % 50;
               if ($PrintDot == 0)
               {
                  print(".");
               }
            }
         }
      }
   }
   print("<BR>");
//
// gotta find order to the scores...any better ideas?
   if ($iResults > 0)
   {
      $diff = time()-$dStartTime;
      //$daysDiff = floor($diff/60/60/24);
      //$diff -= $daysDiff*60*60*24;
      //$hrsDiff = floor($diff/60/60);
      //$diff -= $hrsDiff*60*60;
      $minsDiff = floor($diff/60);
      $diff -= $minsDiff*60;
      $secsDiff = $diff;
   
      print("($owl_lang->elapsed_time ".$minsDiff.'m '.$secsDiff.'s)'."<BR>");
      print "$owl_lang->search_results_for \"".htmlspecialchars(implode(" ", $query))."\"<BR><BR><HR WIDTH=200 ALIGN=CENTER><BR>";
   
      $max = 30;
      $hit = 1;
      $CountLines = 0;
      $iconfiles = array("html","htm","gif","jpg","bmp","zip","tar","doc","mdb","xls","ppt","pdf","gz","mp3","tgz","avi","cpt","eml","mov","rar","txt","bat","drv","exe","mpeg","reg","wav","cdr","dwg","ini","psd","ttf");
   
   
      print("<TABLE WIDTH=$default->table_expand_width BORDER=$default->table_border CELLSPACING=1 CELLPADDING=1>");
      print("<TR height=20 BGCOLOR='$default->table_header_bg'>\n");
      print("<TD align=left width=10%>&nbsp;</TD>\n");
      print("<TD align=left>$owl_lang->owl_log_hd_fld_path</TD>\n");
      print("<TD align=left>$owl_lang->file</TD>\n");
      print("<TD align=left>$owl_lang->size</TD>\n");
      print("<TD align=left>$owl_lang->postedby</TD>\n");
      print("<TD align=left>$owl_lang->modified</TD>\n");
      print("<TD align=left>$owl_lang->actions</TD>\n");
      print("</TR>\n");
      if(sizeof($files) > 0) 
      {
         while($max > 0) 
         {
            foreach(array_keys($files) as $key) 
            {
               if($files[$key][score] == $max) 
               {
                  $name = find_path($files[$key][p])."/".$files[$key][n];			
                  $filename = $files[$key][f];
                  $description = $files[$key][x];
                  $choped = split("\.", $filename);
                  $pos = count($choped);
                  if ( $pos > 1 )
                  {
                     $ext = strtolower($choped[$pos-1]);
                  }
                  else
                  {
                     $ext = "NoExtension";
                  }
                  $CountLines++;
                  $PrintLines = $CountLines % 2;
                  if ($PrintLines == 0)
                  {
                     print("<TR BGCOLOR='$default->table_cell_bg_alt'>");
                  }
                  else
                  {
                     print("<TR BGCOLOR='$default->table_cell_bg'>");
                  }
                  print "<TD ALIGN=CENTER width=10%>";
                  $t_score = $max;
                  for ($c=$max; $c>=1; $c--) 
                  {	
                     if ( $t_score >= 10) 
                     {
                        if ( 0 == ($c % 10)) 
                        {
                           print "<IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_icons/star10.gif' BORDER=0>";
                           $t_score = $t_score - 10;	
                        }
                     } 
                     else 
                     {
                        if ( (0 == ($t_score % 2)) && $t_score > 0 ) 
                        {
                           print "<IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_icons/star.gif' BORDER=0>";
                        }
                        $t_score = $t_score - 1;
                     }   
   
                  }
   
                  print "</TD>";
                  print("<TD ALIGN=LEFT WIDTH=20%>");
                  $sPopupDescription = ereg_replace("\n",'<BR>',$description);
                  $sPopupDescription = ereg_replace("\"", "'", $sPopupDescription);
                  $sPopupDescription = ereg_replace("'", "\\'", $sPopupDescription);
                  $sPopupDescription = ereg_replace("
", "", $sPopupDescription);
                  $sPopupDescription = ereg_replace("\r",'',$sPopupDescription); 
   
                  if ($sPopupDescription == "") 
                  {
                     $sPopupDescription = $owl_lang->no_description;
                  }
                  print("<A HREF='browse.php?sess=$sess&parent=". $files[$key][p] . "&expand=1&fileid=" . $files[$key][id] ."'");
                  print(" onmouseover=" . '"' . "return makeTrue(domTT_activate(this, event, 'statusText', '', 'caption', '" . $owl_lang->description . "', 'content', '" . $sPopupDescription . "', 'trail', true));" . '"');
                  print(">\n");
                  print("$hit. $name");
                  print("</TD>");
                  print("<TD ALIGN=LEFT WIDTH=15%>");
                  if ($files[$key][u] == "1")
                  {
                     print("<IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/icon_filetype/url.gif' BORDER=0>&nbsp;");
                  }
                  else 
                  {
                     $sDispIcon = $ext;
                     if (($ext == "gz") && ($pos > 2))
                     {
                        $exttar = strtolower($choped[$pos-2]);
                        if (strtolower($choped[$pos-2]) == "tar")
                        {
                           $ext = "tar.gz";
                        }
                     }
                     if (preg_grep("/$sDispIcon/",$iconfiles))
                     {
                        print("<IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/icon_filetype/$sDispIcon.gif' BORDER=0>&nbsp;");
                     }
                     else
                     {
                        print("<IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/icon_filetype/file.gif' BORDER=0>&nbsp;");
                     }
                  }
                  if ($files[$key][u] == "1") 
                  {
                     print "<A HREF='$filename' target='new'>".$filename."</A>";
                  } 
                  else 
                  {
                     print "<A HREF='download.php?sess=$sess&id=".$files[$key][id]."&parent=".$files[$key][p]."'>".$filename."</A>";
                  }
                  print("</TD>");
                  print("<TD ALIGN=LEFT width=5%>");
                  if ($files[$key][u] == "1")
                  {
                     print("&nbsp;");
                  }
                  else
                  {
                     print("".gen_filesize($files[$key][s]));
                  }
                  print("</TD>");
                  print("<TD ALIGN=LEFT width=5%>");
                  print("".fid_to_creator($files[$key][id]));
                  print("</TD>");
                  print("<TD ALIGN=LEFT width=11%>");
                  print("".date($owl_lang->localized_date_format, strtotime($files[$key][date])));
                  print("</TD>");
   	
                  print("<TD ALIGN=LEFT nowrap width=10%>");
                  printFileIcons($files[$key][id],$name,$files[$key][c],$files[$key][u],$default->owl_version_control,$ext,$files[$key][p],true);
                  print("</TD></TR>");
                  $hit++;
               }
            }
            $max--;
         }
         print("</TABLE>");
      }
   }
   else
   {
      print "$owl_lang->search_results_for \"".htmlspecialchars(implode(" ", $query))."\"<BR><BR><HR WIDTH=200 ALIGN=CENTER><BR>";
      print("<TABLE WIDTH=$default->table_expand_width BORDER=$default->table_border CELLSPACING=1 CELLPADDING=1>");
      print("<TR height=20 BGCOLOR='$default->table_header_bg'>\n");
      print("<TD align=left width=10%>&nbsp;</TD>\n");
      print("<TD align=left>$owl_lang->owl_log_hd_fld_path</TD>\n");
      print("<TD align=left>$owl_lang->file</TD>\n");
      print("<TD align=left>$owl_lang->size</TD>\n");
      print("<TD align=left>$owl_lang->postedby</TD>\n");
      print("<TD align=left>$owl_lang->modified</TD>\n");
      print("<TD align=left>$owl_lang->actions</TD>\n");
      print("</TR>\n");
      print("<tr><td colspan='7' align='center'><h2>$owl_lang->owl_log_no_rec</h2></td></tr>");
      print("</TABLE>");
   }
   print "<HR WIDTH=\"".$default->table_expand_width."\" ALIGN=\"center\"><BR>";
   fPrintButton("browse.php?sess=$sess&parent=$parent&expand=$expand", "btn_browse", 1);
   print "<P></P>";
} 
else 
{ 
   print("<p>" . $owl_lang->query_empty . "</p>");
}

$keywords = str_replace("%", "*", $keywords);

include(_SYSCOMMONROOT . "/lib/footer.inc");
?> 
