<?php

/**
 * recycle.php
 * 
 * Copyright (c) 1999-2003 The Owl Project Team
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 * 
 * Written by: B0zz
 */

//require("../config/owl.php");
require(_SYSCOMMONROOT . "/lib/disp.lib.php");
require(_SYSCOMMONROOT . "/lib/owl.lib.php");

if ($usergroupid != "0") die("$owl_lang->err_unauthorized");

if (isset($bemptyaction_x))
{
   $action = $owl_lang->empty_trash;
} elseif (isset($bdeleteaction_x))
{
   $action = $owl_lang->del_selected;
} 

$sql = new Owl_DB; //create new db connection
$sql->query("SELECT name from $default->owl_folders_table where id = 1");
$sql->next_record();
$sRootFolderName = $sql->f("name");
// 
// Delete all Selected Files
// 
if ($action == "$owl_lang->del_selected")
{
   foreach($batch as $sDeleteThis)
   {
      myDelete($default->trash_can_location . "/" . $sDeleteThis);
   } 
   header("Location: recycle.php?sess=$sess&folder=$folder");
} 
// 
// Delete Folder
// 
if ($action == "del_folder")
{
   myDelete($default->trash_can_location . "/" . $folder);
   $filesearch = explode('/', $folder);
   $extensioncounter = 0;
   while ($filesearch[$extensioncounter + 1] != null)
   { 
      // pre-append a "." separator in the name for each
      // subsequent part of the the name of the file.
      if ($extensioncounter != 0)
      {
         $firstpart = $firstpart . "/";
      } 
      $firstpart = $firstpart . $filesearch[$extensioncounter];
      $extensioncounter++;
   } 
   if ($extensioncounter == 0)
   {
      $firstpart = $filename;
      $file_extension = '';
   } 
   else
   {
      $file_extension = $filesearch[$extensioncounter];
   } 
   header("Location: recycle.php?sess=$sess&folder=$firstpart");
} 
// 
// Empty Trash Can
// 
if ($action == $owl_lang->empty_trash)
{
   myDelete($default->trash_can_location . "/" . $sRootFolderName);
   header("Location: recycle.php?sess=$sess&folder=$sRootFolderName");
} 

include(_SYSCOMMONROOT . "/lib/header.inc");
include(_SYSCOMMONROOT . "/lib/userheader.inc");

if (!isset($folder) || $folder == "")
{
   $sRecyclePath = $sRootFolderName;
} 
else
{
   $sRecyclePath = $folder;
} 

if (!file_exists($default->trash_can_location . "/" . $sRecyclePath))
   printError($owl_lang->err_trash_can_empty);

print("<TABLE WIDTH='$default->table_expand_width' BGCOLOR='$default->main_header_bgcolor' CELLSPACING='0' CELLPADDING='0' BORDER='$default->table_border' HEIGHT='$default->table_header_height'>\n");
print("<TR>\n<TD WIDTH=200 VALIGN=TOP>");
print("<TR>");
print("<TD ALIGN=LEFT WIDTH=33%>");
print uid_to_name($userid);
print(" : ");
fPrintButton("../index.php?login=logout&sess=$sess'", btn_logout);
print("</TD>");
print("<TD ALIGN=CENTER WIDTH=33%> $owl_lang->alt_owl_admin</TD>");
print("<TD ALIGN=RIGHT WIDTH=33%>");
fPrintButton("../browse.php?sess=$sess'", btn_browse);
print("</TD>");
print("</TR>");
print("</TABLE>");
print("<HR WIDTH=$default->table_expand_width><BR>");
print("<H1> $owl_lang->recycle_bin_admin</H1>");
print("<TABLE WIDTH=$default->table_expand_width BORDER=$default->table_border>\n");

print("<FORM name='FileList' enctype='multipart/form-data' ACTION='recycle.php' METHOD=POST>\n
                        <INPUT TYPE=HIDDEN NAME=sess VALUE='$sess'\n>
                        <INPUT TYPE=HIDDEN NAME=folder VALUE='$folder'\n>
                        <INPUT TYPE=HIDDEN NAME=action VALUE=delete>\n");
// 
// Show the Directories in the
// Recycle Bin
// 
$iCountLines = 0;

if ($Dir = opendir($default->trash_can_location . "/" . $sRecyclePath))
{
   print("<TR><TD colspan=3 height=40 align=left>$default->trash_can_location" . "/" . $sRecyclePath . "</TD></TR>");
   if (!($sRecyclePath == $sRootFolderName))
   { 
      // I SEEM TO USE THIS IN QUITE A FEW PLACES
      // Maybe I should make this a FUNCTION?
      $filesearch = explode('/', $sRecyclePath);
      $extensioncounter = 0;
      while ($filesearch[$extensioncounter + 1] != null)
      { 
         // pre-append a "." separator in the name for each
         // subsequent part of the the name of the file.
         if ($extensioncounter != 0)
         {
            $firstpart = $firstpart . "/";
         } 
         $firstpart = $firstpart . $filesearch[$extensioncounter];
         $extensioncounter++;
      } 
      if ($extensioncounter == 0)
      {
         $firstpart = $filename;
         $file_extension = '';
      } 
      else
      {
         $file_extension = $filesearch[$extensioncounter];
      } 

      print("\t\t\t\t<TR BGCOLOR='$default->table_cell_bg_alt'>");
      print("\n<TD width=1% align=left>&nbsp;</TD><TD width=1% align=left><IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/icon_filetype/folder_closed.gif' BORDER=0></TD>\n<TD align=left><A HREF='recycle.php?folder=" . $firstpart . "&sess=" . $sess . "'>..</A></TD>\n</TR>\n");
   } 

   while ($file = readdir($Dir))
   {
      if ($file[0] == '.')
      {
         continue;
      } 
      if (!is_file($default->trash_can_location . "/" . $sRecyclePath . "/" . $file))
      {
         $iCountLines++;
         $iPrintLines = $iCountLines % 2;
         if ($iPrintLines == 0)
            print("\t\t\t\t<TR BGCOLOR='$default->table_cell_bg_alt'>");
         else
            print("\t\t\t\t<TR BGCOLOR='$default->table_cell_bg'>");
         print("\n<TD width=1% align=left><A HREF='recycle.php?folder=" . $sRecyclePath . "/" . $file . "&sess=" . $sess . "&action=del_folder' onClick='return confirm(\"$owl_lang->reallydelete ?\");'><IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/admin_del_folder.gif' ALT='$owl_lang->alt_del_this_folder $file' TITLE='$owl_lang->alt_del_this_folder $file' BORDER=0></A></TD><TD width=1% align=left><IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/icon_filetype/folder_closed.gif' BORDER=0></TD>\n<TD align=left><A HREF='recycle.php?folder=" . $sRecyclePath . "/" . $file . "&sess=" . $sess . "'>" . $file . "</A></TD>\n</TR>\n");
      } 
   } 
} 
else
{
   printError($owl_lang->err_general);
} 
// 
// Show the Files in the
// Recycle Bin
// 
if ($Dir = opendir($default->trash_can_location . "/" . $sRecyclePath))
{
   while ($file = readdir($Dir))
   {
      if ($file[0] == '.')
         continue;

      if (is_file($default->trash_can_location . "/" . $sRecyclePath . "/" . $file))
      {
         $iCountLines++;
         $iPrintLines = $iCountLines % 2;
         if ($iPrintLines == 0)
            print("\t\t\t\t<TR BGCOLOR='$default->table_cell_bg_alt'>");
         else
            print("\t\t\t\t<TR BGCOLOR='$default->table_cell_bg'>");
         print("\n<TD width=1% align=left><INPUT TYPE=CHECKBOX NAME=batch[] VALUE='" . $sRecyclePath . "/" . $file . "'><TD width=1% align=left>");
         $iconfiles = array("html", "htm", "gif", "jpg", "bmp", "zip", "tar", "doc", "mdb", "xls", "ppt", "pdf", "gz", "mp3", "tgz", "avi", "cpt", "eml", "mov" . "rar", "txt" . "bat", "drv", "exe", "mpeg", "reg", "wav", "cdr", "dwg", "ini", "psd", "ttf");
         $choped = split("\.", $file);
         $pos = count($choped);
         $ext = strtolower($choped[$pos-1]);
         if (preg_grep("/$ext/", $iconfiles))
            print("<IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/icon_filetype/$ext.gif' BORDER=0>&nbsp;");
         else
            print("<IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/icon_filetype/file.gif' BORDER=0>&nbsp;");

         print("</TD>\n<TD align=left>");
         print("$file</TD>\n</TR>\n");
      } 
   } 
} 
else
{
   printError($owl_lang->err_general);
} 

print("<BR />");
print("<TR><TD colspan=3 height=40 align=left><a href='#' onClick='CheckAll();'><IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_icons/tg_check.gif' ALT='$owl_lang->alt_toggle_check_box' TITLE='$owl_lang->alt_toggle_check_box' BORDER=0></a></TD></TR>\n");
print("<TR><TD colspan=3 height=40>&nbsp;</TD></TR>");
print("<TR><TD colspan=3>");

 print("<INPUT TYPE=IMAGE NAME=bdeleteaction onClick='return confirm(\"$owl_lang->reallydelete_selected ?\");' SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_buttons/btn_bulk_del.gif' BORDER=0 ALT='$owl_lang->alt_del_selected' TITLE='$owl_lang->alt_del_selected' VALUE='$owl_lang->del_selected' onMouseOver=this.src='$default->owl_graphics_url/$language/graphics/$default->sButtonStyle/ui_buttons/btn_bulk_del_hover.gif'; onMouseOut=this.src='$default->owl_graphics_url/$language/graphics/$default->sButtonStyle/ui_buttons/btn_bulk_del.gif';>\n");

 print("<INPUT TYPE=IMAGE NAME=bemptyaction onClick='return confirm(\"$owl_lang->really_empty_trash ?\");' SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_buttons/btn_empty_trash.gif' BORDER=0 ALT='$owl_lang->alt_del_selected' TITLE='$owl_lang->alt_del_selected' VALUE='$owl_lang->del_selected' onMouseOver=this.src='$default->owl_graphics_url/$language/graphics/$default->sButtonStyle/ui_buttons/btn_empty_trash_hover.gif'; onMouseOut=this.src='$default->owl_graphics_url/$language/graphics/$default->sButtonStyle/ui_buttons/btn_empty_trash.gif';>\n");

print("</TD></TR>");
print("</FORM></TABLE>");

if (owlusergroup($userid) == 0)
{
   print("<BR>");
   print("<BR>");
   fPrintButton("$default->owl_root_url/admin/index.php?sess=$sess", "btn_admin");
   print("<BR>");
   print("<BR>");
} 

?>
<script language="JavaScript" type="text/javascript">
<!-- 
function CheckAll() {
  for (var i = 0; i < document.FileList.elements.length; i++) {
    if(document.FileList.elements[i].type == "checkbox"){
      document.FileList.elements[i].checked =         !(document.FileList.elements[i].checked);
    }
  }
}
//-->
</script>
</BODY> 
</HTML> 
<?php
