<?php

/**
 * register.php
 * 
 * Copyright (c) 1999-2003 The Owl Project Team
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 */
//require_once("../config/owl.php");
require_once(_SYSCOMMONROOT . "/lib/disp.lib.php");
require_once(_SYSCOMMONROOT . "/lib/owl.lib.php");
include_once(_SYSCOMMONROOT . "/lib/header.inc");
include_once(_SYSCOMMONROOT . "/lib/userheader.inc");

print("<CENTER>");

if ($usergroupid != "0")
{
   die("$owl_lang->err_unauthorized");
} 

print("<H1> $owl_lang->owl_stats_viewer</H1>");
print("<TABLE WIDTH='$default->table_expand_width' BGCOLOR='$default->main_header_bgcolor' CELLSPACING='0' CELLPADDING='0' BORDER='$default->table_border' HEIGHT='30'>\n");
print("<TR><TD WIDTH=200 VALIGN=TOP>");
print("<TR>");
print("<TD ALIGN=LEFT WIDTH=33%>");
print uid_to_name($userid);
print(" : ");
fPrintButton("../index.php?login=logout&sess=$sess", btn_logout);
print("</A></TD>");
print("<TD ALIGN=CENTER WIDTH=33%> $owl_lang->owl_admin</TD>");
print("<TD ALIGN=RIGHT WIDTH=33%>");
fPrintButton("../browse.php?&sess=$sess", btn_browse);
print("</A> </TD>");
print("</TR>");
print("</TABLE>");
print("<HR WIDTH=$default->table_expand_width><BR>");

?>
<TABLE WIDTH="<?php print $default->table_expand_width?>" 
       CELLSPACING='2' 
       CELLPADDING='2' 
       BORDER="<?php print $default->table_border ?>"
>

<?php

$CountLines = 0;
$sql = new Owl_DB;
$sql->query("SELECT creatorid, sum(size) as total_size , count(*) as num_files from $default->owl_files_table group by creatorid order by num_files desc ;");
print("<TR BGCOLOR='$default->table_header_bg' height='25'>");
print("<TD align=left colspan=3><font size=4>$owl_lang->username</font></TD>");
print("<TD align=left><font size=4>$owl_lang->tot_files</font></TD>");
print("</TR>");

print("<TR>\n");
print("<TD ALIGN=LEFT colspan=3>&nbsp;</TD>\n");
print("<TD ALIGN=LEFT>&nbsp;</TD>\n");
print("</TR>\n");
print("<TR>\n");

// 
// User File Stats BEGIN
// 
print("<TD ALIGN=LEFT colspan=3><font size=3><B>$owl_lang->stats_files</B></TD>\n");
print("<TD ALIGN=LEFT>&nbsp;</TD>\n");
print("</TR>\n");
print("<TR>\n");
print("<TD ALIGN=LEFT colspan=3>&nbsp;</TD>\n");
print("<TD ALIGN=LEFT>&nbsp;</TD>\n");
print("</TR>\n");

$iGrandFileTotal = 0;
$iGrandSizeTotal = 0;
while ($sql->next_record())
{
   $CountLines++;
   $PrintLines = $CountLines % 2;
   if ($PrintLines == 0)
      print("\t\t\t\t<TR BGCOLOR='$default->table_cell_bg_alt'>\n");
   else
      print("\t\t\t\t<TR BGCOLOR='$default->table_cell_bg'>\n");

   print("<TD ALIGN=LEFT colspan=2>" . uid_to_name($sql->f("creatorid")) . "</TD>\n");
   print("<TD ALIGN=LEFT>" . $sql->f("num_files") . "</TD>\n");
   $iGrandFileTotal = $iGrandFileTotal + $sql->f("num_files");
   print("<TD ALIGN=LEFT>" . gen_filesize($sql->f("total_size")) . "</TD>\n");
   $iGrandSizeTotal = $iGrandSizeTotal + $sql->f("total_size");
   print("</TR>\n");
} 
print("<TR>\n");
print("<TD ALIGN=RIGHT colspan=2>$owl_lang->tot_files</TD>\n");
print("<TD ALIGN=LEFT>$iGrandFileTotal</TD>\n");
print("<TD ALIGN=LEFT>" . gen_filesize($iGrandSizeTotal) . "</TD>\n");
print("</TR>\n");
// 
// User File Stats END
// 
// 
// User Folder Stats BEGIN
// 
print("<TR>\n");
print("<TD ALIGN=LEFT colspan=3><font size=3><B>$owl_lang->stats_folders</B></TD>\n");
print("<TD ALIGN=LEFT>&nbsp;</TD>\n");
print("</TR>\n");
print("<TR>\n");
print("<TD ALIGN=LEFT colspan=3>&nbsp;</TD>\n");
print("<TD ALIGN=LEFT>&nbsp;</TD>\n");
print("</TR>\n");

$sql->query("SELECT creatorid , count(*) as num_folders from $default->owl_folders_table group by creatorid order by num_folders desc ;");

$iGrandFolderTotal = 0;
while ($sql->next_record())
{
   $CountLines++;
   $PrintLines = $CountLines % 2;
   if ($PrintLines == 0)
      print("\t\t\t\t<TR BGCOLOR='$default->table_cell_bg_alt'>\n");
   else
      print("\t\t\t\t<TR BGCOLOR='$default->table_cell_bg'>\n");

   print("<TD ALIGN=LEFT colspan=3>" . uid_to_name($sql->f("creatorid")) . "</TD>\n");
   print("<TD ALIGN=LEFT>" . $sql->f("num_folders") . "</TD>\n");
   $iGrandFolderTotal = $iGrandFolderTotal + $sql->f("num_folders");
   print("</TR>\n");
} 
print("<TR>\n");
print("<TD ALIGN=RIGHT colspan=3>$owl_lang->tot_files</TD>\n");
print("<TD ALIGN=LEFT>$iGrandFolderTotal</TD>\n");
print("</TR>\n");
// 
// User Folder Stats END
// 
if ($default->logging && $default->log_file)
{ 
   // 
   // User Logon Stats BEGIN
   // 
   print("<TR>\n");
   print("<TD ALIGN=LEFT colspan=3><font size=3><B>USER Signon (Login / Failure / Logout)</B></TD>\n");
   print("<TD ALIGN=LEFT>&nbsp;</TD>\n");
   print("</TR>\n");
   print("<TR>\n");
   print("<TD ALIGN=LEFT colspan=3>&nbsp;</TD>\n");
   print("<TD ALIGN=LEFT>&nbsp;</TD>\n");
   print("</TR>\n");

   $sql->query("select count(*) as num_action, userid, action  from $default->owl_log_table where type='LOGIN' group by userid, action");

   $iGrandLoginTotal = 0;
   $iGrandLogoutTotal = 0;
   $iGrandFailedTotal = 0;
   $SaveUser = -1;
   $iLoginTotal = 0;
   $iLogoutTotal = 0;
   $iFailedTotal = 0;

   while ($sql->next_record())
   {
      if ($SaveUser <> $sql->f("userid"))
      {
         if ($SaveUser <> -1)
         {
            print("($iLoginTotal / $iFailedTotal / $iLogoutTotal )");
            print("</TD>\n");
            print("</TR>\n");
            $iGrandLoginTotal = $iGrandLoginTotal + $iLoginTotal;
            $iGrandLogoutTotal = $iGrandLogoutTotal + $iLogoutTotal;
            $iGrandFailedTotal = $iGrandFailedTotal + $iFailedTotal;
            $iLoginTotal = 0;
            $iLogoutTotal = 0;
            $iFailedTotal = 0;
         } 
         $CountLines++;
         $PrintLines = $CountLines % 2;
         if ($PrintLines == 0)
         {
            print("\t\t\t\t<TR BGCOLOR='$default->table_cell_bg_alt'>\n");
         } 
         else
         {
            print("\t\t\t\t<TR BGCOLOR='$default->table_cell_bg'>\n");
         } 
         print("<TD ALIGN=LEFT colspan=3>" . uid_to_name($sql->f("userid")) . "</TD>\n");
         print("<TD ALIGN=LEFT>");
      } 

      switch ($sql->f("action"))
      {
         case LOGIN:
            $iLoginTotal = $sql->f("num_action");
            break;
         case LOGIN_FAILED:
            $iFailedTotal = $sql->f("num_action");
            break;
         case LOGOUT:
            $iLogoutTotal = $sql->f("num_action");
            break;
      } 
      $SaveUser = $sql->f("userid");
   } 

   $iGrandLoginTotal = $iGrandLoginTotal + $iLoginTotal;
   $iGrandLogoutTotal = $iGrandLogoutTotal + $iLogoutTotal;
   $iGrandFailedTotal = $iGrandFailedTotal + $iFailedTotal;

   print("($iLoginTotal / $iFailedTotal / $iLogoutTotal )");
   print("</TD>\n");
   print("</TR>\n");
   print("<TR>\n");
   print("<TD ALIGN=RIGHT colspan=3>$owl_lang->tot_files</TD>\n");
   print("<TD ALIGN=LEFT>($iGrandLoginTotal / $iGrandFailedTotal / $iGrandLogoutTotal)</TD>\n");
   print("</TR>\n"); 
   // 
   // User Logon Stats END
   // 
} 
// 
// Currently Logged In BEGIN
// 
print("<TR>\n");
print("<TD ALIGN=LEFT colspan=3><font size=3><B>Currently Logged In</B></font></TD>\n");
print("<TD ALIGN=LEFT>&nbsp;</TD>\n");
print("</TR>\n");
print("<TR>\n");
print("<TD ALIGN=LEFT colspan=3>&nbsp;</TD>\n");
print("<TD ALIGN=LEFT>&nbsp;</TD>\n");
print("</TR>\n");

$sql->query("select uid, lastused, ip  from $default->owl_sessions_table order by uid;");

$iGrandUserTotal = 0;
while ($sql->next_record())
{
   $CountLines++;
   $PrintLines = $CountLines % 2;
   if ($PrintLines == 0)
      print("\t\t\t\t<TR BGCOLOR='$default->table_cell_bg_alt'>\n");
   else
      print("\t\t\t\t<TR BGCOLOR='$default->table_cell_bg'>\n");

   print("<TD ALIGN=LEFT>" . uid_to_name($sql->f("uid")) . "</TD>\n");

   $time = time();
   if (($time - $sql->f("lastused")) <= $default->owl_timeout)
   {
      print("<TD ALIGN=LEFT>SESSION ACTIVE</TD>\n");
   } 
   else
   {
      print("<TD ALIGN=LEFT>SESSION EXPIRED</TD>\n");
   } 
   print("<TD ALIGN=LEFT>" . $sql->f("ip") . "</TD>\n");
   print("<TD ALIGN=LEFT>" . gethostbyaddr($sql->f('ip')) . "</TD>\n");
   $iGrandUserTotal = $iGrandUserTotal + 1;
   print("</TR>\n");
} 
print("<TR>\n");
print("<TD ALIGN=RIGHT colspan=3>$owl_lang->tot_files</TD>\n");
print("<TD ALIGN=LEFT>$iGrandUserTotal</TD>\n");
print("</TR>\n");
// 
// User Folder Stats END
// 
print("<TR>\n");
print("<TD ALIGN=LEFT colspan=3>&nbsp;</TD>\n");
print("<TD ALIGN=LEFT>&nbsp;</TD>\n");
print("</TR>\n");
print("<TR BGCOLOR='$default->table_header_bg' height='25'>");
print("<TD align=left colspan=3><font size=4>$owl_lang->file</font></TD>");
print("<TD align=left><font size=4>$owl_lang->tot_files</font></TD>");
print("</TR>");
print("<TR>\n");
print("<TD ALIGN=LEFT colspan=3>&nbsp;</TD>\n");
print("<TD ALIGN=LEFT>&nbsp;</TD>\n");
print("</TR>\n");
print("<TR>\n");
print("<TD ALIGN=LEFT colspan=3><font size=3><B>$owl_lang->stats_top</B></TD>\n");
print("<TD ALIGN=LEFT>&nbsp;</TD>\n");
print("</TR>\n");
print("<TR>\n");
print("<TD ALIGN=LEFT colspan=3>&nbsp;</TD>\n");
print("<TD ALIGN=LEFT>&nbsp;</TD>\n");
print("</TR>\n");

if ($default->logging && $default->log_file)
{
   $sGetAction = FILE_DOWNLOADED;
   $sql->query("select action, parent, filename, count(filename) as download_count from $default->owl_log_table where action = '$sGetAction' group by filename, action, parent order by download_count desc");

   $iTopCount = 0;
   while ($sql->next_record())
   {
      $CountLines++;
      $PrintLines = $CountLines % 2;
      if ($PrintLines == 0)
         print("\t\t\t\t<TR BGCOLOR='$default->table_cell_bg_alt'>\n");
      else
         print("\t\t\t\t<TR BGCOLOR='$default->table_cell_bg'>\n");

      print("<TD ALIGN=LEFT colspan=3>" . $sql->f("filename") . "</TD>\n");
      print("<TD ALIGN=LEFT>" . $sql->f("download_count") . "</TD>\n");
      print("</TR>\n");
      $iTopCount++;

      if ($iTopCount > 20)
         break;
   } 
} 
else
{
   print("<TR>\n");
   print("<TD ALIGN=LEFT colspan=3>$owl_lang->stats_information</TD>\n");
   print("<TD ALIGN=LEFT>&nbsp;</TD>\n");
   print("</TR>\n");
} 

print("</TABLE>\n");

if (owlusergroup($userid) == 0)
{
   print("<BR>");
   print("<BR>");
   fPrintButton("$default->owl_root_url/admin/index.php?sess=$sess", "btn_admin");
   print("<BR>");
   print("<BR>");
}
                                                                                                                                                                                                    
if (file_exists(_SYSCOMMONROOT . "/lib/footer.inc"))
{
   include(_SYSCOMMONROOT . "/lib/footer.inc");
}
else
{
   include(_SYSCOMMONROOT . "/lib/footer.inc");
}
?>
