<?php


/*
 * disp.lib.php
 *
 * Copyright (c) 1999-2003 The Owl Project Team
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 *
 * $Id: disp.lib.php,v 1.11 2003/11/12 14:26:03 b0zz Exp $
 */
function gethtmlprefs ( )
{
   global $default;

   $sql = new Owl_DB;
   $sql->query("select * from $default->owl_html_table");
   $sql->next_record();

   // styles sheet
   // this is an absolute URL and not a filesystem reference

   $default->styles                = _URLCOMMONROOT ."/lib/styles.css";
   $default->table_border          = $sql->f("table_border");
   $default->table_header_bg       = $sql->f("table_header_bg");
   $default->table_cell_bg         = $sql->f("table_cell_bg");
   $default->table_cell_bg_alt     = $sql->f("table_cell_bg_alt");
   $default->table_expand_width    = $sql->f("table_expand_width");
   $default->table_collapse_width  = $sql->f("table_collapse_width");
   $default->main_header_bgcolor   = $sql->f("main_header_bgcolor");
   $default->body_bgcolor          = $sql->f("body_bgcolor");
   $default->body_background       = $sql->f("body_background");
   $default->owl_logo              = $sql->f("owl_logo");
   $default->body_textcolor        = $sql->f("body_textcolor");
   $default->body_link             = $sql->f("body_link");
   $default->body_vlink            = $sql->f("body_vlink");
   $default->table_header_height   = 40;
};

function fPrintButton($sHref, $sBtn_name, $sequence = 0, $type = "ui_buttons")
{
   global $default, $language, $owl_lang;

   if ($language == "")
   {
      $language = $default->owl_lang;
   }

   $sAltstring = 'alt_' . $sBtn_name;
   if ($sequence > 0)
   {
      $sImageName = $sBtn_name . "_" . $sequence;
   }
   else
   {
      $sImageName = $sBtn_name;
   }
   print("<A HREF='$sHref' " . 'onMouseOut="MM_swapImgRestore()" onMouseOver="' . "MM_swapImage('$sImageName','','$default->owl_graphics_url/$language/graphics/$default->sButtonStyle/$type/" . $sBtn_name . "_hover.gif',1)" .'"' .">");
   print("<IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/$type/$sBtn_name.gif' ALT='" . $owl_lang->{$sAltstring} ."' TITLE='". $owl_lang->{$sAltstring} ."' BORDER=0 name='$sImageName'></A>\n");
}

function fPrintPrefs () {
        global $default, $language, $userid, $parent;
        global $sess, $expand, $sort, $sortorder, $order, $owl_lang;
      	print("<A HREF='prefs.php?owluser=$userid&sess=$sess&parent=$parent&expand=$expand&order=$order&sortname=$sort' TITLE='$owl_lang->title_edit_prefs'>");
      	print("&nbsp;<IMG SRC='$default->owl_graphics_url/$language/graphics/$default->sButtonStyle/ui_icons/user_prefs.gif' BORDER=0>");
      	print ("</A>&nbsp;");
      	print("$owl_lang->user: ");
      	print uid_to_name($userid);
}
function fDisplayPolicy ($parent)
{
   global $default;
   global $owl_lang;
   $sql = new Owl_DB; 

   $sql->query("select security from $default->owl_folders_table where id = '$parent'");
   $sql->next_record();

   switch ($sql->f("security"))
   {
      case "50":
         $sPolicy = "$owl_lang->geveryoneread";
         break;
      case "51":
         $sPolicy = "$owl_lang->geveryonewrite";
         break;
      case "52":
         $sPolicy = "$owl_lang->ggroupread";
         break;
      case "53":
         $sPolicy = "$owl_lang->ggroupwrite";
         break;
      case "54":
         $sPolicy = "$owl_lang->gonlyyou";
         break;
      case "55":
         $sPolicy = "$owl_lang->ggroupwrite_nod";
         break;
      case "56":
         $sPolicy = "$owl_lang->geveryonewrite_nod";
         break;
      case "57":
         $sPolicy = "$owl_lang->ggroupwrite_worldread";
         break;
      case "58":
         $sPolicy = "$owl_lang->ggroupwrite_worldread_nod";
         break;
      default:
         $sPolicy = "";
         break;
   }

return $sPolicy;
   
}
function gen_navbar($parent , $fileid = 0) {
        global $default;
        global $sess, $expand, $sort, $sortorder, $order, $owl_lang, $userid, $usergroupid;
        $name = fid_to_name($parent);
        $navbar = "&nbsp;<A HREF='browse.php?sess=$sess&parent=$parent&expand=$expand&order=$order&$sortorder=$sort' TITLE='$owl_lang->title_return_folder $name'>$name</A>";
        $new = $parent;
        while ($new != "1") {
                $sql = new Owl_DB; $sql->query("select parent from $default->owl_folders_table where id = '$new'");
                while($sql->next_record()) $newparentid = $sql->f("parent");
                $name = fid_to_name($newparentid);
                $navbar = "<A HREF='browse.php?sess=$sess&parent=$newparentid&expand=$expand&order=$order&$sortorder=$sort' TITLE='$owl_lang->title_return_folder $name'>$name</A>/" . $navbar;
                $new = $newparentid;
        }

        $iCurrentParent =  owlfolderparent($parent);
        if ( $fileid <> "0"  )
        {
           $navbar .= "/" . flid_to_name($fileid);
        }
        $navbar .= "<BR>&nbsp;&nbsp;&nbsp;&nbsp;$owl_lang->folder_policy &nbsp;";

        if (owlusergroup($userid) == 0 || $usergroupid == $default->file_admin_group)
        {
           $navbar .= "<a class='Status' href=modify.php?sess=$sess&action=folder_modify&id=$parent&parent=$iCurrentParent&expand=$expand&order=$order&$sortorder=$sort alt='$owl_lang->alt_mod_folder' title='$owl_lang->alt_mod_folder'>" . fDisplayPolicy($parent) . "</a>";
        }
        else
        {
           if (check_auth($parent, "folder_property", $userid) == 1 and $parent != 1)
           {
              $navbar .= "<a class='Status' href=modify.php?sess=$sess&action=folder_modify&id=$parent&parent=$iCurrentParent&expand=$expand&order=$order&$sortorder=$sort alt='$owl_lang->alt_mod_folder' title='$owl_lang->alt_mod_folder'>" . fDisplayPolicy($parent) . "</a>";
           }
           else
           {
              $navbar .= "<font class='Status'>" . fDisplayPolicy($parent) . "</font>";
           }
        }

        return $navbar;
}

//
// functions to create/show the links to be sorted on
//
function show_link($column,$sortname,$sortvalue,$order,$sess,$expand,$parent,$title) {
     global $default, $type, $owl_lang;

     $self = $_SERVER["PHP_SELF"]; 
     if ($sortvalue == "ASC")
     {
          print("\t\t\t\t<TD align=left><A CLASS='Text' HREF='$self?sess=$sess&expand=$expand&parent=$parent&order=$column&$sortname=DESC&type=$type' STYLE='toplink' TITLE='$owl_lang->title_sort'>$title");
          if ($order == $column)
          {
               print("</A>&nbsp;<img border='0' src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_nav/asc.gif'></TD>");
          }
          else
          {
               print("</A></TD>\n");
          }
     }
     else
     {
          print("\t\t\t\t<TD align=left><A CLASS='Text' HREF='$self?sess=$sess&expand=$expand&parent=$parent&order=$column&$sortname=ASC&type=$type' STYLE='toplink' TITLE='$owl_lang->title_sort'>$title");
          if ($order == $column)
          {
               print("</A>&nbsp;<img border='0' src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_nav/desc.gif'></TD>");
          }
          else
          {
               print("</A></TD>\n");
          }
     }
}


function printFileIcons ($fid, $filename, $checked_out, $url, $allicons, $ext, $backup_parent, $is_backup_folder = false)
{
   global $default;
   global $sess, $expand, $order, $sortorder ,$sortname, $userid;
   global $owl_lang;

   $self = $_SERVER["PHP_SELF"];
   $isBackup = fid_to_name($backup_parent);
   // check to see if the file is checked out
   // to display a the lock or unlock Icon.

   $checklocked = new Owl_DB;
   $checklocked->query("SELECT checked_out FROM $default->owl_files_table where id = '$fid'");
   $checklocked->next_record();
   $iCheckedOut = $checklocked->f("checked_out");

   //$bFileModify =   check_auth($fid, "file_modify", $userid);
   //$bFileDownload = check_auth($fid, "file_download", $userid);
   //$bFileDelete	= check_auth($fid, "file_delete", $userid);

   $aFileAccess	= check_auth($fid, "file_all", $userid);
   //print("OLD: M = $bFileModify DL: $bFileDownload DEL: $bFileDelete <BR>");
   //print("NEW: M =" .$aFileAccess["file_modify"] . " DL: " . $aFileAccess["file_download"] . " DEL:" . $aFileAccess["file_delete"]." <BR>");
   $bFileModify 	= $aFileAccess["file_modify"];
   $bFileDownload 	= $aFileAccess["file_download"];
   $bFileDelete	= $aFileAccess["file_delete"];


   print("&nbsp;&nbsp;");
   if ($allicons == 1)
   {
      if ($url == "0") 
      {
         $filename = ereg_replace("\&","<amp>", $filename);
         print("<a href='log.php?sess=$sess&id=".$fid."&filename=".$filename."&parent=$backup_parent&expand=$expand&order=$order&sortname=$sortname'><IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/icon_action/log.gif' BORDER=0 ALT='$owl_lang->alt_log_file' TITLE='$owl_lang->alt_log_file'></a><img src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/x_clear.gif' height=1 width=4>");
      } 
      else 
      {
         print("<IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/16x16.gif' BORDER=0><img src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/x_clear.gif' height=1 width=4>");
      }
   }


     	if (($checked_out == 0) || ($checked_out == $userid) || owlusergroup($userid) == 0 || $usergroupid == $default->file_admin_group) {
       		// *****************************************************************************
    		// Don't Show the delete icon if the user doesn't have delete access to the file
    		// *****************************************************************************

    		if($bFileDelete == 1)
        		if ($url == "1")
                        {
            		   print("<A HREF='dbmodify.php?sess=$sess&action=file_delete&type=url&id=".$fid."&parent=$backup_parent&expand=$expand&order=$order&sortname=$sortname'\tonClick='return confirm(\"$owl_lang->reallydelete ".$filename."?\");'><IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/icon_action/trash.gif' ALT='$owl_lang->alt_del_file' TITLE='$owl_lang->alt_del_file'\tBORDER=0></A><img src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/x_clear.gif' height=1 width=4>");
                        }
    			else
                        {
            		   print("<A HREF='dbmodify.php?sess=$sess&action=file_delete&id=".$fid."&parent=$backup_parent&expand=$expand&order=$order&sortname=$sortname'\tonClick='return confirm(\"$owl_lang->reallydelete ".$filename."?\");'><IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/icon_action/trash.gif' ALT='$owl_lang->alt_del_file' TITLE='$owl_lang->alt_del_file'\tBORDER=0></A><img src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/x_clear.gif' height=1 width=4>");
                        }

		// *****************************************************************************
    		// Don't Show the modify icon if the user doesn't have modify access to the file
    		// *****************************************************************************

    		if($bFileModify == 1 && !$is_backup_folder) 
                {
            	   print("<A HREF='modify.php?sess=$sess&action=file_modify&id=".$fid."&parent=$backup_parent&expand=$expand&order=$order&sortname=$sortname'><IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/icon_action/edit.gif' BORDER=0 ALT='$owl_lang->alt_mod_file' TITLE='$owl_lang->alt_mod_file'></A><img src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/x_clear.gif' height=1 width=4>");
		}

    		// *****************************************************************************
    		// Don't Show the move modify icon if the user doesn't have move access to the file
    		// *****************************************************************************
		
    		if($bFileModify == 1 && !$is_backup_folder)
			if (($default->hide_backup == 1 && $self != $default->owl_root_url . "/log.php")  || $isBackup != "backup" || $default->hide_backup != 1)
            		if ($url == "1")
                        {
                    	   print("<A HREF='move.php?sess=$sess&id=".$fid."&parent=$backup_parent&expand=$expand&action=file&type=url&order=$order&sortname=$sortname'><IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/icon_action/move.gif' BORDER=0 ALT='$owl_lang->alt_move_file' TITLE='$owl_lang->alt_move_file'></A>");
                        }
            		else
                        {
                    	   print("<A HREF='move.php?sess=$sess&id=".$fid."&parent=$backup_parent&expand=$expand&action=file&order=$order&sortname=$sortname'><IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/icon_action/move.gif' BORDER=0 ALT='$owl_lang->alt_move_file' TITLE='$owl_lang->alt_move_file'></A><img src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/x_clear.gif' height=1 width=4>");
                        }
		// *****************************************************************************
    		// Don't Show the file update icon if the user doesn't have update access to the file
    		// *****************************************************************************
    		if($bFileModify == 1 && !$is_backup_folder)
			if (($default->hide_backup == 1 && $self != $default->owl_root_url . "/log.php")  || $isBackup != "backup" || $default->hide_backup != 1)
            		   if ($url != "1")
                           {
                    	      print("<A HREF='$default->owl_root_url/modify.php?sess=$sess&expand=$expand&action=file_update&order=$order&sortname=$sortname&id=".$fid."&parent=".$backup_parent."'><IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/icon_action/update.gif' BORDER=0 ALT='$owl_lang->alt_upd_file' TITLE='$owl_lang->alt_upd_file'></A><img src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/x_clear.gif' height=1 width=4>");
                           }

    		// *****************************************************************************
    		// Don't Show the file dowload icon if the user doesn't have download access to the file
    		// *****************************************************************************

    		if($bFileDownload == 1)
            	   if ($url != "1")
                   {
                      print("<A HREF='$default->owl_root_url/download.php?sess=$sess&id=".$fid."&parent=".$backup_parent."&binary=1'><IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/icon_action/bin.gif' BORDER=0 ALT='$owl_lang->alt_get_file' TITLE='$owl_lang->alt_get_file'></A><img src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/x_clear.gif' height=1 width=4>");
                   }

    		// *****************************************************************************
    		// Don't Show the comment icon if the user doesn't have download access to the file
    		// *****************************************************************************


    		if($bFileDownload == 1 && !$is_backup_folder) {
	 		$sql = new Owl_DB;
                        $sql->query("SELECT * from $default->owl_comment_table where fid = '$fid'");
            		if ($url == "1") 
                        {
				print("<IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/16x16.gif' BORDER=0><img src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/x_clear.gif' height=1 width=4>");
				print("<IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/16x16.gif' BORDER=0><img src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/x_clear.gif' height=1 width=4>");
			}
				
				if($sql->num_rows() == 0) 
                                {
                    		   print("<A HREF='$default->owl_root_url/modify.php?sess=$sess&expand=$expand&action=file_comment&order=$order&sortname=$sortname&id=".$fid."&parent=".$backup_parent."'><IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/icon_action/comment_dis.gif' BORDER=0 ALT='$owl_lang->alt_add_comments' TITLE='$owl_lang->alt_add_comments'></A><img src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/x_clear.gif' height=1 width=4>");
				} 
                                else 
                                {
                    		print("<A HREF='$default->owl_root_url/modify.php?sess=$sess&expand=$expand&action=file_comment&order=$order&sortname=$sortname&id=".$fid."&parent=".$backup_parent."'><IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/icon_action/comment.gif' BORDER=0 ALT='$owl_lang->alt_view_comments' TITLE='$owl_lang->alt_view_comments'></A><img src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/x_clear.gif' height=1 width=4>");
				}
		}

		if ($allicons == 1)
		{
    			// *****************************************************************************
    			// Don't Show the lock icon if the user doesn't have access to the file
    			// *****************************************************************************
    			if($bFileModify == 1 && !$is_backup_folder)
            			if ($url != "1")
					if ($iCheckedOut <> 0) 
                                        {
                    			   print("<A HREF='dbmodify.php?sess=$sess&action=file_lock&id=".$fid."&parent=$backup_parent&expand=$expand&order=$order&sortname=$sortname'><IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/icon_action/unlock.gif' BORDER=0 ALT='$owl_lang->alt_unlock_file' TITLE='$owl_lang->alt_unlock_file'></a><img src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/x_clear.gif' height=1 width=4>");
					} 
                                        else 
                                        {	
                    			   print("<A HREF='dbmodify.php?sess=$sess&action=file_lock&id=".$fid."&parent=$backup_parent&expand=$expand&order=$order&sortname=$sortname'><IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/icon_action/lock.gif' BORDER=0 ALT='$owl_lang->alt_lock_file' TITLE='$owl_lang->alt_lock_file'></a><img src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/x_clear.gif' height=1 width=4>");
					}
			}

    		// *****************************************************************************
    		// Don't Show the email icon if the user doesn't have access to email the file
    		// *****************************************************************************

    		if($bFileDownload == 1 && !$is_backup_folder)
            		if ($url == "1") 
                        {
			   if ($default->owl_version_control == 1) 
                           {
			      print("<IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/16x16.gif' BORDER=0><img src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/x_clear.gif' height=1 width=4>");
			   }
                    	   print("<A HREF='$default->owl_root_url/modify.php?sess=$sess&expand=$expand&action=file_email&type=url&order=$order&sortname=$sortname&id=".$fid."&parent=".$backup_parent."'><IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/icon_action/email.gif' BORDER=0 ALT='$owl_lang->alt_email' TITLE='$owl_lang->alt_email'></A><img src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/x_clear.gif' height=1 width=4>");
			} 
                        else 
                        {
                    	   print("<A HREF='$default->owl_root_url/modify.php?sess=$sess&expand=$expand&action=file_email&order=$order&sortname=$sortname&id=".$fid."&parent=".$backup_parent."'><IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/icon_action/email.gif' BORDER=0 ALT='$owl_lang->alt_email' TITLE='$owl_lang->alt_email'></A><img src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/x_clear.gif' height=1 width=4>");
			}
	
    		// *****************************************************************************
    		// Don't Show the toggle monitor this file  icon if the user doesn't have access 
    		// *****************************************************************************

    		if($bFileDownload == 1)
            		if ($url != "1") {
				$sql = new Owl_DB;
				$sql->query("SELECT * from $default->owl_users_table where id = '$userid'");
				$sql->next_record();
				if (trim($sql->f("email")) != "") {
		                	$sql->query("select * from $default->owl_monitored_file_table where fid = '$fid' and userid = '$userid'");

                			if($sql->num_rows($sql) == 0) 
                                        {
                    			   print("<A HREF='$default->owl_root_url/dbmodify.php?sess=$sess&expand=$expand&action=file_monitor&order=$order&sortname=$sortname&id=".$fid."&parent=".$backup_parent."'><IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/icon_action/monitor.gif' BORDER=0 ALT='$owl_lang->alt_monitor' TITLE='$owl_lang->alt_monitor'></A><img src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/x_clear.gif' height=1 width=4>");
					}  
                                        else 
                                        {
                    			  print("<A HREF='$default->owl_root_url/dbmodify.php?sess=$sess&expand=$expand&action=file_monitor&order=$order&sortname=$sortname&id=".$fid."&parent=".$backup_parent."'><IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/icon_action/monitored.gif' BORDER=0 ALT='$owl_lang->alt_monitored' TITLE='$owl_lang->alt_monitored'></A><img src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/x_clear.gif' height=1 width=4>");
					}
				}
			}

		// *****************************************************************************
		// Don't Show the view icon if the user doesn't have download access to the file
		// *****************************************************************************
		
		 if($bFileDownload == 1)
    			if ($url != "1") {
            			$imgfiles = array("jpg","gif");
            			if ($ext != "" && preg_grep("/$ext/", $imgfiles)) 
                                {
                    		   print("<A HREF='view.php?sess=$sess&id=".$fid."&parent=$backup_parent&action=image_preview&expand=$expand&order=$order&sortname=$sortname'><IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/icon_action/mag.gif' BORDER=0 ALT='$owl_lang->alt_view_file' TITLE='$owl_lang->alt_view_file'></A><img src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/x_clear.gif' height=1 width=4>");
            			}
            			$htmlfiles = array("html","htm","xml");
            			if ($ext != "" && preg_grep("/$ext/", $htmlfiles)) 
                                {
				   print("<A HREF='view.php?sess=$sess&id=".$fid."&parent=$backup_parent&action=html_show&expand=$expand&order=$order&sortname=$sortname'><IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/icon_action/mag.gif' BORDER=0 ALT='$owl_lang->alt_view_file' TITLE='$owl_lang->alt_view_file'></A><img src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/x_clear.gif' height=1 width=4>");
            			}
            			if ($ext != "" && $ext == "pod") 
                                {
				   print("<A HREF='view.php?sess=$sess&id=".$fid."&parent=$backup_parent&action=pod_show&expand=$expand&order=$order&sortname=$sortname'><IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/icon_action/mag.gif' BORDER=0 ALT='$owl_lang->alt_view_file' TITLE='$owl_lang->alt_view_file'></A><img src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/x_clear.gif' height=1 width=4>");
            			}
            			$txtfiles = array("txt","text","README", "readme", "sh", "c", "cpp", "php", "php3", "pl", "perl", "sql", "py");
            			if ($ext != "" && preg_grep("/$ext/", $txtfiles)) {
					if(owlfiletype($fid) == 2) 
					{
					   print("<A HREF='view.php?sess=$sess&id=".$fid."&parent=$backup_parent&action=note_show&expand=$expand&order=$order&sortname=$sortname'><IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/icon_action/mag.gif' BORDER=0 ALT='$owl_lang->alt_view_file' TITLE='$owl_lang->alt_view_file'></A><img src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/x_clear.gif' height=1 width=4>");
					}
					else
					{
					   print("<A HREF='view.php?sess=$sess&id=".$fid."&parent=$backup_parent&action=text_show&expand=$expand&order=$order&sortname=$sortname'><IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/icon_action/mag.gif' BORDER=0 ALT='$owl_lang->alt_view_file' TITLE='$owl_lang->alt_view_file'></A><img src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/x_clear.gif' height=1 width=4>");
					}
            			}
				// BEGIN what I added to show PDF, DOC, and TXT special view
				$pdffiles = array("pdf");
				if ($ext != "" && preg_grep("/$ext/", $pdffiles)) 
                                {
				   print("<A HREF='view.php?sess=$sess&id=".$fid."&parent=$backup_parent&action=pdf_show&expand=$expand&order=$order&sortname=$sortname'><IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/icon_action/mag.gif' BORDER=0 ALT='$owl_lang->alt_view_file' TITLE='$owl_lang->alt_view_file'></A><img src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/x_clear.gif' height=1 width=4>");
				}
				$mswordfiles = array("doc");
				if ($ext != "" && preg_grep("/$ext/", $mswordfiles)) 
                                {
				   print("<A HREF='view.php?sess=$sess&id=".$fid."&parent=$backup_parent&action=doc_show&expand=$expand&order=$order&sortname=$sortname'><IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/icon_action/mag.gif' BORDER=0 ALT='$owl_lang->alt_view_file' TITLE='$owl_lang->alt_view_file'></A><img src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/x_clear.gif' height=1 width=4>");
				}
				$msexcelfiles = array("xls");
				if ($ext != "" && preg_grep("/$ext/", $msexcelfiles)) 
                                {
				   print("<A HREF='view.php?sess=$sess&id=".$fid."&parent=$backup_parent&action=xls_show&expand=$expand&order=$order&sortname=$sortname'><IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/icon_action/mag.gif' BORDER=0 ALT='$owl_lang->alt_view_file' TITLE='$owl_lang->alt_view_file'></A><img src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/x_clear.gif' height=1 width=4>");
				}
				$audiofiles = array("mp3");
				if ($ext != "" && preg_grep("/$ext/", $audiofiles)) 
                                {
				   print("<A HREF='view.php?sess=$sess&id=".$fid."&parent=$backup_parent&action=mp3_play&expand=$expand&order=$order&sortname=$sortname'><IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/icon_action/play.gif' BORDER=0 ALT='$owl_lang->alt_play_file' TITLE='$owl_lang->alt_play_file'></A><img src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/x_clear.gif' height=1 width=4>");
				}
				$pptfiles = array("ppt");
				if ($ext != "" && preg_grep("/$ext/", $pptfiles)) 
                                {
				   print("<A HREF='view.php?sess=$sess&id=".$fid."&parent=$backup_parent&action=ppt_show&expand=$expand&order=$order&sortname=$sortname'><IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/icon_action/mag.gif' BORDER=0 ALT='$owl_lang->alt_view_file' TITLE='$owl_lang->alt_view_file'></A><img src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/x_clear.gif' height=1 width=4>");
				}
                    		$zipfiles = array("tar.gz", "tgz", "tar", "gz", "zip");
				$bPrintZipView = false;
                    		if ($ext != "" && preg_grep("/$ext/", $zipfiles)) {
					if ($ext == "zip" && file_exists($default->unzip_path) && trim($default->unzip_path) != "") {
						$bPrintZipView = true;
					}
					if ($ext == "gz" && file_exists($default->gzip_path) && trim($default->gzip_path) != "") {
						$bPrintZipView = true;
					}
					if (($ext == "tar" || $ext == "tar.gz" || $ext == "tgz") && file_exists($default->tar_path) && trim($default->tar_path) != "") {
						if (substr(php_uname(), 0, 7) != "Windows") {
							$bPrintZipView = true;
						}
					}
					if ( $bPrintZipView ) 
                                        {
					    print("<A HREF='view.php?sess=$sess&id=".$fid."&parent=$backup_parent&action=zip_preview&filext=$ext&expand=$expand&order=$order&sortname=$sortname'><IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/icon_action/mag.gif' BORDER=0 ALT='$owl_lang->alt_view_file' TITLE='$owl_lang->alt_view_file'></A><img src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_misc/x_clear.gif' height=1 width=4>");
					}
				}
    			} 
	}
}

function displayBrowsePage($parent) 
{
   global $sess, $expand, $order, $sortorder, $sortname, $parent;
   // If we are hidding the backup directory
   // then change the directory to return to
   // the parent of this backup  directory
   	
   if(fid_to_name($parent) == "backup" && $default->hide_backup == 1) 
   {
      $sql->query("select parent from $default->owl_folders_table where id = $parent");
      $sql->next_record();
      $parent = $sql->f("parent");
   }
   header("Location: browse.php?sess=$sess&parent=$parent&expand=$expand&order=$order&$sortorder=$sortname");
}

function fGetStatusBarCount() 
{
   global $iUpdatedFileCount, $iNewFileCount, $iMyFileCount, $iTotalFileCount, $iQuotaCurrent, $iQuotaMax, $iNewsCount, $iFolderCount, $iFileCount;
   global $default, $owl_lang, $sess, $expand, $userid, $lastlogin, $parent, $usergroupid, $userid;

   $iUpdatedFileCount = 0;
   $iNewFileCount = 0;
   $iMyFileCount = 0;
   $iTotalFileCount = 0;
   $iQuotaCurrent = 0;
   $iQuotaMax = 0;
   $iNewsCount = 0;
   $iFolderCount = 0;
   
   $sql = new Owl_DB;

   // ******* Get Total Number of Folders To be displayed in Current Folder ********

   $sql->query("SELECT id from $default->owl_folders_table where parent = '$parent'");
   if ($default->restrict_view == 1)
   {
      while($sql->next_record()) 
      {
         if (check_auth($sql->f("id"), "folder_view", $userid))
         {
            $iFolderCount++;
         } 
      }
   }
   else
   {
      $iFolderCount = $sql->num_rows();
   }

   // ******* Get Total Number of Files in Current Folder ********
   $sql->query("SELECT id from $default->owl_files_table where parent = '$parent'");
   if ($default->restrict_view == 1)
   {
      while($sql->next_record()) 
      {
         if (check_auth($sql->f("id"), "file_download", $userid))
         {
            $iFileCount++;
         } 
      }
   }
   else
   {
      $iFileCount = $sql->num_rows();
   }


	
   // ******* Get Count of Updated Files ********
   $sql->query("SELECT id FROM $default->owl_files_table where smodified > '$lastlogin' and created < '$lastlogin'");
   while($sql->next_record()) 
   {
      if(check_auth($sql->f("id"), "file_download", $userid) == 1) 
      {
         $iUpdatedFileCount++;
      }
   }

   // ******* Get Count of New Files ********

   $sql->query("SELECT id, parent FROM $default->owl_files_table where created > '$lastlogin'");
   while($sql->next_record()) 
   {
      if(check_auth($sql->f("id"), "file_download", $userid) == 1) 
      {
         $sDirectoryPath = get_dirpath($sql->f("parent"));
         $pos = strpos($sDirectoryPath, "backup");
         if (!(is_integer($pos) && $pos)) 
         {
            $iNewFileCount++;
         }
      }
   }

   // ******* Get Count of That users Files ********

   $sql->query("SELECT id FROM $default->owl_files_table where creatorid = '$userid'");
   $iMyFileCount = $sql->num_rows();

   // ******* Get Count of All Files ********

   $sql->query("SELECT id FROM $default->owl_files_table");
   $iTotalFileCount = $sql->num_rows();

   // ******* Get Count of All Files ********

   $sql->query("SELECT * from $default->owl_users_table where id = '$userid'");
   $sql->next_record();
   $iQuotaCurrent = $sql->f("quota_current");
   $iQuotaMax = $sql->f("quota_max");
	
   $iPercent = $iQuotaCurrent ;

   // ******* Get Count of New News ********

   $iLastNews = $sql->f("lastnews");
   if (!isset($iLastNews))
   {
       $iLastNews = 0;
   }

   $sqlmemgroup = new Owl_DB;
   $sqlmemgroup->query("select * from $default->owl_users_grpmem_table where userid = '" . $userid . "'");
   $sGroupsWhereClause = "( gid = '-1' OR gid = '$usergroupid'";

   while($sqlmemgroup->next_record())
   {
      $sGroupsWhereClause .= " OR gid = '" . $sqlmemgroup->f("groupid") . "'";
   }
   $sGroupsWhereClause .= ")";

   $sql->query("SELECT * from $default->owl_news_table where $sGroupsWhereClause and id > '$iLastNews'  and news_end_date >= now()");
   $iNewsCount = $sql->num_rows();

}

function fPrintStatusBar ($nextfolders = 0, $nextfiles = 0, $bDisplayFiles, $iFileCount = 0, $iCurrentPage = 0) {

	global $iUpdatedFileCount, $iNewFileCount, $iMyFileCount, $iTotalFileCount, $iQuotaCurrent, $iQuotaMax, $iNewsCount;
	global $default, $owl_lang, $sess, $expand, $userid, $lastlogin, $parent, $order, $sortname, $language, $sortorder;


	print("<INPUT TYPE=HIDDEN NAME=sess VALUE='$sess'>\n");
	print("<INPUT TYPE=HIDDEN NAME=parent VALUE='$parent'>\n");
	print("<INPUT TYPE=HIDDEN NAME=expand VALUE='$expand'>\n");
	print("<INPUT TYPE=HIDDEN NAME=order VALUE='$order'>\n");
	print("<INPUT TYPE=HIDDEN NAME=sortname VALUE='$sortname'>\n");
	print("<INPUT TYPE=HIDDEN NAME=sortorder VALUE='$sortorder'>\n");
	if ($expand == 1) {
		print("<table border='0' cellpadding='0' cellspacing='0'  BGCOLOR='" . $default->main_header_bgcolor ."' width='" . $default->table_expand_width ."'>\n");
	} else {
		print("<table border='0' cellpadding='0' cellspacing='0'  BGCOLOR='" . $default->main_header_bgcolor ."' width='" . $default->table_collapse_width ."'>\n");
	}
	print("<tr>\n");
	// Toggle Check box column
	print("<td width='2%' rowspan=2 align=center>\n");
	if ($default->hide_bulk == 0 ) {
  		if ($sess != "0" || ( $sess == "0" && $default->anon_ro == 0 )) {
			print("<a href='#' onClick='CheckAll();'><IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_icons/tg_check.gif' ALT='$owl_lang->alt_toggle_check_box' TITLE='$owl_lang->alt_toggle_check_box' BORDER=0></a>\n");
		}
	} else {
		print("&nbsp;");
	}
	print("</td>\n");
	// Total column column
	print("<td>&nbsp;</td>\n");
	// Button Column 
	print("<td align='left' nowrap rowspan=2>\n");
	if ($default->hide_bulk == 0 ) {
  		if ($sess != "0" || ( $sess == "0" && $default->anon_ro == 0 )) {
			print("<INPUT TYPE=IMAGE  NAME=bmoveaction SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_buttons/btn_bulk_move.gif' BORDER=0 ALT='$owl_lang->alt_move_selected' TITLE='$owl_lang->alt_move_selected' VALUE='$owl_lang->move_selected' onMouseOver=this.src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_buttons/btn_bulk_move_hover.gif'; onMouseOut=this.src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_buttons/btn_bulk_move.gif';>\n");

			print("<INPUT TYPE=IMAGE  NAME=bemailaction SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_buttons/btn_bulk_email.gif' BORDER=0 ALT='$owl_lang->alt_email_selected' TITLE='$owl_lang->alt_email_selected' VALUE='$owl_lang->email_selected' onMouseOver=this.src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_buttons/btn_bulk_email_hover.gif'; onMouseOut=this.src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_buttons/btn_bulk_email.gif';>\n");
			print("<INPUT TYPE=IMAGE NAME=bdeleteaction onClick='return confirm(\"$owl_lang->reallydelete_selected ?\");' SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_buttons/btn_bulk_del.gif' BORDER=0 ALT='$owl_lang->alt_del_selected' TITLE='$owl_lang->alt_del_selected' VALUE='$owl_lang->del_selected' onMouseOver=this.src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_buttons/btn_bulk_del_hover.gif'; onMouseOut=this.src='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_buttons/btn_bulk_del.gif';>\n");
		}
	} else {
		print("&nbsp;");
	}
	print("</td>\n");
	// Date Column 
	print("</td>&nbsp;</td>\n");
	print("</tr>\n");

	print("<TR height=20 valign=bottom>\n");

	// Total column column
	if($default->anon_user == $userid) {
		print("<TD align='left' width='250'>&nbsp;");
	} else {
		print("<TD align='left'>");
		print("<B><font size=2><IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_icons/new.gif' BORDER=0>&nbsp;<A CLASS='Text' HREF='showrecords.php?sess=$sess&type=n' TITLE='$owl_lang->title_view_new'>$owl_lang->tot_new_files</A> <font class='Status'>$iNewFileCount</font></font>&nbsp;&nbsp;");
		print("<font size=2><IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_icons/updated.gif' BORDER=0>&nbsp;<A CLASS='Text' HREF='showrecords.php?sess=$sess&type=u' TITLE='$owl_lang->title_view_updated'>$owl_lang->tot_updated_files</A> <font  class='Status'>$iUpdatedFileCount</font></font>&nbsp;&nbsp;");
		print("<font size=2><A CLASS='Text' HREF='showrecords.php?sess=$sess&type=m' TITLE='$owl_lang->title_view_my'>$owl_lang->tot_my_files</A>     <font  class='Status'>$iMyFileCount</font></font>&nbsp;&nbsp;");
		print("<font size=2>$owl_lang->tot_files         <font  class='Status'>$iTotalFileCount</font></font>");
	
		if($iNewsCount > 0) {
			print("<font size=2>");
			if($default->allow_popup ) 
                        {
       print("&nbsp;&nbsp;<IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_icons/news.gif' BORDER=0 ALT='$owl_lang->alt_have_news' TITLE='$owl_lang->alt_have_news'>&nbsp;<A CLASS='Text' HREF=" . '"#" onClick="' . "window.open('readnews.php?sess=$sess', 'NewsWindow', 'status=no,directories=no,scrollbars=yes,title=yes,menubar=no,resizable=yes,toolbar=no,location=no,width=400,height=480');" . '"' . " ALT='$owl_lang->alt_have_news' TITLE='$owl_lang->alt_have_news'" . '>' . "<font size=2>$owl_lang->news_hd:</a>&nbsp;<font  class='Status'>".$iNewsCount."</font></font></B>");
			} else {
        			print("&nbsp;&nbsp;<IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_icons/news.gif' BORDER=0 ALT='$owl_lang->alt_have_news' TITLE='$owl_lang->alt_have_news'>&nbsp;<A CLASS='Text' HREF='readnews.php?sess=$sess'><font size=2>$owl_lang->news_hd:</a><font  class='Status'>".$iNewsCount."</font></font></B>");
			}
		} else {
        		print("&nbsp;&nbsp;<IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_icons/news.gif' BORDER=0 ALT='$owl_lang->alt_have_no_news' TITLE='$owl_lang->alt_have_no_news'>");
			print("&nbsp;<a CLASS='Text' HREF='#' ALT='$owl_lang->alt_have_no_news' TITLE='$owl_lang->alt_have_no_news'><font size=2>$owl_lang->news_hd:</a>&nbsp;<font  class='Status'>".$iNewsCount."</font></font></B>");
		}
	}
	if($iQuotaMax <> 0) {
	        $iPercent = round(($iQuotaCurrent / $iQuotaMax), 1) * 100;
                if ($iPercent > 100)
                {
                   $iPercent = 100;
                }
		print("<B><font size=1>&nbsp;&nbsp;<IMG SRC='$default->owl_graphics_url/$default->owl_lang/graphics/$default->sButtonStyle/ui_icons/quota_$iPercent.gif' BORDER=0'>&nbsp;$owl_lang->disk_quota<font  class='Status'>(" .  gen_filesize($iQuotaCurrent) ." / ".  gen_filesize($iQuotaMax) .")</font></font>&nbsp;&nbsp;</B>");
	}
	
	print("</TD>\n");
	// Button Column 
	//print("<td>&nbsp;</td>");
	// Date Column 
        if ($default->records_per_page > 0)
        {
	   print("<td nowrap>\n");
           $iNumberOfPages = (int) $iFileCount / $default->records_per_page;
           if ($iCurrentPage != 0) 
           {
              print("<A HREF='browse.php?sess=$sess&prev=1&nextfolders=$nextfolders&nextfiles=$nextfiles&bDisplayFiles=$bDisplayFiles&iCurrentPage=$iCurrentPage&parent=$parent&expand=$expand&order=$order&$sortorder=$sortname'><IMG SRC='$default->owl_graphics_url/$language/graphics/$default->sButtonStyle/ui_nav/prev.gif' BORDER=0 ALT='$owl_lang->alt_log_prev' TITLE='$owl_lang->alt_log_prev'></A>&nbsp;");
           }
           $iNumberOfPages = (int) round($iNumberOfPages + 0.4999);
           if($iNumberOfPages > 1)
           {
 	      for ($c = 0; $c < $iNumberOfPages; $c++)
   	      {
		   $iPrintC = $c + 1;
        	   print("<A HREF='browse.php?sess=$sess&page=$c&bDisplayFiles=$bDisplayFiles&parent=$parent&expand=$expand&order=$order&$sortorder=$sortname' TITLE='$owl_lang->page $iPrintC'>$iPrintC</A>&nbsp;\n");
              }
           }
           if ($iCurrentPage < ($iNumberOfPages - 1)) 
           {
              print("<A HREF='browse.php?sess=$sess&next=1&nextfolders=$nextfolders&nextfiles=$nextfiles&bDisplayFiles=$bDisplayFiles&iCurrentPage=$iCurrentPage&parent=$parent&expand=$expand&order=$order&$sortorder=$sortname'><IMG SRC='$default->owl_graphics_url/$language/graphics/$default->sButtonStyle/ui_nav/next.gif' BORDER=0 ALT='$owl_lang->alt_log_next' TITLE='$owl_lang->alt_log_next'></A></td>\n");
           }
           $iCurrentPage++;
        }
	print("<TD align='right'<b><font size=1>$owl_lang->last_logged</font></b><B><font size=-1  class='Status'>" . date($owl_lang->localized_date_format , strtotime($lastlogin)) . "</font></B><BR>");
        if ($default->records_per_page > 0)
        {
           print("$owl_lang->page $iCurrentPage / $iNumberOfPages</TD>\n");
        }
        else
        {
           print("</TD>\n");
        }

	print("</tr>\n");
	print("</table>\n");
}
?>
