<?php

/**
 * view.php
 * 
 * Copyright (c) 1999-2003 The Owl Project Team
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 * 
 * $Id: readnews.php,v 1.3 2003/10/14 16:29:31 b0zz Exp $
 */

//require_once("./config/owl.php");
require_once(_SYSCOMMONROOT . "/lib/disp.lib.php");
require_once(_SYSCOMMONROOT . "/lib/owl.lib.php");
require_once(_SYSCOMMONROOT . "/lib/security.lib.php");

include_once(_SYSCOMMONROOT . "/lib/header.inc");
include_once(_SYSCOMMONROOT . "/lib/userheader.inc");

$iGroupId = owlusergroup($userid);

if ($default->anon_user == $userid)
{
   die("$owl_lang->err_unauthorized");
} 

$sql = new Owl_DB;

if (isset($start)) $iStartId = $start;
// 
// Create the where Clause for user Groups
// 
$sqlmemgroup = new Owl_DB;
$sqlmemgroup->query("select * from $default->owl_users_grpmem_table where userid = '" . $userid . "'");
$sGroupsWhereClause = "( gid = '-1' OR gid = '$iGroupId'";

while ($sqlmemgroup->next_record())
{
   $sGroupsWhereClause .= " OR gid = '" . $sqlmemgroup->f("groupid") . "'";
} 
$sGroupsWhereClause .= ")";
// print("W: $sGroupsWhereClause");
// exit;
// 
// Get the id of the last Viewed Article
// 
$sql->query("SELECT lastnews from $default->owl_users_table where id = '$userid'");
$sql->next_record();

if ($action == "")
{
   $Update = new Owl_DB;
   $iStartId = $sql->f("lastnews");
   if ($iStardId == "")
   {
      $iStartId = 0;
   }
   $bHidePrevious = true;
} 
// 
// Get the Next News Article for this user
// 
if ($action == "prev")
{
   $bHidePrevious = false;
   $iCurrentNewsId = $current - 1; 
   // 
   // If we go down one more is it the
   // first then we need to hid the
   // Prev button.
   // 
   $sql->query("SELECT * from $default->owl_news_table where $sGroupsWhereClause and id < '$iCurrentNewsId' and news_end_date >= now() order by id desc LIMIT 1");
   $sql->next_record();

   $iPreviousOne = $sql->f("id");
   if ($iPreviousOne <= $iStartId)
   {
      $bHidePrevious = true;
   } 
   if ($iCurrentNewsId <= $iStartId)
   {
      $iCurrentNewsId = $iStartId;
      $sql->query("SELECT * from $default->owl_news_table where $sGroupsWhereClause and id >= '$iStartId'  and news_end_date >= now() LIMIT 1");
   } 
   else
   {
      $sql->query("SELECT * from $default->owl_news_table where $sGroupsWhereClause and id <= '$iCurrentNewsId' and news_end_date >= now() order by id desc LIMIT 1");
   } 
   $sql->next_record();

   $iCurrentNewsId = $sql->f("id");
} 
else
{
   if ($action == "")
   {
      $sql->query("SELECT * from $default->owl_news_table where $sGroupsWhereClause and id > '$iStartId' and news_end_date >= now() LIMIT 1");
      $sql->next_record();
      $iStartId = $sql->f("id");
   } 
   else
   {
      $bHidePrevious = false;
      $iCurrentNewsId = $current;
      $sql->query("SELECT * from $default->owl_news_table where $sGroupsWhereClause and id > '$iCurrentNewsId' and news_end_date >= now() LIMIT 1");
      $sql->next_record();
   } 

   if ($sql->num_rows() == 0)
   {
      print('<script language="javascript">');
      print('window.close();');
      print('</script>');
   } 
   else
   {
      $iCurrentNewsId = $sql->f("id");
      $UpdateUser = new Owl_DB;
      $bLastNews = false;
      $UpdateUser->query("SELECT * from $default->owl_news_table where $sGroupsWhereClause and id > '$iCurrentNewsId' and news_end_date >= now() LIMIT 1");
      $UpdateUser->next_record();

      if ($UpdateUser->num_rows() == 0)
      {
         $bLastNews = true;
      } 

      $UpdateUser->query("UPDATE $default->owl_users_table set lastnews = '" . $iCurrentNewsId . "' where id = '$userid'");
   } 
} 
print("<table ALIGN='center' WIDTH='90%' CELLSPACING='2' CELLPADDING='2' BORDER='0' HEIGHT='100%'>");
print("<td align=left WIDTH='90%'>\n");
print("<h4>" . $sql->f("news_title") . "</h4>\n");
print("</td>\n");

?>
<td><a HREF="#" onClick="window.print(); return false");><img SRC="<?php print("$default->owl_graphics_url/$language/graphics/$default->sButtonStyle/icon_action/print.gif");
?>" BORDER='0' ALT='<?php print $owl_lang->alt_news_print ?>' TITLE='<?php print $owl_lang->alt_news_print ?>'></a></td>
<?php
if (!$bHidePrevious)
{

   ?>
	<td ALIGN='center' ><a HREF="readnews.php?sess=<?php print $sess;
   ?>&action=prev&start=<?php print $iStartId;
   ?>&current=<?php print $iCurrentNewsId;
   ?>" ><img SRC="<?php print("$default->owl_graphics_url/$language/graphics/$default->sButtonStyle/ui_nav/prev.gif");
   ?>" BORDER='0' ALT='<?php print $owl_lang->alt_news_prev ?>' TITLE='<?php print $owl_lang->alt_news_prev ?>'></a></td>
<?php
} 
else
{
   print("<td></td>");
} 

?>
<?php
if ($bLastNews)
{
   if ($default->allow_popup)
   {

      ?>
                <td ALIGN='center' ><a HREF="readnews.php?sess=<?php print $sess;
      ?>&action=next&start=<?php print $iStartId;
      ?>&start=<?php print $iStartId;
      ?>&current=<?php print $iCurrentNewsId;
      ?>" ><img SRC="<?php print("$default->owl_graphics_url/$language/graphics/$default->sButtonStyle/ui_nav/close.gif");
      ?>" BORDER='0' ALT='<?php print $owl_lang->alt_news_close ?>' TITLE='<?php print $owl_lang->alt_news_close ?>'></a></td>
<?php
   } 
   else
   {
      print("<TD ALIGN=CENTER><A HREF='browse.php?sess=$sess'><IMG SRC='$default->owl_graphics_url/$language/graphics/$default->sButtonStyle/ui_nav/close.gif' ALT='$owl_lang->alt_return' TITLE='$owl_lang->alt_return' BORDER=0></A> </TD>");
   } 
} 
else
{

   ?>
   <td ALIGN='center' ><a HREF="readnews.php?sess=
<?php print $sess; ?>
&action=next&start=
<?php print $iStartId; ?>
&start=
<?php print $iStartId; ?>
&current=
<?php print $iCurrentNewsId; ?>
"><img SRC="
<?php print("$default->owl_graphics_url/$language/graphics/$default->sButtonStyle/ui_nav/next.gif"); ?>
" BORDER='0' ALT='
<?php print $owl_lang->alt_news_next ?>
' TITLE='
<?php print $owl_lang->alt_news_next ?>'>
</a></td>
<?php
} 
?>
<td></td>
</tr>
<tr>
<td VALIGN="top" HEIGHT="90%" COLSPAN="5" align=left> <?php print(ereg_replace("\n", '<BR>', $sql->f("news")));
?></td>
</tr>
<?php
print("<tr><td colspan=5 align=left><BR>$owl_lang->news_posted_date  " . date($owl_lang->localized_date_format, strtotime($sql->f("news_date"))) . "</td><BR /><BR /></tr>");
print("<tr>\n");
if ($default->allow_popup)
{

   ?>
	<td ALIGN='center' >&nbsp;</td>
<?php
} 
else
{
   print("<TD ALIGN=CENTER><A HREF='browse.php?sess=$sess'><IMG SRC='$default->owl_graphics_url/$language/graphics/$default->sButtonStyle/ui_nav/close.gif' ALT='$owl_lang->alt_return' TITLE='$owl_lang->alt_return' BORDER=0></A> </TD>");
} 

?>
<td><a HREF="#" onClick="window.print(); return false");><img SRC="<?php print("$default->owl_graphics_url/$language/graphics/$default->sButtonStyle/icon_action/print.gif");
?>" BORDER='0' ALT='<?php print $owl_lang->alt_news_print ?>' TITLE='<?php print $owl_lang->alt_news_print ?>'></a></td>
<?php
if (!$bHidePrevious)
{

   ?>
	<td ALIGN='center' ><a HREF="readnews.php?sess=<?php print $sess;
   ?>&action=prev&start=<?php print $iStartId;
   ?>&current=<?php print $iCurrentNewsId;
   ?>" ><img SRC="<?php print("$default->owl_graphics_url/$language/graphics/$default->sButtonStyle/ui_nav/prev.gif");
   ?>" BORDER='0' ALT='<?php print $owl_lang->alt_news_prev ?>' TITLE='<?php print $owl_lang->alt_news_prev ?>'></a></td>
<?php
} 
else
{
   print("<td></td>");
} 

?>
<?php
if ($bLastNews)
{
   if ($default->allow_popup)
   {

      ?>
		<td ALIGN='center' ><a HREF="readnews.php?sess=<?php print $sess;
      ?>&action=next&start=<?php print $iStartId;
      ?>&start=<?php print $iStartId;
      ?>&current=<?php print $iCurrentNewsId;
      ?>" ><img SRC="<?php print("$default->owl_graphics_url/$language/graphics/$default->sButtonStyle/ui_nav/close.gif");
      ?>" BORDER='0' ALT='<?php print $owl_lang->alt_news_close ?>' TITLE='<?php print $owl_lang->alt_news_close ?>'></a></td>
<?php
   } 
   else
   {
      print("<TD ALIGN=CENTER><A HREF='browse.php?sess=$sess'><IMG SRC='$default->owl_graphics_url/$language/graphics/$default->sButtonStyle/ui_nav/close.gif' ALT='$owl_lang->alt_return' TITLE='$owl_lang->alt_return' BORDER=0></A> </TD>");
   } 
} 
else
{

   ?>
	<td ALIGN='center' ><a HREF="readnews.php?sess=<?php print $sess;
   ?>&action=next&start=<?php print $iStartId;
   ?>&start=<?php print $iStartId;
   ?>&current=<?php print $iCurrentNewsId;
   ?>" ><img SRC="<?php print("$default->owl_graphics_url/$language/graphics/$default->sButtonStyle/ui_nav/next.gif");
   ?>" BORDER='0' ALT='<?php print $owl_lang->alt_news_next ?>' TITLE='<?php print $owl_lang->alt_news_next ?>'></a></td>
<?php
} 
print("</tr>");

?>
</table>
</body>
</html>
